/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

#include "toppers/text.hpp"
#include "toppers/c_expr.hpp"
#include "toppers/itron/static_api.hpp"
#include <iostream>
#include <iomanip>
#include <iterator>
#include <string>
#include <boost/spirit/tree/parse_tree.hpp>
#include <boost/spirit/tree/ast.hpp>
#include <boost/spirit/tree/tree_to_xml.hpp>

using namespace std;
using namespace boost::spirit;
using namespace toppers;

struct test_expr : c_expr_grammar_base<test_expr>
{
  typedef c_expr_grammar_base<test_expr> base_t;

  template <class Scanner>
  struct definition : base_t::definition<Scanner>
  {
    definition( const test_expr& self ) : base_t::definition<Scanner>( self ) {}
    const rule_t& start() const { return constant_expression; };
  };

  explicit test_expr( bool ucn = false, codeset_t codeset = ascii ) : c_expr_grammar_base<test_expr>( ucn, codeset ) {}
};

typedef itron::static_api_grammar test_static_api;

int main()
{
#if 1
  c_const_expr_grammar cexpr_p( true, shift_jis );
  test_static_api api( cexpr_p );
  string str;
  
  while ( cout << "# ", getline( cin, str ) )
  {
    cout << str << endl;
    if ( str == "q" )
      break;
//    parse_info<string::const_iterator> info = parse( str.begin(), str.end(), api, space_p );
    tree_parse_info<const char*> pt_info = pt_parse( str.c_str(), api, space_p );
    cout << ( pt_info.full ? "okay" : "fail" ) << endl;
//    tree_to_xml( cout, pt_info.trees );

    itron::static_api test;
    bool result = test.analyze( pt_info.trees[0].children[0].children.begin(), pt_info.trees[0].children[0].children.end() );   
    cout << boolalpha << result << endl;
    for ( itron::static_api::const_iterator iter = test.begin(); iter != test.end(); ++iter )
    {
      cout << *iter << ' ';
    }
    cout << endl;
  }
#endif

#if 0
  test_expr expr( true, shift_jis );
  string str;
  
  while ( cout << "# ", getline( cin, str ) )
  {
    cout << str << endl;
    if ( str == "q" )
      break;
    parse_info<string::const_iterator> info = parse( str.begin(), str.end(), expr, space_p );
    cout << ( info.full ? "okay" : "fail" ) << endl;

    tree_parse_info<const char*> pt_info = ast_parse( str.c_str(), expr, space_p );
    tree_to_xml( cout, pt_info.trees );
  }
#endif

#if 0
  toppers::text t;
  t.assign( std::cin );
  for ( toppers::text::const_iterator iter = t.begin(); iter != t.end(); iter+=1 )
  {
    std::cout << "(" << iter.line().file_.string() << ", " << iter.line().line_ << ") " << *iter << std::endl;
  }
#endif

#if 0
  integer_parser<> parser;
  string str( "12345678" );
  cout << str << endl;
  parse_info<string::const_iterator> info = parse( str.begin(), str.end(), parser );
  cout << ( info.full ? "okay" : "fail" ) << endl;
//  cout << parser.value() << endl;
#endif

#if 0
  string str( "\"\x2f\25\u3124abc\\\"\\"" );
  cout << str << endl;
  parse_info<string::const_iterator> info = parse( str.begin(), str.end(), c_strlit_parser( shift_jis ) );
  cout << ( info.full ? "okay" : "fail" ) << endl;
#endif

#if 0
  ucn_parser parser;
  string str( "\\u1234");
  cout << str << endl;
  parse_info<string::const_iterator> info = parse( str.begin(), str.end(), parser, space_p );
  cout << ( info.full ? "okay" : "fail" ) << endl;
#endif

#if 0
  string str( "_abc\\u3526345" );
  cout << str << endl;
  parse_info<string::const_iterator> info = parse( str.begin(), str.end(), c_ident_p );
  cout << ( info.full ? "okay" : "fail" ) << endl;
#endif

  return 0;
}
