/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2004 by Witz Corporation, JAPAN  
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/cmdline.cpp
 */
#include "toppers/cmdline.hpp"
#include "toppers/reporter.hpp"
#include <algorithm>
#include <functional>
#include <sstream>
#include <list>
#include <utility>
#include <cctype>
#include <boost/utility.hpp>

namespace toppers
{

  /*!
   *  \brief  ftHgRXgN^
   */
  cmdline::option_array::option_array()
  {
  }

  /*!
   *  \brief  IvV̗L
   *  \param  key   IvV
   *  \return IvVtrueԂ
   */
  bool cmdline::option_array::find( const std::string& key ) const
  {
    map::const_iterator nil( map_.end() );
    if ( map_.find( key ) == nil )
    {
      char ch = *key.rbegin();
      if ( ch == ':' || ch == '=' )
      {
        return false;
      }
      else
      {
        if ( map_.find( key + ":" ) == nil )
        {
          if ( map_.find( key + "=" ) == nil )
          {
            return false;
          }
        }
      }
    }
    return true;
  }

  /*!
   *  \brief  IvV̗Lyш̎擾
   *  \param  key   IvV
   *  \param  arg   ̊i[
   *  \return IvVtrueԂ
   */
  bool cmdline::option_array::find( const std::string& key, std::string& arg ) const
  {
    map::const_iterator nil( map_.end() );
    map::const_iterator iter( map_.find( key ) );
    if ( iter == nil )
    {
      char ch = *key.rbegin();
      if ( ch == ':' || ch == '=' )
      {
        return false;
      }
      else
      {
        iter = map_.find( key + ":" );
        if ( iter == nil )
        {
          iter = map_.find( key + ":" );
          if ( iter == nil )
          {
            return false;
          }
        }
      }
    }
    arg = iter->second;
    return true;
  }

  /*!
   *  \brief  IvV̗Lyш̎擾iΉj
   *  \param  key   IvV
   *  \param  args  ̊i[
   *  \return IvVtrueԂ
   *
   *  ̊֐ł key Ŏw肳ꂽIvVw肳ꂽꍇɁAꂼ̈
   *  擾邽߂Ɏgp܂B
   */
  bool cmdline::option_array::find( const std::string& key, std::vector<std::string>& args ) const
  {
    std::pair<map::const_iterator, map::const_iterator> range( map_.equal_range( key ) );
    std::string opt_key( key );
    if ( range.first == range.second )
    {
      char ch = *key.rbegin();
      if ( ch == ':' || ch == '=' )
      {
        return false;
      }
      else
      {
        opt_key = key + ":";
        range = map_.equal_range( opt_key );
        if ( range.first == range.second )
        {
          opt_key = key + "=";
          range = map_.equal_range( key );
          if ( range.first == range.second )
          {
            return false;
          }
        }
      }
    }

    std::vector<std::string> t;
    for ( map::const_iterator iter( range.first ), last( range.second ); iter != last; ++iter )
    {
      if ( iter->first == opt_key )
      {
        t.push_back( iter->second );
      }
    }
    args.swap( t );
    return true;
  }

  /*!
   *  \brief  IvV̑}
   *  \param  key   IvV
   *  \param  value IvVij
   */
  void cmdline::option_array::insert( const std::string& key, const std::string& value )
  {
    map_.insert( map::value_type( key, value ) );
  }

  /*!
   *  \brief  IvV̒u
   *  \param  key   IvV
   *  \param  value u镶
   *  \return IvVtrueԂ
   */
  bool cmdline::option_array::replace( const std::string& key, const std::string& value )
  {
    map::iterator iter( map_.find( key ) );
    if ( iter == map_.end() )
    {
      return false;
    }
    iter->second = value;
    return true;
  }

  /*!
   *  \brief  R}hCIvṼL[ύX
   *  \param  old_key ύXÕL[
   *  \param  new_key ύX̃L[
   *
   *  ̊֐̓R}hCIvVƂēo^ꂽeʖœo^Ȃ܂B
   *  ʖ̓`̃IvV𓯂OɓꂷꍇɎgp܂B
   */
  void cmdline::option_array::remap_option( const std::string& old_key, const std::string& new_key )
  {
    map::iterator iter( map_.find( old_key ) );
    if ( iter != map_.end() )
    {
      map::value_type value( new_key, iter->second );
      map_.erase( iter );
      map_.insert( value );
    }
  }

  /*!
   *  \brief  IuWFNǧ
   *  \param  other   Ώۂ̃IuWFNg
   */
  void cmdline::option_array::swap( option_array& other ) throw()
  {
    map_.swap( other.map_ );
    set_.swap( other.set_ );
  }

  cmdline::option_array::option_array( const map& options, const set& optset )
    : map_( options ), set_( optset )
  {
  }


  /*!
   *  \brief  main֐̈󂯎RXgN^
   *  \param  argc  R}hČ
   *  \param  argv  R}hCi[z
   */
  cmdline::cmdline( int argc, char* argv[] ) : argc_( argc ), argv_( argv )
  {
  }

  /*!
   *  \brief  R}hC̉
   *  \param  pattern IvVƂĎ󂯓p^[
   *  \param  options ͌ʂ̊i[
   *  \return IvVȊÖ
   *
   *  patternɂ́A󂯓IvV󔒕ŋ؂ė񋓂܂B
   *  ̍ہAp[^󂯎IvV́A':'܂'='w肵ĂB
   *  ':'w肵ꍇAIvV̌ɂ̂܂܃p[^n܂B
   *  '='w肵ꍇAIvV̌'='Ńp[^w肵܂B
   *
   *  \code
   *  // example
   *  cmdline cmdl( argc, argv );
   *  option_array options;
   *  cmdl.parse( "-I: -v --source=", options );
   *  \endcode
   */
  std::auto_ptr<std::vector<std::string> > cmdline::parse( const std::string& pattern, option_array& options ) const
  {
    std::stringstream sstr( pattern );
    option_array::map optmap;
    option_array::set optset;
    std::list<const char*> args( argv_+1, argv_+argc_ );

    // `options'̏dvf܂Ƃ߂
    std::string name;
    while ( sstr >> name )
    {
      if ( name[0] == '-' ) // '-'Ŏn܂̈ȊO̓IvVƂĔF߂Ȃ
      {
        optset.insert( name );
      }
    }

    const std::set<std::string>::const_iterator last( optset.end() );
    for ( std::set<std::string>::const_iterator iter( optset.begin() ); iter != last; ++iter )
    {
      std::string name( *iter );
      bool has_arg = false;
      char back = *name.rbegin();
      if ( back == ':' ) // ':'ŏIIvV'='Ȃ̈
      {
        has_arg = true;
        name.erase( name.size()-1 ); // ':'
      }
      else if ( back == '=' ) // '='ŏIIvV'='ẗ
      {
        has_arg = true;
      }
      std::list<const char*>::iterator iter2( args.begin() );
      while ( iter2 != args.end() )
      {
        const char* argv = *iter2;
        if ( ( back == '=' && strncmp( argv, name.c_str(), name.size() ) == 0 )
          || ( back != '=' && strcmp( argv, name.c_str() ) == 0 ) )
        {
          typedef option_array::map::value_type option;
          if ( has_arg ) // tIvV
          {
            if ( argv[name.size()] != '\0' )
            {
              argv = argv+name.size();
            }
            else
            {
              std::list<const char*>::iterator next( boost::next( iter2 ) );
              if ( next != args.end() )
              {
                argv = *next;
              }
              else
              {
                // ̃G[bZ[W͖|󂳂ꂻɂȂAƂ肠u
                rout.error( _( "argument to `%1%\' is missing" ) % name );
              }
              args.erase( next );
            }
            while ( std::isspace( *argv ) ) // Ô߁A󔒗ޕ菜
                 ;
            if ( back == ':' )
            {
              name += ':';
            }
            option opt( name, std::string( argv ) );
            optmap.insert( opt );
          }
          else // ȂIvV
          {
            option opt( name, "" );
            optmap.insert( opt );
          }
          std::list<const char*>::iterator next = boost::next( iter2 );
          args.erase( iter2 );
          iter2 = next;
        }
        else // nameIvVȊO
        {
          ++iter2;
        }
      }
    }

    // OŜ std::auto_ptr pāAŕԋplgݗĂ
    std::auto_ptr<std::vector<std::string> > result( new std::vector<std::string>( args.begin(), args.end() ) );

    option_array t( optmap, optset );
    options.swap( t );

    return result;
  }

  /*!
   *  \brief  sIvV̒T
   *  \param  first IvV̐擪ʒu
   *  \param  last  IvV̏I[ʒu+1
   *  \return sIvVoꍇ͂̈ʒuAȊOlastԂB
   *  \note   sIvVoꍇAreporter::error Ăяo܂B
   */
  std::vector<std::string>::const_iterator cmdline::find_illegal_options( std::vector<std::string>::const_iterator first, std::vector<std::string>::const_iterator last )
  {
    for ( std::vector<std::string>::const_iterator iter( first ); iter != last; ++iter )
    {
      if ( iter->at( 0 ) == '-' )
      {
        rout.error( _( "illegal option `%1%\'" ) % *iter );
        return iter;
      }
    }
    return last;
  }

}
