/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2004 by Witz Corporation, JAPAN    
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/cmdline.hpp
 *  \brief  R}hC͂Ɋւ錾
 *
 *  ̃t@CŒ`NX
 *  \code
 *  class cmdline;
 *  class cmdline::option_array;
 *  \endcode
 */
#ifndef	TOPPERS_CMDLINE_HPP_
#define	TOPPERS_CMDLINE_HPP_

#include "toppers/config.hpp"
#include <memory>
#include <string>
#include <map>
#include <set>
#include <vector>
#include <boost/shared_ptr.hpp>

namespace toppers
{

  /*!
   *  \class cmdline cmdline.hpp "toppers/cmdline.hpp"
   *  \brief  R}hC̓NX
   */
  class cmdline
  {
  public:
    /*!
     *  \class  option_array cmdline.hpp "toppers/cmdline.hpp"
     *  \brief  R}hCIvVi[pRei
     */
    class option_array
    {
    public:
      typedef std::multimap<std::string, std::string> map;
      typedef std::set<std::string> set;

      option_array();
      bool find( const std::string& key ) const;
      bool find( const std::string& key, std::string& arg ) const;
      bool find( const std::string& key, std::vector<std::string>& args ) const;
      void insert( const std::string& key, const std::string& value ); 
      bool replace( const std::string& key, const std::string& value );
      void remap_option( const std::string& old_key, const std::string& new_key );
      void swap( option_array& other ) throw();
    private:
      option_array( const map& options, const set& optset );

      map map_;
      set set_;   // ݖgp
      friend class cmdline;
    };

    cmdline( int argc, char* argv[] );
    std::auto_ptr<std::vector<std::string> > parse( const std::string& pattern, option_array& options ) const;
    static std::vector<std::string>::const_iterator find_illegal_options( std::vector<std::string>::const_iterator first, std::vector<std::string>::const_iterator last );
  private:
    int argc_;
    char*const* argv_;
  };

}

#endif	// ! TOPPERS_CMDLINE_HPP_
