/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/debug.hpp
 *  \brief  fobOpCuɊւ錾`
 */
#ifndef TOPPERS_DEBUG_HPP_
#define TOPPERS_DEBUG_HPP_

#include "toppers/config.hpp"
#include <iostream>
#if defined( _WIN32 ) || defined( __WIN32__ ) || defined( WIN32 )
#include <windows.h>
#include <sstream>
#endif

namespace toppers
{

  template <typename T>
  void trace( const char* str, const T& value )
  {
#if defined( _WIN32 ) || defined( __WIN32__ ) || defined( WIN32 )
    std::ostringstream ostr;
    ostr << str << value << '\n';
    ::OutputDebugString( ostr.str().c_str() );
#else
    std::cerr << str << value << std::endl;
#endif
  }

}

#if defined( _DEBUG ) || defined( __DEBUG ) || defined( DEBUG )
#define TOPPERS_TRACE( str, value )   ::toppers::trace( ( str ), ( value ) )
#else
#define TOPPERS_TRACE( str, value )   ( ( void )0 )
#endif

#endif  // ! TOPPERS_DEBUG_HPP_
