/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/itron/cfg_contents.cpp
 */
#include "toppers/itron/cfg_contents.hpp"
#include "toppers/itron/static_api.hpp"
#include "toppers/itron/kernel_object.hpp"
#include <algorithm>

namespace toppers
{
  namespace itron
  {

    /*!
     *  \brief  RtBM[Vt@C̍\
     *  \param  next  ͑Ώۃf[^̐擪
     *  \param  last  ͑Ώۃf[^̏I[+1
     *  \return \͂ɐ true Ԃ
     */
    bool cfg_contents::parse( text::const_iterator& next, text::const_iterator last )
    {
      text::const_iterator iter( next );
      if ( !do_parse( iter, last, ucn_, codeset_ ) )
      {
        return false;
      }
      next = iter;
      return true;
    }

    /*!
     *  \brief  RtBM[Vf[^̌
     *  \param  other   Ώۂ̃RtBM[Vf[^
     */
    void cfg_contents::swap( cfg_contents& other ) throw()
    {
      groups_.swap( other.groups_ );
      name_.swap( other.name_ );
      std::swap( ucn_, other.ucn_ );
      std::swap( codeset_, other.codeset_ );
    }

    /*!
     *  \brief  cfg_contents::classify ֐̎
     *  \param  ucn     ەLɂꍇ true w
     *  \param  codeset RtBM[Vt@C̕R[hw
     */
    const boost::shared_ptr<std::vector<boost::shared_ptr<cfg_contents> > > cfg_contents::do_classify( bool, codeset_t ) const
    {
      typedef std::vector<boost::shared_ptr<cfg_contents> > vector_t;
      boost::shared_ptr<vector_t> v( new vector_t );

      if ( !kernel_object::assign_id( groups().front()->objects().begin(), groups().front()->objects().end() ) )
      {
        v.reset();
        return v;
      }

      v->push_back( boost::shared_ptr<cfg_contents>( new cfg_contents( *this ) ) );
      return v;
    }

    /*!
     *  \brief  eLXgf[^̉
     *  \param  next    eLXgf[^̐擪ʒuщ͏Iʒůi[
     *  \param  last    eLXgf[^ɏI[ʒu+1
     *  \param  ucn     ەɑΉꍇ true w
     *  \param  codeset Wi ascii, shift_jis, euc_jp, utf8 j
     *  \return ͂ɐꍇ true Ԃ
     */
    bool cfg_contents::do_parse( text::const_iterator& next, text::const_iterator last, bool ucn, codeset_t codeset )
    {
      text::const_iterator iter( next );
      if ( iter != last )
      {
        boost::shared_ptr<cfg_group> g( new cfg_group( "" ) );
        if ( !g->parse( iter, last, ucn, codeset ) )
        {
          return false;
        }
        if ( iter != last )
        {
          error( get_text_line( iter ), _( "syntax error" ) );
        }
        groups_.push_back( g );
      }
      next = iter;
      return true;
    }

  }
}
