/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/cfg_contents.hpp
 *  \brief  RtBM[Vt@C̃RecɊւ錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  class cfg_contents;
 *  \endcode
 */
#ifndef TOPPERS_ITRON_CFG_CONTENTS_HPP_
#define TOPPERS_ITRON_CFG_CONTENTS_HPP_

#include "toppers/itron/cfg_group.hpp"
#include <vector>
#include <string>

namespace toppers
{
  namespace itron
  {

    class kernel_object;

    /*!
     *  \class  cfg_contents cfg_contents.hpp "toppers/itron/cfg_contents.hpp"
     *  \brief  RtBM[Vt@C̃Reci[邽߂̃NX
     *  \image  html class_diagram__cfg_contents.png
     */
    class cfg_contents
    {
    public:
      typedef std::vector<boost::shared_ptr<cfg_group> > group_container;
      typedef const boost::shared_ptr<cfg_contents> ( *builder_type )( text::const_iterator&, text::const_iterator, bool, codeset_t );

      /*!
       *  \brief  RXgN^
       *  \param  ucn     ەLɂꍇ true w
       *  \param  codeset R[h
       */
      explicit cfg_contents( bool ucn = false, codeset_t codeset = ascii ) : ucn_( ucn ), codeset_( codeset ) {}
      /*!
       *  \brief  RXgN^
       *  \param  name    Rec
       *  \param  ucn     ەLɂꍇ true w
       *  \param  codeset R[h
       */
      explicit cfg_contents( const std::string& name, bool ucn = false, codeset_t codeset = ascii ) : name_( name ), ucn_( ucn ), codeset_( codeset ) {}
      /*!
       *  \brief  fXgN^
       */
      virtual ~cfg_contents() {}

      void swap( cfg_contents& other ) throw();
      /*!
       *  \brief  O[vւ̎QƂ̎擾
       *  \return O[vւ̎QƂԂ
       */
      group_container& groups() { return groups_; }
      /*!
       *  \brief  O[vւ̎QƂ̎擾
       *  \return O[vւ̎QƂԂ
       */
      const group_container& groups() const { return groups_; }
      /*!
       *  \brief  O[v̐ݒ
       *  \param  container ݒ肷O[v
       */
      void groups( const group_container& container ) { groups_ = container; }
      /*!
       *  \brief  Rec̐ݒ
       *  \param  str   RecƂĐݒ肷镶
       */
      void name( const std::string& str ) { name_ = str; }
      /*!
       *  \brief  Rec̎擾
       *  \return Rec\ւ̎QƂԂ
       */
      const std::string& name() const { return name_; }
      /*!
       *  \brief  Rece̕
       *  \return ތ̃Recւ̃X}[g|C^Ԃ
       *
       *  ̊֐́ARec̃O[vJ[lʂɉKɂĕނA
       *  ̕ނꂽPʂVȃRecƂĔz𐶐܂B\n
       *  Ⴆ΁A}`vZbTJ[l̏ꍇA[JNXɑΉeO[v
       *  VȃRecƂAxN^Ɋi[܂B
       *
       *  classify ֐RećAŏIIɂ͈g kernel_id.h  kernel_cfg.c
       *  𐶐邽߂̏ƂȂ܂B\n
       *  āAیg̃hĈ悤ɁÃO[vRec
       *  ĂAŏIIɈg kernel_id.h  kerenl_cfg.c KvȂꍇ́A
       *  classify ֐ŐxN^̗vfPɂȂ܂B
       */
      const boost::shared_ptr<std::vector<boost::shared_ptr<cfg_contents> > > classify() const { return do_classify( ucn_, codeset_ ); }
      /*!
       *  \brief  \[XeLXg̍\
       *  \param  next  ͑Ώۂ̐擪ʒu
       *  \param  last  ͑Ώۂ̏I[ʒu+1
       */
      bool parse( text::const_iterator& next, text::const_iterator last );
    protected:
      virtual const boost::shared_ptr<std::vector<boost::shared_ptr<cfg_contents> > > do_classify( bool ucn, codeset_t codeset ) const;
      virtual bool do_parse( text::const_iterator& next, text::const_iterator last, bool ucn, codeset_t codeset );
    private:
      group_container groups_;
      std::string name_;
      bool ucn_;
      codeset_t codeset_;
    };

  }
}

#endif  // ! TOPPERS_ITRON_CFG_CONTENTS_HPP_
