/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/cfg_factory.hpp
 *  \brief  JSPJ[l̃RtBM[^pt@NgɊւ錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  class cfg_factory;
 *  \endcode
 */
#ifndef TOPPERS_ITRON_CFG_FACTORY_HPP_
#define TOPPERS_ITRON_CFG_FACTORY_HPP_

#include "toppers/itron/kernel_object.hpp"
#include "toppers/itron/cfg_contents.hpp"
#include "toppers/itron/kernel_chk.hpp"
#include "toppers/factory.hpp"

namespace toppers
{
  namespace itron
  {

    class static_api;

    /*!
     *  \class  cfg_factory cfg_factory.hpp "toppers/itron/cfg_factory.hpp"
     *  \brief  RtBM[^p̃t@Ng[NX
     *  \image html class_diagram__cfg_factory.png
     */
    class cfg_factory : public factory
    {
    public:
      /*!
       *  \brief  t@N^֐ւ̃|C^^
       */
      typedef const boost::shared_ptr<cfg_factory> ( *builder_type )( const cmdline::option_array&, const std::string& );
      /*!
       *  \brief  gR[h֐ւ̃|C^^
       */
      typedef void ( *extra_initializer_type )( const kernel_cfg&, std::ostream& );

      cfg_factory( const cmdline::option_array& options, const std::string& version, long prid );

      const boost::shared_ptr<cfg_contents> create_cfg_contents( text::const_iterator& next, text::const_iterator last, bool ucn = false, codeset_t codeset = ascii ) const;
      const boost::shared_ptr<kernel_object> create_kernel_object( const static_api& api, std::vector<boost::shared_ptr<kernel_object> >& container );

      /*!
       *  \brief  kernel_object IuWFNg̐֐Q̎擾
       *  \return kernel_object IuWFNgi[xN^ւ̃X}[g|C^Ԃ
       */
      const boost::shared_ptr<std::vector<kernel_object::builder_type> > get_kernel_object_builders() const { return do_get_kernel_object_builders(); }
      /*!
       *  \brief  J[lIuWFNgi"task"jꗗ̎擾
       *  \return J[lIuWFNg̃xN^wX}[g|C^Ԃ
       */
      const boost::shared_ptr<std::vector<std::string> > get_kernel_object_names() const { return do_get_kernel_object_names(); }
      /*!
       *  \brief  gR[h֐̎擾
       *  \return gR[h֐ւ̃|C^Ԃ
       */
      extra_initializer_type get_extra_initializer() const { return do_get_extra_initializer(); }
      /*!
       *  \brief  `FbJ[NX̐
       *  \return kernel_chk NXւ̃X}[g|C^Ԃ
       */
      const boost::shared_ptr<kernel_chk> create_kernel_chk() const { return do_create_kernel_chk(); }
      /*!
       *  \brief  v_NgIDl̎擾
       *  \return t@NgɎw肵v_NgIDlԂ
       */
      long prid() const { return prid_; }

      /*!
       *  \brief  t@NgRec̐ݒ
       *  \param  contents  ݒ肷Recւ̃X}[g|C^
       */
      void set_contents( const boost::shared_ptr<cfg_contents>& contents ) { contents_ = contents; }
      /*!
       *  \brief  t@NgRec̎擾
       *  \return Recւ̃X}[g|C^Ԃ
       */
      const boost::shared_ptr<cfg_contents> get_contents() const { return contents_; }

      static const boost::shared_ptr<cfg_factory> build( const cmdline::option_array& options, const std::string& version = std::string() );
      static void register_builder( builder_type builder );
      static void clear_builders();
      static void global( const boost::shared_ptr<cfg_factory>& factory );
      static const boost::shared_ptr<cfg_factory> global();
    protected:
      virtual const boost::shared_ptr<cfg_contents> do_create_cfg_contents( text::const_iterator& next, text::const_iterator last, bool ucn, codeset_t codeset ) const;
      virtual const boost::shared_ptr<kernel_id> do_create_kernel_id( const std::string& file ) const;
      virtual const boost::shared_ptr<kernel_cfg> do_create_kernel_cfg( const std::string& file, const std::string& id_file ) const;
      virtual const boost::shared_ptr<std::vector<kernel_object::builder_type> > do_get_kernel_object_builders() const = 0;
      virtual const boost::shared_ptr<std::vector<std::string> > do_get_kernel_object_names() const = 0;
      virtual extra_initializer_type do_get_extra_initializer() const = 0;
      virtual const boost::shared_ptr<kernel_chk> do_create_kernel_chk() const = 0;
    private:
      static std::vector<builder_type>& builders();
      static boost::shared_ptr<cfg_factory>& global_factory();

      boost::shared_ptr<cfg_contents> contents_;
      long prid_;
    };

  }
}

#endif  // ! TOPPERS_ITRON_CFG_FACTORY_HPP_
