/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/itron/cfg_group.hpp
 */
#include "toppers/itron/cfg_group.hpp"
#include "toppers/itron/cfg_factory.hpp"
#include "toppers/itron/static_api.hpp"
#include <algorithm>

namespace toppers
{
  namespace itron
  {

    /*!
     *  \brief  O[v̌
     *  \param  other Ώۂ̃IuWFNg
     */
    void cfg_group::swap( cfg_group& other ) throw()
    {
      objects_.swap( other.objects_ );
      name_.swap( other.name_ );
      group_type_.swap( other.group_type_ );
    }

    /*!
      *  \brief  \[XeLXg̍\
      *  \param  next    ͑Ώۂ̐擪ʒu
      *  \param  last    ͑Ώۂ̏I[ʒu+1
      *  \param  ucn     ەLɂɂ true w肷
      *  \param  codeset R[h
      *  \return \͂ɐ true Ԃ
      */
    bool cfg_group::parse( text::const_iterator& next, text::const_iterator last, bool ucn, codeset_t codeset )
    {
      return do_parse( next, last, ucn, codeset );
    }

    bool cfg_group::do_parse( text::const_iterator& next, text::const_iterator last, bool ucn, codeset_t codeset )
    {
      text::const_iterator iter( next );
      while ( iter != last )
      {
        static_api api;
        if ( !api.parse( iter, last, ucn, codeset ) )
        {
          break;
        }
        boost::shared_ptr<kernel_object> ptr( cfg_factory::global()->create_kernel_object( api, objects_ ) );
        if ( !ptr )
        {
          // -iapiIvVŔFłȂÓIAPI𖳎ł悤ɂ邽߁A
          // ł͓ɃG[sȂ
        }
      }
      next = iter;
      return true;
    }

  }
}

