/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/cfg_group.hpp
 *  \brief  RtBM[Vt@C̃RecɊ܂܂O[vɊւ錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  class cfg_group;
 *  \endcode
 */
#ifndef TOPPERS_ITRON_CFG_GROUP_HPP_
#define TOPPERS_ITRON_CFG_GROUP_HPP_

#include "toppers/codeset.hpp"
#include "toppers/text.hpp"
#include <string>
#include <boost/shared_ptr.hpp>

namespace toppers
{
  namespace itron
  {

    class kernel_object;

    /*!
     *  \class  cfg_group cfg_group.hpp "toppers/itron/cfg_group.hpp"
     *  \brief  Rec̃O[vǗNX
     */
    class cfg_group
    {
    public:
      typedef std::vector<boost::shared_ptr<kernel_object> > object_container;

      /*!
       *  \brief  ftHgRXgN^
       */
      cfg_group() {}
      /*!
       *  \brief  RXgN^
       *  \param  name        O[v
       *  \param  group_type  O[v
       */
      cfg_group( const std::string& name, const std::string& group_type ) : name_( name ), group_type_( group_type ) {}
      /*!
       *  \brief  RXgN^
       *  \param  name        O[v
       */
      explicit cfg_group( const std::string& name ) : name_( name ) {}
      /*!
       *  \brief  fXgN^
       */
      virtual ~cfg_group() {}

      void swap( cfg_group& other ) throw();
      /*!
       *  \brief  J[lIuWFNg̎擾
       *  \return J[lIuWFNgւ̎QƂԂ
       */
      object_container& objects() { return objects_; }
      /*!
       *  \brief  J[lIuWFNg̎擾
       *  \return J[lIuWFNgւ̎QƂԂ
       */
      const object_container& objects() const { return objects_; }
      /*!
       *  \brief  J[lIuWFNg̐ݒ
       *  \param  container ݒ肷J[lIuWFNg
       */
      void objects( const object_container& container ) { objects_ = container; }
      /*!
       *  \brief  O[v̎擾
       *  \return O[v\ւ̎Q
       */
      const std::string& name() const { return name_; }
      /*!
       *  \brief  O[vʂ̎擾
       *  \return O[vʂ\ւ̎QƂԂ
       */
      const std::string& group_type() const { return group_type_; }

      bool parse( text::const_iterator& next, text::const_iterator last, bool ucn = false, codeset_t codeset = ascii );
    protected:
      virtual bool do_parse( text::const_iterator& next, text::const_iterator last, bool ucn, codeset_t codeset );
    private:
      object_container objects_;
      std::string name_;
      std::string group_type_;
    };

  }
}

#endif  // ! TOPPERS_ITRON_CFG_GROUP_HPP_
