/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/cfg_kernel_cfg.hpp
 *  \brief  ITRONp"kernel_cfg.c"t@Co͂Ɋւ錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  \class cfg_kernel_cfg;
 *  \endcode
 */
#ifndef TOPPERS_ITRON_CFG_KERNEL_CFG_HPP_
#define TOPPERS_ITRON_CFG_KERNEL_CFG_HPP_

#include "toppers/kernel_cfg.hpp"

namespace toppers
{
  namespace itron
  {

    class cfg_contents;

    /*!
     *  \class  cfg_kernel_cfg cfg_kernel_cfg.hpp "toppers/itron/cfg_kernel_cfg.hpp"
     *  \brief  "kernel_cfg.c"t@Co͏NX
     */
    class cfg_kernel_cfg : public kernel_cfg
    {
    public:
      explicit cfg_kernel_cfg( const std::string& file, const std::string& id_file, long prid = -1L );
      /*!
       *  \brief  Rec̃[h
       *  \param  contents  [hRec
       */
      void load( const boost::shared_ptr<cfg_contents>& contents ) { do_load( contents ); }
      /*!
       *  \brief  v_NgIDl̎擾
       *  \return t@NgɎw肵v_NgIDlԂ
       */
      long prid() const { return prid_; }
    protected:
      virtual void do_body( std::ostream& ostr ) const;
      virtual void do_depend() const;
      virtual void do_include_headers( std::ostream& ostr ) const;
      virtual void do_define_macros( std::ostream& ostr ) const;
      virtual void do_define_objects( std::ostream & ostr ) const;
      virtual void do_initialize_object( std::ostream& ostr ) const;
      virtual void do_initialize_other( std::ostream& ostr ) const;
      virtual void do_check_version( std::ostream& ostr ) const;
      virtual void do_check_magic_number( std::ostream& ostr ) const;
      virtual void do_load( const boost::shared_ptr<cfg_contents>& contents );
    private:
      long prid_;
    };

  }
}

#endif  // ! TOPPERS_ITRON_CFG_KERNEL_CFG_HPP_
