/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/itron/cfg_kernel_id.cpp
 */
#include "toppers/itron/cfg_kernel_id.hpp"
#include "toppers/itron/cfg_factory.hpp"
#include "toppers/itron/cfg_contents.hpp"
#include <ostream>

namespace toppers
{
  namespace itron
  {

    void cfg_kernel_id::do_load( const boost::shared_ptr<cfg_contents>& contents )
    {
      typedef cfg_contents::group_container::const_iterator group_iterator;
      const cfg_contents::group_container& container = contents->groups();

      for ( group_iterator giter( contents->groups().begin() ), glast( contents->groups().end() ); giter != glast; ++giter )
      {
        typedef cfg_group::object_container::const_iterator object_iterator;
        const boost::shared_ptr<cfg_group> group( *giter );
        for ( object_iterator oiter( group->objects().begin() ), olast( group->objects().end() ); oiter != olast; ++oiter )
        {
          insert_id( ( *oiter )->get_object_type(), ( *oiter )->get_idb() );
        }
      }
    }

    void cfg_kernel_id::do_body( std::ostream& ostr ) const
    {
      typedef factory::kernel_id_generator_type generator_type;
      const boost::shared_ptr<std::vector<generator_type> > generators( cfg_factory::global()->create_kernel_id_generators() );
      std::vector<generator_type>::const_iterator iter;
      const std::vector<generator_type>::const_iterator last( generators->end() );
      for ( iter = generators->begin(); iter != last; ++iter )
      {
        ( *iter )( *this, ostr );
      }
      ostr << '\n';
    }

  }
}
