/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/cfg_kernel_id.hpp
 *  \brief  ITRONp"kernel_id.h"t@C̏o͂Ɋւ錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  class cfg_kernel_id;
 *  \endcode
 */
#ifndef TOPPERS_ITRON_CFG_KERNEL_ID_HPP_
#define TOPPERS_ITRON_CFG_KERNEL_ID_HPP_

#include "toppers/kernel_id.hpp"

namespace toppers
{
  namespace itron
  {

    class cfg_contents;

    /*!
     *  \class  cfg_kernel_id cfg_kernel_id.hpp "toppers/itron/cfg_kernel_id.hpp"
     *  \brief  "kernel_id.h"t@Co͏NX
     */
    class cfg_kernel_id : public kernel_id
    {
    public:
      /*!
       *  \brief  RXgN^
       *  \param  file  t@C
       */
      explicit cfg_kernel_id( const std::string& file ) : kernel_id( file ) {}
      /*!
       *  \brief  Rec̃[h
       *  \param  contents  [hRec
       */
      void load( const boost::shared_ptr<cfg_contents>& contents ) { do_load( contents ); }
    protected:
      virtual void do_body( std::ostream& ostr ) const;
      virtual void do_load( const boost::shared_ptr<cfg_contents>& contents );
    };

  }
}

#endif  // ! TOPPERS_ITRON_CFG_KERNEL_ID_HPP_
