/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/itron/chk_factory.cpp
 */
#include "toppers/itron/chk_factory.hpp"

namespace toppers
{
  namespace itron
  {

    /*!
     *  \brief  RtBM[^
     *  \param  options R}hCIvV
     *  \param  prid    TKERNEL_PRID}N̒l
     */
    chk_factory::chk_factory( const cmdline::option_array& options, long prid )
      : options_( new cmdline::option_array( options ) ), prid_( prid )
    {
    }

    /*!
     *  \brief  t@Nĝ̐
     *  \param  options R}hCIvV
     *  \param  prid    TKERNEL_PRID}N̒l
     */
    const boost::shared_ptr<chk_factory> chk_factory::build( const cmdline::option_array& options, long prid )
    {
      typedef std::vector<builder_type>::const_iterator const_iterator;
      for ( const_iterator iter( builders().begin() ), last( builders().end() ); iter != last; ++iter )
      {
        boost::shared_ptr<chk_factory> ptr( ( *iter )( options, prid ) );
        if ( ptr )
        {
          return ptr;
        }
      }
      return boost::shared_ptr<chk_factory>();
    }

    /*!
     *  \brief  t@Nĝ̐֐̓o^
     *  \param  builder   ֐
     *
     *  ̊֐œo^֐ build ֐Ăяo܂B
     */
    void chk_factory::register_builder( builder_type builder )
    {
      builders().push_back( builder );
    }

    /*!
     *  \brief  o^Ăt@Ng֐̏
     */
    void chk_factory::clear_builders()
    {
      builders().clear();
    }

    /*!
     *  \brief  O[ot@Ng̐ݒ
     *  \param  factory   O[oo^t@Ngւ̃X}[g|C^
     */
    void chk_factory::global( const boost::shared_ptr<chk_factory>& factory )
    {
      global_factory() = factory;
    }

    /*!
     *  \brief  O[ot@Ng̎Q
     *  \return O[ot@NgwX}[g|C^Ԃ
     */
    const boost::shared_ptr<chk_factory> chk_factory::global()
    {
      return global_factory();
    }

    /*!
     *  \brief  t@Nĝ̃r_֐Rei̎Q
     *  \return r_֐Reiւ̎QƂԂ
     *
     *  ̊֐́AÓIIuWFNg̃RXgN^ĂяoɊւ
     *  邽߂ɓIɎgp܂B
     */
    std::vector<chk_factory::builder_type>& chk_factory::builders()
    {
      static std::vector<builder_type> builders_array;
      return builders_array;
    }

    /*!
     *  \brief  O[o chk_factory IuWFNg̎擾
     *  \return O[o chk_factory IuWFNgwX}[g|C^ւ̎Q
     *
     *  ̊֐́AÓIIuWFNg̃RXgN^ĂяoɊւ
     *  邽߂ɓIɎgp܂B
     */
    boost::shared_ptr<chk_factory>& chk_factory::global_factory()
    {
      static boost::shared_ptr<chk_factory> instance( build( cmdline::option_array(), 0x0001 ) );
      return instance;
    }

  }
}
