/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/fdmp/cfg_contents.hpp
 *  \brief  @\U}`vZbTRecɊւ錾`
 */
#ifndef TOPPERS_ITRON_MP_CFG_CONTENTS_HPP_
#define TOPPERS_ITRON_MP_CFG_CONTENTS_HPP_

#include "toppers/itron/cfg_contents.hpp"

namespace toppers
{
  namespace itron
  {
    namespace fdmp
    {

      /*!
      *  \class  cfg_contents cfg_contents.hpp "toppers/itron/fdmp/cfg_contents.hpp"
      *  \brief  @\U}`vZbTReci[邽߂̃NX
      */
      class cfg_contents : public itron::cfg_contents
      {
      public:
        explicit cfg_contents( bool ucn = false, codeset_t codeset = ascii ) : itron::cfg_contents( ucn, codeset ) {}
        explicit cfg_contents( const std::string& name, bool ucn = false, codeset_t codeset = ascii ) : itron::cfg_contents( name, ucn, codeset ) {}
        virtual ~cfg_contents() {}
      protected:
        virtual const boost::shared_ptr<std::vector<boost::shared_ptr<itron::cfg_contents> > > do_classify( bool ucn, codeset_t codeset ) const;
        virtual bool do_parse( text::const_iterator& next, text::const_iterator last, bool ucn, codeset_t codeset );
      };

    }
  }
}

#endif  // ! TOPPERS_ITRON_MP_CFG_CONTENTS_HPP_
