/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/fdmp/cfg_factory.hpp
 *  \brief  @\U}`vZbTt@NgɊւ錾`
 */
#ifndef TOPPERS_ITRON_MP_CFG_FACTORY_HPP_
#define TOPPERS_ITRON_MP_CFG_FACTORY_HPP_

#include "toppers/itron/fdmp/cfg_contents.hpp"
#include "toppers/itron/cfg_factory.hpp"

namespace toppers
{
  namespace itron
  {
    namespace fdmp
    {

      /*!
      *  \class  cfg_factory cfg_factory.hpp "toppers/itron/fdmp/cfg_factory.hpp"
      *  \brief  RtBM[^p̃t@Ng[NX
      */
      class cfg_factory : public itron::cfg_factory
      {
      public:
        cfg_factory( const cmdline::option_array& options, const std::string& version, long prid );
        static const boost::shared_ptr<itron::cfg_factory> build( const cmdline::option_array& options, const std::string& version );
      protected:
        virtual const boost::shared_ptr<itron::cfg_contents> do_create_cfg_contents( text::const_iterator& next, text::const_iterator last, bool ucn, codeset_t codeset ) const;
        virtual const std::string do_get_cfg_file_name( const std::string& file ) const;
        virtual const boost::shared_ptr<std::vector<kernel_cfg_generator_type> > do_create_kernel_cfg_generators() const;
        virtual const boost::shared_ptr<std::vector<kernel_id_generator_type> > do_create_kernel_id_generators() const;
        virtual const boost::shared_ptr<std::vector<kernel_object::builder_type> > do_get_kernel_object_builders() const;
        virtual const boost::shared_ptr<std::vector<std::string> > do_get_kernel_object_names() const;
        virtual extra_initializer_type do_get_extra_initializer() const;
        virtual const boost::shared_ptr<kernel_chk> do_create_kernel_chk() const;
      private:
        static void extra_init( const kernel_cfg& cfg, std::ostream& ostr );

        boost::shared_ptr<itron::cfg_factory> base_factory_;
      };

    }
  }
}

#endif  // ! TOPPERS_ITRON_MP_CFG_FACTORY_HPP_
