/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/fdmp/class_id.hpp
 *  \brief  }`vZbTJ[lp"class_id.h"t@C̏o͂Ɋւ錾`
 */
#ifndef TOPPERS_ITRON_MP_CLASS_ID_HPP_
#define TOPPERS_ITRON_MP_CLASS_ID_HPP_

#include "toppers/kernel_id.hpp"
#include <vector>

namespace toppers
{
  namespace itron
  {

    class cfg_contents;

    namespace fdmp
    {

      /*!
      *  \class  class_id class_id.hpp "toppers/itron/fdmp/class_id.hpp"
      *  \brief  }`vZbTJ[lp"class_id.h"t@C̏o̓NX
      */
      class class_id : public kernel_id
      {
      public:
        explicit class_id( const std::string& file = std::string( "class_id.h" ) );
        void load( const boost::shared_ptr<itron::cfg_contents>& contents );
        void save() const;
        std::vector<std::string>& classes();
        const std::vector<std::string>& classes() const;
      protected:
        virtual void do_body( std::ostream& ostr ) const;
        virtual const std::vector<std::string>& do_get_object_types() const;
      private:
        std::vector<std::string> classes_;
      };

    }
  }
}

#endif  // ! TOPPERS_ITRON_MP_CLASS_ID_HPP_
