/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/include.hpp
 *  \brief  ÓIAPI "INCLUDE" Ɋւ錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  struct include_policy;
 *  \endcode
 */
#ifndef TOPPERS_ITRON_INCLUDE_HPP_
#define TOPPERS_ITRON_INCLUDE_HPP_

#include "toppers/itron/specified_object.hpp"

namespace toppers
{
  namespace itron
  {

    /*!
     *  \struct include_policy include.hpp "toppers/itron/include.hpp"
     *  \brief  INCLUDEÓIAPÎ߂̃|V[NX
     *
     *  \sa specified_object, include
     */
    struct include_policy : kernel_object_policy_base
    {
      static bool generate_kernel_cfg( const kernel_cfg& cfg, std::ostream& ostr );
      static bool generate_kernel_id( const kernel_id&, std::ostream& );
      static bool verify( const static_api& api, kernel_object& obj );
      enum { use_id_ = 0 };
      static const char name_[];
      static const char* const apis_[];
      static const char* const params_[];
    };

    /*!
     *  \brief  INCLUDEÓIAPÎ߂̃J[lIuWFNgNX
     *
     *  INCLUDE ÓIAPI̓J[lIuWFNgł͂܂񂪁A̕֋XAJ[l
     *  IuWFNg̈ƂĈ̂Ƃ܂B
     */
    typedef specified_object<include_policy> include;

  }
}

#endif  // ! TOPPERS_ITRON_INCLUDE_HPP_
