/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/itron/jsp/dataqueue.cpp
 */
#include "toppers/itron/jsp/dataqueue.hpp"

namespace toppers
{
  namespace itron
  {
    namespace jsp
    {

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::verify ֐
       *  \param  api   ͑Ώۂ̐ÓIAPI
       *  \param  obj   J[lIuWFNg
       *  \return 茋ʂł true ԂB
       */
      bool dataqueue_policy::verify( const static_api& api, kernel_object& obj )
      {
        if ( obj.get( "dtq" ) != "NULL" )
        {
          error( _( "parameter `%1%\' must be `NULL\'" ) % "dtq" );
          return false;
        }
        return true;
      }

      const char dataqueue_policy::name_[] = "dataqueue";
      const char dataqueue_policy::symbol_[] = "dtq";
      const char* const dataqueue_policy::apis_[] = { "CRE_DTQ", 0 };
      const char* const dataqueue_policy::params_[] = { "$dtqid { #dtqatr #dtqcnt dtq }", 0 };
      const char dataqueue_policy::region_format_[] = "#if @#dtqcnt > 0\n"
                                                      "static VP_INT __dataqueue_@name[@#dtqcnt];\n"
                                                      "#else\n"
                                                      "#define __dataqueue_@name  NULL\n"
                                                      "#endif\n"
                                                      "\n";
      const char dataqueue_policy::init_format_[] = "\t{ @#dtqatr, @#dtqcnt, __dataqueue_@name }";

    }
  }
}

