/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/itron/jsp/eventflag.cpp
 */
#include "toppers/itron/jsp/eventflag.hpp"

namespace toppers
{
  namespace itron
  {
    namespace jsp
    {

      /*!
       *  \brief  p[^`FbNR[h ̐
       *  \param  cfg   kernel_cfg.c 
       *  \param  ostr  o̓Xg[
       */
      void eventflag_policy::generate_assertions( const kernel_cfg& cfg, std::ostream& ostr )
      {
        const kernel_cfg::inib_array* pinibs = cfg.get_inib_array( name_ );
        static const char pattern[] = 
          "#if ((@#flgatr) & 0x02u) != 0x00u\n"
          "#error \"`flgatr\' of eventflag `@name\' is specified TA_WMUL\"\n"
          "#endif\n"
          "__CFG_ASSERT(((@#flgatr) & 0x02u) == 0x00u);\n"
          "\n";
        std::transform( pinibs->begin(), pinibs->end(), std::ostream_iterator<std::string>( ostr ), generator( pattern ) );
      }

      const char eventflag_policy::name_[] = "eventflag";
      const char eventflag_policy::symbol_[] = "flg";
      const char* const eventflag_policy::apis_[] = { "CRE_FLG", 0 };
      const char* const eventflag_policy::params_[] = { "$flgid { #flgatr iflgptn }", 0 };
      const char eventflag_policy::init_format_[] = "\t{ @#flgatr, @iflgptn }";

    }
  }
}
