/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/jsp/file_generator.hpp
 *  \brief  J[lIuWFNg̐Ɋւ錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  class file_generator<Policy>;
 *  \endcode
 */
#ifndef TOPPERS_ITRON_JSP_FILE_GENERATOR_HPP_
#define TOPPERS_ITRON_JSP_FILE_GENERATOR_HPP_

#include "toppers/kernel_cfg.hpp"
#include "toppers/misc.hpp"
#include <boost/format.hpp>

namespace toppers
{
  namespace itron
  {
    namespace jsp
    {
 
      /*!
       *  \class  file_generator file_generator.hpp "toppers/itron/jsp/file_generator.hpp"
       *  \brief  JSPJ[lJ[lIuWFNgNX
       *
       *  ̃NX toppers::itron::specified_object<Policy> Ɏw肷 Policy ɕKvɂȂ
       *  generate_kernel_cfg  generate_kernel_id ֐`܂B
       *  ̊֐A file_generator<Policy> NXɐ؂oĂ̂́A
       *  ֐̒` Policy ̑̃o[Ɉˑ邽߂łB
       */
      template <class Policy>
      class file_generator
      {
      public:
        /*!
        *  \brief  kernel_cfg.c ̐
        *  \param  cfg   kernel_cfg.c 
        *  \param  ostr  o̓Xg[
        */
        static void generate_kernel_cfg( const kernel_cfg& cfg, std::ostream& ostr )
        {
          using boost::format;

          ostr << format( "\t/* Object initializer [%1%] */\n\n" ) % static_cast<const char*>( Policy::name_ );

          kernel_cfg::inib_array inibs( *cfg.get_inib_array( Policy::name_ ) );
          std::string SYM( toupper( Policy::symbol_ ) );
          std::string TNUM;
          boost::shared_ptr<cmdline::option_array> options( cfg_factory::global()->options() );

          if ( Policy::use_id_ )
          {
            // IDԍ̐ƍől
            TNUM = "TNUM_" + SYM + "ID";
            ostr << format( "#define %1% %2%\n\n" ) % TNUM % inibs.size();
//            ostr << format( "const ID _kernel_tmax_%1%id = (TMIN_%2%ID + %3% - 1);\n\n" ) % static_cast<const char*>( Policy::symbol_ ) % SYM % TNUM;
			/* @chg 2004-04-03 TMIN_xxID ̔p~ɂύX */  
			ostr << format( "const ID _kernel_tmax_%1%id = (TMIN_ID + %2% - 1);\n\n" ) % static_cast<const char*>( Policy::symbol_ ) % TNUM;
          }
          else
          {
            // IuWFNgԍ̐ƍől
            TNUM = "TNUM_" + SYM + "NO";
            ostr << format( "#define %1% %2%\n\n" ) % TNUM % inibs.size();
            ostr << format( "const UINT _kernel_tnum_%1%no = %2%;\n\n" ) % static_cast<const char*>( Policy::symbol_ ) % TNUM;
          }

          std::string prefix( Policy::prefix_ == 0 ? Policy::symbol_ : Policy::prefix_ );
          std::string PREFIX( toupper( prefix ) );
          if ( inibs.empty() )
          {
            if ( !options->find( "-z" ) )
            {
              // IuWFNgȂꍇ̃_~[x̏o
              ostr << format( "__EMPTY_LABEL(const %1%INIB, _kernel_%2%inib_table);\n" ) % PREFIX % prefix;
              if ( Policy::use_id_ )
              {
                ostr << format( "__EMPTY_LABEL(%1%CB, _kernel_%2%cb_table);\n" ) % PREFIX % prefix;
              }
              Policy::generate_extra_empty_labels( ostr );
              ostr << '\n';
            }
          }
          else
          {
            std::sort( inibs.begin(), inibs.end(), &kernel_cfg::initial_block::less_than );

            // ̈`̐
            std::transform( inibs.begin(), inibs.end(), std::ostream_iterator<std::string>( ostr ), typename Policy::generator( Policy::region_format_ ) );
            ostr << '\n';

            // ubN`̐
            ostr << format( "const %1%INIB _kernel_%2%inib_table[%3%] = {\n" ) % PREFIX % prefix % TNUM;
            output_list( inibs.begin(), inibs.end(), ostr, typename Policy::generator( Policy::init_format_ ), ",\n" );
            ostr << "\n};\n\n";

            // ̑̕ϐ`iRAM̈j̏o
            Policy::generate_variables( cfg, ostr );

            // ubN`̏o
            if ( Policy::use_id_ )
            {
              ostr << format( "%1%CB _kernel_%2%cb_table[%3%];\n\n" ) % PREFIX % prefix % TNUM;
            }

            // ̑̒萔`iROM̈j̏o
            Policy::generate_constants( cfg, ostr );

            // IDԍi[Lϐ̏o
            if ( Policy::use_id_ )
            {
              if ( options->find( "-var" ) )
              {
                ostr << "\t/* Identifier storage variables */\n";
                std::transform( inibs.begin(), inibs.end(), std::ostream_iterator<std::string>( ostr ), typename Policy::generator( "const int @name\\_id = @id;\n" ) );
                ostr << '\n';
              }
            }

            // AT[VR[h̏o
            if ( options->find( "-c" ) )
            {
              Policy::generate_assertions( cfg, ostr );
            }
          }
        }

        /*!
        *  \brief  kernel_id.h ̐
        *  \param  id_cfg   kernel_id.h 
        *  \param  ostr     o̓Xg[
        */
        static void generate_kernel_id( const kernel_id& id_cfg, std::ostream& ostr )
        {
          const kernel_id::id_array* pids = id_cfg.get_id_array( Policy::name_ );
          if ( pids != 0 )
          {
            typedef kernel_id::id_array::const_iterator idb_iterator;
            for ( idb_iterator iter( pids->begin() ), last( pids->end() ); iter != last; ++iter )
            {
              std::string name( ( *iter )->name() );
              if ( !name.empty() )
              {
                ostr << "#define " << name << '\t' << ( *iter )->value() << '\n';
              }
            }
          }
        }
      };

    }
  }
}

#endif  // ! TOPPERS_ITRON_JSP_FILE_GENERATOR_HPP_
