/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/itron/jsp/initialization.cpp
 */
#include "toppers/itron/jsp/initialization.hpp"

namespace toppers
{
  namespace itron
  {
    namespace jsp
    {

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::generate_kernel_cfg ֐
       *  \param  cfg   kernel_cfg.c 
       *  \param  ostr  o̓Xg[
       */
      void initialization_policy::generate_kernel_cfg( const kernel_cfg& cfg, std::ostream& ostr )
      {
        using boost::format;
        typedef kernel_cfg::inib_array::const_iterator const_iterator;

        const kernel_cfg::inib_array* pinibs = cfg.get_inib_array( name_ );
        if ( pinibs == 0 )
        {
          static const kernel_cfg::inib_array dummy;
          pinibs = &dummy;
        }

        // [`̌Ăяo֐`
        ostr << "\t/* Initialization handler */\n\n";
        ostr << "void\n_kernel_call_inirtn(void)\n{\n";
        for ( const_iterator iter( pinibs->begin() ), last( pinibs->end() ); iter != last; ++iter )
        {
          if ( !( *iter )->get( "inirtn" ).empty() )
          {
            ostr << format( "\t%1%((VP_INT)%2%);\n" ) % ( *iter )->get( "inirtn" ) % ( *iter )->get( "exinf" );
          }
        }
        ostr << "}\n\n";
      }

      /*!
       *  \brief  p[^`FbNR[h ̐
       *  \param  cfg   kernel_cfg.c 
       *  \param  ostr  o̓Xg[
       */
      void initialization_policy::generate_assertions( const kernel_cfg& cfg, std::ostream& ostr )
      {
        const kernel_cfg::inib_array* pinibs = cfg.get_inib_array( name_ );
        static const char pattern[] = 
          "#if ((@#iniatr) & (TA_HLNG|TA_ASM)) != TA_HLNG\n"
          "#error \"`iniatr\' for `@inirtn\' is not TA_HLNG\"\n"
          "#endif\n"
          "__CFG_ASSERT(((@#iniatr) & (TA_HLNG|TA_ASM)) != TA_HLNG);\n"
          "__CFG_ASSERT(sizeof((*(@inirtn))(0), 1));\n"   // inirtnɊ֐^}Nw肵Ăꍇɂ̓RpCs
          "\n";
        std::transform( pinibs->begin(), pinibs->end(), std::ostream_iterator<std::string>( ostr ), generator( pattern ) );
      }

      const char initialization_policy::name_[] = "initialization";
      const char* const initialization_policy::apis_[] = { "ATT_INI", 0 };
      const char* const initialization_policy::params_[] = { "{ #iniatr exinf inirtn }", 0 };

    }
  }
}
