/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/jsp/kernel_chk.hpp
 *  \brief  JSPJ[l"kernel_chk.c"o͂Ɋւ錾`
 */
#ifndef TOPPERS_ITRON_JSP_KERNEL_CHK_HPP_
#define TOPPERS_ITRON_JSP_KERNEL_CHK_HPP_

#include "toppers/itron/kernel_chk.hpp"

namespace toppers
{
  namespace itron
  {
    namespace jsp
    {

      /*!
      *  \class  kernel_chk kernel_chk.hpp "toppers/itron/jsp/kernel_chk.hpp"
      *  \brief  "kernel_chk.c"o̓NX
      */
      class kernel_chk : public itron::kernel_chk
      {
      public:
        enum
        {
          magic_number,
          TKERNEL_PRID,

          sizeof_ID,
          sizeof_UINT,
          sizeof_SIZE,
          sizeof_ATR,
          sizeof_PRI,
          sizeof_RELTIM,
          sizeof_VP,
          sizeof_VP_INT,
          sizeof_FP,

          countof_TSKID,
          sizeof_TINIB,
          offsetof_TINIB_tskatr,
          offsetof_TINIB_exinf,
          offsetof_TINIB_task,
          offsetof_TINIB_ipriority,
          offsetof_TINIB_stksz,
          offsetof_TINIB_stk,
          offsetof_TINIB_texatr,
          offsetof_TINIB_texrtn,

          countof_SEMID,
          sizeof_SEMINIB,
          offsetof_SEMINIB_sematr,
          offsetof_SEMINIB_isemcnt,
          offsetof_SEMINIB_maxsem,

          countof_FLGID,
          sizeof_FLGPTN,
          sizeof_FLGINIB,
          offsetof_FLGINIB_flgatr,
          offsetof_FLGINIB_iflgptn,

          countof_DTQID,
          sizeof_DTQINIB,
          offsetof_DTQINIB_dtqatr,
          offsetof_DTQINIB_dtqcnt,
          offsetof_DTQINIB_dtq,

          countof_MBXID,
          sizeof_MBXINIB,
          offsetof_MBXINIB_mbxatr,
          offsetof_MBXINIB_maxmpri,

          countof_MPFID,
          sizeof_MPFINIB,
          offsetof_MPFINIB_mpfatr,
          offsetof_MPFINIB_blksz,
          offsetof_MPFINIB_mpf,
          offsetof_MPFINIB_limit,

          countof_CYCID,
          sizeof_CYCINIB,
          offsetof_CYCINIB_cycatr,
          offsetof_CYCINIB_exinf,
          offsetof_CYCINIB_cychdr,
          offsetof_CYCINIB_cyctim,
          offsetof_CYCINIB_cycphs,

          countof_INHNO,
          sizeof_INHNO,
          sizeof_INHINIB,
          offsetof_INHINIB_inhno,
          offsetof_INHINIB_inhatr,
          offsetof_INHINIB_inthdr,

          countof_EXCNO,
          sizeof_EXCNO,
          sizeof_EXCINIB,
          offsetof_EXCINIB_excno,
          offsetof_EXCINIB_excatr,
          offsetof_EXCINIB_exchdr,

          table_size
        };

        explicit kernel_chk( const std::string& file ) : itron::kernel_chk( file ) {}
        virtual ~kernel_chk() {}
      protected:
        virtual void do_body( std::ostream& ostr ) const;
        virtual bool do_load( const s_record& srec, unsigned long address );
      };

    }
  }
}

#endif  // ! TOPPERS_ITRON_JSP_KERNEL_CHK_HPP_
