/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/jsp/kernel_policy.hpp
 *  \brief  JSPJ[lJ[l|V[Ɋւ錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  struct kernel_policy;
 *  \endcode
 */
#ifndef TOPPERS_ITRON_JSP_KERNEL_POLICY_HPP_
#define TOPPERS_ITRON_JSP_KERNEL_POLICY_HPP_

#include "toppers/config.hpp"
#include <iosfwd>
#include <string>
#include <boost/mpl/list.hpp>

namespace toppers
{

  class kernel_cfg;

  namespace itron
  {

    struct include_policy;

    namespace jsp
    {

      struct task_policy;
      struct semaphore_policy;
      struct eventflag_policy;
      struct dataqueue_policy;
      struct mailbox_policy;
      struct mempfix_policy;
      struct cyclic_policy;
      struct interrupt_policy;
      struct exception_policy;
      struct initialization_policy;
      struct termination_policy;

      class kernel_chk;

      /*!
       *  \struct kernel_policy kernel_policy.hpp "toppers/itron/jsp/kernel_policy.hpp"
       *  \brief  JSPJ[lJ[l|V[NX
       *  \sa   specified_factory
       */
      struct kernel_policy
      {
        /*!
         *  \brief  J[lT|[gIuWFNg|V[^Xg
         *
         *  ŕׂɐÓIAPỈ͂ kernel_cfg.c ̍\vfo͂s܂B
         */
        typedef boost::mpl::list<include_policy, task_policy, semaphore_policy, eventflag_policy,
                                 dataqueue_policy, mailbox_policy, mempfix_policy, cyclic_policy,
                                 interrupt_policy, exception_policy, initialization_policy,
                                 termination_policy> sequence;
        enum { prid_ = 0x0001 };
        typedef jsp::kernel_chk kernel_chk;

        static bool match_version( const std::string& ver );
        static void extra_init( const kernel_cfg& cfg, std::ostream& ostr );
      };

    }
  }
}

#endif  // ! TOPPERS_ITRON_JSP_KERNEL_POLICY_HPP_

