/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/itron/jsp/mempfix.cpp
 */
#include "toppers/itron/jsp/mempfix.hpp"

namespace toppers
{
  namespace itron
  {
    namespace jsp
    {

      /*!
       *  \brief  p[^`FbNR[h ̐
       *  \param  cfg   kernel_cfg.c 
       *  \param  ostr  o̓Xg[
       */
      void mempfix_policy::generate_assertions( const kernel_cfg& cfg, std::ostream& ostr )
      {
        const kernel_cfg::inib_array* pinibs = cfg.get_inib_array( name_ );
        static const char pattern[] = 
          "__CFG_ASSERT((@blkcnt) >0);\n"
          "__CFG_ASSERT((@blksz) > 0);\n"
          "\n";
        std::transform( pinibs->begin(), pinibs->end(), std::ostream_iterator<std::string>( ostr ), generator( pattern ) );
      }

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::verify ֐
       *  \param  api   ͑Ώۂ̐ÓIAPI
       *  \param  obj   J[lIuWFNg
       *  \return 茋ʂł true ԂB
       */
      bool mempfix_policy::verify( const static_api& api, kernel_object& obj )
      {
        if ( obj.get( "mpf" ) != "NULL" )
        {
          error( _( "parameter `%1%\' must be `NULL\'" ) % "mpf" );
          return false;
        }
        return true;
      }

      const char mempfix_policy::name_[] = "mempfix";
      const char mempfix_policy::symbol_[] = "mpf";
      const char* const mempfix_policy::apis_[] = { "CRE_MPF", 0 };
      const char* const mempfix_policy::params_[] = { "$mpfid { #mpfatr blkcnt blksz mpf }", 0 };
      const char mempfix_policy::region_format_[] = "static __MPF_UNIT __fixedsize_memorypool_@name[__TCOUNT_MPF_UNIT(@blksz) * (@blkcnt)];\n";
      const char mempfix_policy::init_format_[] = "\t{ @#mpfatr, __TROUND_MPF_UNIT(@blksz), __fixedsize_memorypool_@name, (VP)(((VB*)__fixedsize_memorypool_@name) + sizeof(__fixedsize_memorypool_@name)) }";

    }
  }
}
