/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/jsp/task.hpp
 *  \brief  ^XNɊւ錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  struct task_policy;
 *  \endcode
 */
#ifndef TOPPERS_ITRON_JSP_TASK_HPP_
#define TOPPERS_ITRON_JSP_TASK_HPP_

#include "toppers/itron/specified_object.hpp"
#include "toppers/itron/jsp/file_generator.hpp"
#include "toppers/itron/jsp/itron.hpp"

namespace toppers
{
  namespace itron
  {
    namespace jsp
    {

      struct TINIB
      {
        ATR tskatr;
        VP_INT exinf;
        FP task;
        UINT ipriority;
        SIZE stksz;
        VP stk;
        ATR texatr;
        FP texrtn;
      };

      /*!
       *  \struct task_policy task.hpp "toppers/itron/jsp/task.hpp"
       *  \brief  ^XN̂߂̃|V[NX
       *
       *  ̃NXŎÓIAPI
       *  \code
       *  CRE_TSK( ID tskid, { ATR tskatr, VP_INT exinf, FP task, PRI itskpri, SIZE stksz, VP stk } );
       *  DEF_TSK( ID tskid, { ATR texatr, FP texrtn } );
       *  \endcode
       */
      struct task_policy : kernel_object_policy_base, file_generator<task_policy>
      {
        static void generate_constants( const kernel_cfg& cfg, std::ostream& ostr );
        static void generate_assertions( const kernel_cfg& cfg, std::ostream& ostr );
        static void generate_extra_empty_labels( std::ostream& ostr );
        static bool verify( const static_api& api, kernel_object& obj );
        static bool check( const itron::kernel_chk& chk, const s_record& srec, const nm_symbol& syms );
        static const char name_[];
        static const char symbol_[];
        static const char* const apis_[];
        static const char* const params_[];
        static const char* const apis2_[];
        static const char* const params2_[];
        static const char* const prefix_;
        static const char region_format_[];
        static const char init_format_[];
      };

      /*!
       *  \brief  CRE_TSK, DEF_TEXÓIAPIp̃J[lIuWFNgNX
       */
      typedef specified_object<task_policy> task;

    }
  }
}

#endif  // ! TOPPERS_ITRON_JSP_TASK_HPP_
