/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/itron/jsp/termination.cpp
 */
#include "toppers/itron/jsp/termination.hpp"

namespace toppers
{
  namespace itron
  {
    namespace jsp
    {

      /*!
      *  \brief  specified_object<Plociy> NXv Policy::generate_kernel_cfg ֐
      *  \param  cfg   kernel_cfg.c 
      *  \param  ostr  o̓Xg[
      *  \return ɐ true Ԃ
      */
      bool termination_policy::generate_kernel_cfg( const kernel_cfg& cfg, std::ostream& ostr )
      {
        using boost::format;
        typedef kernel_cfg::inib_array::const_iterator const_iterator;

        const kernel_cfg::inib_array* pinibs = cfg.get_inib_array( name_ );
        if ( pinibs == 0 )
        {
          static const kernel_cfg::inib_array dummy;
          pinibs = &dummy;
        }

        // I[`̌Ăяo֐`
        ostr << "\t/* Termination handler */\n\n";
        ostr << "void\n_kernel_call_terrtn(void)\n{\n";
        for ( const_iterator iter( pinibs->begin() ), last( pinibs->end() ); iter != last; ++iter )
        {
          if ( !( *iter )->get( "terrtn" ).empty() )
          {
            ostr << format( "\t%1%((VP_INT)%2%);\n" ) % ( *iter )->get( "terrtn" ) % ( *iter )->get( "exinf" );
          }
        }
        ostr << "}\n\n";

        return true;
      }

      const char termination_policy::name_[] = "termination";
      const char* const termination_policy::apis_[] = { "VATT_TER", 0 };
      const char* const termination_policy::params_[] = { "{ #teratr exinf terrtn }", 0, };

    }
  }
}
