/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/itron/specified_object.cpp
 */
#include "toppers/itron/specified_object.hpp"
#include <cctype>
#include <boost/lexical_cast.hpp>

namespace toppers
{
  namespace itron
  {

    /*!
     *  \brief  kernel_cfg.cւ̏o͏񐶐t@N^̊֐ĂяoZq
     *  \param  pinib   ubNւ̃X}[g|C^
     *  \return o͂镶Ԃ
     *
     *  RXgN^Ŏ󂯎ɊÂ pinib w
     *  ܂B
     *  Ɋ܂܂ '@' ɑ͏ubÑtB[h
     *  \܂B '@' ȍ~̃tB[h kernel_cfg::initial_block::get ɓnA
     *  ΉtB[h̒l擾܂B
     *
     *  tB[hɂ́A擪̂'$', '%', '#'܂܂Ă\܂BQڈȍ~
     *  ͉p܂͉łȂ΂Ȃ܂B
     *  tB[h̒ɉp≺ꍇA'\\'ŋ؂邱Ƃł܂B
     *  ̏ꍇA؂ɗp'\\'͖܂B
     */
    const std::string kernel_object_policy_base::generator::operator()( boost::shared_ptr<kernel_cfg::initial_block> pinib )
    {
      std::string str;
      std::string::const_iterator iter( format_.begin() ), last( format_.end() );
      while ( iter != last )
      {
        char ch = *iter;
        if ( ch != '@' )
        {
          str += ch;
          ++iter;
        }
        else
        {
          std::string key;
          switch ( *++iter )
          {
          case '@':
            str += '@';
            ++iter;
            continue;
          case '$':
          case '%':
          case '#':
            key = *iter;
            ++iter;
            break;
          }
          while ( iter != last )
          {
            ch = *iter;
            if ( !std::isalnum( static_cast<unsigned char>( ch ) ) && ch != '_' )
            {
              if ( ch == '\\' )
              {
                ++iter;
              }
              break;
            }
            key += ch;
            ++iter;
          }
          if ( key == "id" )  // "id"̏ꍇget֐Ŏ擾łȂ̂...
          {
            str += boost::lexical_cast<std::string>( pinib->id() );
          }
          else
          {
            str += pinib->get( key );
          }
        }
      }
      return str;
    }

    const char kernel_object_policy_base::name_[] = "";
    const char kernel_object_policy_base::symbol_[] = "";
    const char* const kernel_object_policy_base::apis_[] = { 0 };
    const char* const kernel_object_policy_base::params_[] = { 0 };
    const char* const kernel_object_policy_base::apis2_[] = { 0 };
    const char* const kernel_object_policy_base::params2_[] = { 0 };
    const char* const kernel_object_policy_base::prefix_ = 0;
    const char kernel_object_policy_base::region_format_[] = "";
    const char kernel_object_policy_base::init_format_[] = "";

  }
}
