/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/specified_object.hpp
 *  \brief  ̃J[lIuWFNgɊւ錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  class specified_object<Policy>;
 *  class kernel_object_policy_base;
 *  class kernel_object_policy_base::generator;
 *  \endcode
 */
#ifndef TOPPERS_ITRON_SPECIFIED_OBJECT_HPP_
#define TOPPERS_ITRON_SPECIFIED_OBJECT_HPP_

#include "toppers/itron/kernel_object.hpp"
#include "toppers/itron/static_api.hpp"
#include "toppers/itron/cfg_factory.hpp"
#include "toppers/misc.hpp"
#include <cstring>
#include <boost/format.hpp>

namespace toppers
{

  class s_record;
  class nm_symbol;

  namespace itron
  {

    class kernel_chk;

    /*!
     *  \class  specified_object kernel_object.hpp "toppers/itron/kernel_object.hpp"
     *  \brief  ̃J[lIuWFNgǗNX
     *
     *  kernel_object NXX̃IuWFNgɑΉ邽߂̏̃NX
     *  `܂B\n
     *  Ⴆ΁AZ}tHɊւ` semaphore_policy NX specified_object 
     *  ev[g Policy Ɏw肷邱Ƃōs܂B
     *
     *  ev[g Policy ɂ͎̃o^w肵ĂB
     *
     *  \code
     *  // RXgN^œnꂽɂāApinibwvf
     *  // ^typeɕϊt@N^
     *  class generator
     *  {
     *  public:
     *    explicit generator( const std::string& format );
     *    type operator()(  boost::shared_ptr<kernel_cfg::initial_block> pinib );
     *  };
     *
     *  // kernel_cfg.cւ̏o͏I[o[ChB
     *  static bool generate_kernel_cfg( const kernel_cfg& cfg, std::ostream& ostr );
     *
     *  // kernel_id.hւ̏o͏I[o[ChB
     *  static bool generate_kernel_id( const kernel_id& id_cfg, std::ostream& ostr );
     *
     *  // kernel_cfg.cւ̏݉\vf̏o͏LqB
     *  static void generate_regions( const kernel_cfg& cfg, std::ostream& ostr );
     *
     *  // kernel_cfg.cւ̏ubN̏o͏LqB
     *  static void generate_inits( const kernel_cfg& cfg, std::ostream& ostr );
     *
     *  // kernel_cfg.cւ̗̈vf̏o͏LqB
     *  static void generate_variables( const kernel_cfg& cfg, std::ostream& ostr );
     *
     *  // kernel_cfg.cւ̏ݕsvf̏o͏LqB
     *  static void generate_constants( const kernel_cfg& cfg, std::ostream& ostr );
     *
     *  // kernel_cfg.cւ̃AT[VR[h̏o͏LqB
     *  static void generate_assertions( const kernel_cfg& cfg, std::ostream& ostr );
     *
     *  // IuWFNgȂꍇkenrel_cfg.cւ__EMPTY_LABELo͏LqB
     *  static void generate_extra_empty_labels( std::ostream& ostr );
     *
     *  // ÓIAPỈ͏I[o[ChB
     *  // I[o[ChꍇtrueԂ
     *  bool analyze( kernel_object& obj, const static_api& api );
     *
     *  // ÓIAPỈ͌ʂ𔻒肷B
     *  bool verify( const static_api& api, kernel_object& obj );
     *
     *  // IDԍ͈̔̓`FbNsB
     *  bool check_id_range( long id );
     *
     *  static const bool use_id_;              // IDgꍇtrueAԍgꍇfalse
     *  static const char name_[];              // IuWFNg
     *  static const char symbol_[];            // O
     *  static const char* const apis_[];       // ȐÓIAPI̔z
     *  static const char* const params_[];     // ȐÓIAPĨp[^т̔z
     *  static const char* const apis_[];       // IȐÓIAPI̔z
     *  static const char* const params_[];     // IȐÓIAPĨp[^т̔z
     *  static const char prefix_[];            // ubŇ^ɎgvtBbNX
     *  static const char region_format_[];     // ̈`̏
     *  static const char init_format_[];       // ubN̏
     *  \endcode
     *
     *  \sa kernel_object_policy_base
     */
    template <class Policy>
    class specified_object : public kernel_object
    {
    public:
      typedef specified_object<Policy> self_t;

      /*!
       *  \brief  kernel_object ̍\z
       *  \param  api       ÓIAPI
       *  \param  container \z kernel_object i[pRei
       *  \return \zꂽ kernel_object ւ̃X}[g|C^
       *  \note   i[pReiƂēn̂ DEF_TEX ̂悤Ɋ kernel_object
       *          XVÓIAPȊΉ邽
       */
      static const boost::shared_ptr<kernel_object> build( const static_api& api, std::vector<boost::shared_ptr<kernel_object> >& container )
      {
        static_api::const_iterator iter( api.begin() );
        boost::shared_ptr<kernel_object> ptr;

        for ( int i = 0; Policy::apis_[i] != 0; i++ )
        {
          if ( *iter == Policy::apis_[0] )
          {
            ptr.reset( new self_t );
            if ( ptr->analyze( api ) )
            {
              container.push_back( ptr );
            }
          }
        }
        if ( !ptr )
        {
          // IAPȈ
          for ( int i = 0; Policy::apis2_[i] != 0; i++ )
          {
            if ( *iter == Policy::apis2_[i] )
            {
              typedef std::vector<boost::shared_ptr<kernel_object> >::const_iterator const_iterator;
              for ( const_iterator i( container.begin() ), t( container.end() ); i != t; ++i )
              {
                if ( std::strcmp( ( *i )->get_object_type(), Policy::name_ ) == 0 )
                {
                  if ( ( *i )->analyze( api ) )
                  {
                    return *i;
                  }
                }
              }
            }
          }
        }
        return ptr;
      }

      /*!
       *  \brief  kernel_cfg.c ̐
       *  \param  cfg   kernel_cfg.c 
       *  \param  ostr  o̓Xg[
       */
      static void generate_kernel_cfg( const kernel_cfg& cfg, std::ostream& ostr )
      {
        Policy::generate_kernel_cfg( cfg, ostr );
      }

      /*!
       *  \brief  kernel_id.h ̐
       *  \param  id_cfg  kernel_id.h 
       *  \param  ostr    o̓Xg[
       */
      static void generate_kernel_id( const kernel_id& id_cfg, std::ostream& ostr )
      {
        if ( Policy::use_id_ )
        {
          Policy::generate_kernel_id( id_cfg, ostr );
        }
      }
    protected:
      /*!
       *  \brief  ȐÓIAPỈ͏
       *  \param  api   ͂ÓIAPI
       *  \return ͂ɐꍇ true Ԃ
       *
       *  ̊֐ŉ͂ÓIAPȈ́A Policy::apis_  Policy::params_
       *  ̍ŏ̗vfgpB
       */
      bool analyze_primary( const static_api& api )
      {
        static_api::const_iterator iter( api.begin() );
        for ( int i = 0; Policy::apis_[i] != 0; i++ )
        {
          if ( *iter == Policy::apis_[i] )
          {
            self_t t;
            if ( !t.analyze_parameters( api, Policy::params_[i] ) )
            {
              break;
            }
            swap( t );
            return true;
          }
        }
        return false;
      }

      /*!
       *  \brief  IȐÓIAPỈ
       *  \param  api   ͂ÓIAPI
       *  \return ͂ɐꍇ true Ԃ
       *
       *  ̊֐́AႦ΃^XN̂悤ɁÃJ[lIuWFNgɊ֘A
       *  ÓIAPI݂ꍇɎgpB\n
       *  ̓Iɂ́A^XNł CRE_TSK ̉͂ analyze_primary ֐ōsA
       *  DEF_TSK ̉͂ analyze_secondary ōsƂɂȂB
       *
       *  ̊֐ŉ͂ÓIAPȈ́A Policy::apis_  Policy::params_
       *  ̂QԖڂ̗vfizY 1 `jȍ~gpB
       */
      bool analyze_secondary( const static_api& api )
      {
        static_api::const_iterator iter( api.begin() );
        for ( int i = 0; Policy::apis2_[i] != 0; i++ )
        {
          if ( *iter == Policy::apis2_[i] )
          {
            if ( id() < 0 && name().empty() )
            {
              break;
            }
            self_t t( *this );
            if ( !t.analyze_parameters( api, Policy::params2_[i] ) )
            {
              break;
            }
            if ( id() != t.id() || name() != t.name() )
            {
              break;
            }
            swap( t );
            return true;
          }
        }
        return false;
      }

      /*!
       *  ۂ̐ÓIAPỈ͈͂ȉ̎菇ōs܂B
       *
       *  -# Policy::analyze
       *  -# analyze_primary
       *  -# analyze_secondary
       *
       *  L̎菇̂Aŏɐi true ԂĂĵ͌ʂ
       *  č̗p܂B
       *  ͂ɐꍇ Policy::verify ɂĐ𔻒肵܂B
       */
      virtual bool do_analyze( const static_api& api )
      {
        bool result = Policy::analyze( api, *this );
        result = result || analyze_primary( api );
        result = result || analyze_secondary( api );
        result = result && Policy::verify( api, *this );
        return result;
      }
      virtual const char* do_get_object_type() const
      {
        return Policy::name_;
      }
      virtual bool do_has_id() const
      {
        return !!Policy::use_id_;
      }
      virtual bool do_check_id_range( long id ) const
      {
        if ( Policy::use_id_ )
        {
          return Policy::check_id_range( id );
        }
        return true;
      }
    };

    /*!
     *  \struct kernel_object_policy_base kernel_object.hpp "toppers/itron/kernel_object.hpp"
     *  \brief  specified_object ev[gNXɎw肷|V[̊NX
     *
     *  specified_object ev[gNX Policy ƂĎw肷^͂̃NX
     *  p邱ƂŋLqȗ邱Ƃł܂B
     */
    class kernel_object_policy_base
    {
    public:
      /*!
       *  \class  generator kernel_object.hpp "toppers/itron/kernel_object.hpp"
       *  \brief  specified_object<Plociy> NXv Policy::generator t@N^
       */
      class generator
      {
      public:
        explicit generator( const std::string& format ) : format_( format ) {}
        const std::string operator()( boost::shared_ptr<kernel_cfg::initial_block> pinib );
      private:
        std::string format_;
      };

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::generate_regions ֐
       *  \param  cfg   kernel_cfg.c 
       *  \param  ostr  o̓Xg[
       *
       *  ̊֐͉s܂B
       *  Kvɉ kernel_object_policy_base pNXœ̊֐
       *  `邱ƂŁAύX邱Ƃł܂B
       *  ̊֐͉z֐ł͂Ȃ߁A̕ύX͐ÓIɉ܂B
       */
      static void generate_regions( const kernel_cfg& cfg, std::ostream& ostr )
      {
      }

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::generate_inits ֐
       *  \param  cfg   kernel_cfg.c 
       *  \param  ostr  o̓Xg[
       *
       *  ̊֐͉s܂B
       *  Kvɉ kernel_object_policy_base pNXœ̊֐
       *  `邱ƂŁAύX邱Ƃł܂B
       *  ̊֐͉z֐ł͂Ȃ߁A̕ύX͐ÓIɉ܂B
       */
      static void generate_inits( const kernel_cfg& cfg, std::ostream& ostr )
      {
      }

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::generate_variables ֐
       *  \param  cfg   kernel_cfg.c 
       *  \param  ostr  o̓Xg[
       *
       *  ̊֐͉s܂B
       *  Kvɉ kernel_object_policy_base pNXœ̊֐
       *  `邱ƂŁAύX邱Ƃł܂B
       *  ̊֐͉z֐ł͂Ȃ߁A̕ύX͐ÓIɉ܂B
       */
      static void generate_variables( const kernel_cfg& cfg, std::ostream& ostr )
      {
      }

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::generate_constants ֐
       *  \param  cfg   kernel_cfg.c 
       *  \param  ostr  o̓Xg[
       *
       *  ̊֐͉s܂B
       *  Kvɉ kernel_object_policy_base pNXœ̊֐
       *  `邱ƂŁAύX邱Ƃł܂B
       *  ̊֐͉z֐ł͂Ȃ߁A̕ύX͐ÓIɉ܂B
       */
      static void generate_constants( const kernel_cfg& cfg, std::ostream& ostr )
      {
      }

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::generate_assertions ֐
       *  \param  cfg   kernel_cfg.c 
       *  \param  ostr  o̓Xg[
       *
       *  ̊֐͉s܂B
       *  Kvɉ kernel_object_policy_base pNXœ̊֐
       *  `邱ƂŁAύX邱Ƃł܂B
       *  ̊֐͉z֐ł͂Ȃ߁A̕ύX͐ÓIɉ܂B
       */
      static void generate_assertions( const kernel_cfg& cfg, std::ostream& ostr )
      {
      }

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::generate_extra_empty_labels ֐
       *  \param  ostr  o̓Xg[
       *
       *  ̊֐͉s܂B
       *  Kvɉ kernel_object_policy_base pNXœ̊֐
       *  `邱ƂŁAύX邱Ƃł܂B
       *  ̊֐͉z֐ł͂Ȃ߁A̕ύX͐ÓIɉ܂B
       */
      static void generate_extra_empty_labels( std::ostream& ostr )
      {
      }

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::analyze ֐
       *  \param  api   ͑Ώۂ̐ÓIAPI
       *  \param  obj   J[lIuWFNg
       *  \return  false Ԃ
       *
       *  ̊֐͏ false Ԃ܂B
       *  Kvɉ kernel_object_policy_base pNXœ̊֐
       *  `邱ƂŁAύX邱Ƃł܂B
       *  ̊֐͉z֐ł͂Ȃ߁A̕ύX͐ÓIɉ܂B
       */
      static bool analyze( const static_api& api, kernel_object& obj )
      {
        return false;
      }

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::verify ֐
       *  \param  api   ͑Ώۂ̐ÓIAPI
       *  \param  obj   J[lIuWFNg
       *  \return 茋ʂł true ԂB
       *
       *  ̊֐͏ true Ԃ܂B
       *  Kvɉ kernel_object_policy_base pNXœ̊֐
       *  `邱ƂŁAύX邱Ƃł܂B
       *  ̊֐͉z֐ł͂Ȃ߁A̕ύX͐ÓIɉ܂B
       */
      static bool verify( const static_api& api, kernel_object& obj )
      {
        return true;
      }

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::check_id_range ֐
       *  \param  id   ΏۂIDԍ
       *  \return 茋ʂł true ԂB
       *  \note   ̊֐ use_id_ != 0 ̏ꍇĂяo܂B
       */
      static bool check_id_range( long id )
      {
        return id > 0;
      }

      /*!
       *  \param  chk   "kernel_chk.srec"t@C̃[hf[^
       *  \param  srec  [hW[iSR[hj̃[hf[^
       *  \param  syms  [hW[̃V{e[u
       *  \return `FbNɐꍇ true Ԃ
       */
      static bool check( const kernel_chk& chk, const s_record& srec, const nm_symbol& syms )
      {
        return true;
      }

      /*!
       *  \brief  specified_object<Plociy> NXv Policy::use_id_ 萔
       *
       *  kernel_object_policy_base NXł true ɒ`Ă܂B
       *  IDԍł͂ȂAIuWFNgԍgpꍇ́Akernel_object_policy_base
       *  pNXœ̃oĒ`ĂB
       */
      enum { use_id_ = true };     
      static const char name_[];
      static const char symbol_[];
      static const char* const apis_[];
      static const char* const params_[];
      static const char* const apis2_[];
      static const char* const params2_[];
      static const char* const prefix_;
      static const char region_format_[];
      static const char init_format_[];
    };

  }
}

#endif  // ! TOPPERS_ITRON_SPECIFIED_OBJECT_HPP_
