/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/static_api.hpp
 *  \brief  ÓIAPIɊւ錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  class static_api;
 *  \endcode
 */
#ifndef TOPPERS_STATIC_API_HPP_
#define TOPPERS_STATIC_API_HPP_

#include "toppers/reporter.hpp"
#include "toppers/codeset.hpp"
#include "toppers/text.hpp"

namespace toppers
{

  namespace itron
  {

    /*!
     *  \class  static_api static_api.hpp "toppers/itron/static_api.hpp"
     *  \brief  ÓIAPĨp[^i[邽߂̃NX
     *
     *  ̃NX̓RtBM[Vt@CɌÓIAPĨp[^i[܂B
     *  ۂɊi[p[^́AAPIƊep[^̑ApPbg𔻕ʂ邽߂
     *  '{''}'łB\n
     *  Ⴆ΁ACRE_SEM(SEMID1, { TA_TFIFO, 0, 1 });ł΁A\n
     *  "CRE_SEM", "SEMID1", "{", "TA_TFIFO", "0", "1", "}"\n
     *  Ƃp[^񂪊i[܂B
     */
    class static_api
    {
    public:
      typedef std::vector<std::string>::value_type value_type;
      typedef std::vector<std::string>::const_iterator const_iterator;
      typedef std::vector<std::string>::const_reference const_reference;
      typedef std::vector<std::string>::size_type size_type;
      typedef text_line line_type;

      /*!
       *  \brief  p[^̐擪ʒu̎擾
       *  \return p[^̐擪ʒuԂ
       */
      const_iterator begin() const { return tokens_.begin(); }
      /*!
       *  \brief  p[^̏I[ʒu+1̎擾
       *  \return p[^̏I[ʒuԂ
       */
      const_iterator end() const { return tokens_.end(); }
      /*!
       *  \brief  wʒũp[^̎Q
       *  \param  index   ʒuw肷邽߂̃CfbNX
       *  \return index Ŏw肳ꂽp[^̎QƂԂ
       */
      const_reference operator[]( size_type index ) const { return tokens_[index]; }
      /*!
       *  \brief  p[^̗vf̎擾
       *  \return p[^̗vfԂ
       */
      size_type size() const { return tokens_.size(); }
      /*!
       *  \brief  p[^񂪋ł邩ǂ̔
       *  \return p[^񂪋ł true Ԃ
       */
      bool empty() const { return tokens_.empty(); }

      /*!
       *  \brief  p[^̊i[
       *  \param  first p[^̐擪ʒu
       *  \param  last  p[^̏I[ʒu+1
       */
      template <typename Iterator>
      void assign( Iterator first, Iterator last )
      {
        tokens_.assign( first, last );
      }

      /*!
       *  \brief  ÓIAPI̐擪ʒuꂽsԍ̎擾
       *  \return sԍԂ
       */
      const line_type& line() const { return line_; }
      /*!
       *  \brief  ÓIAPI̐擪ʒuꂽsԍ̐ݒ
       *  \param  value ݒ肷sԍ
       */
      void line( const line_type& value ) { line_ = value; }

      void swap( static_api& other ) throw();

      bool parse( text::const_iterator& next, text::const_iterator last, bool ucn = false, codeset_t codeset = ascii );
    private:
      std::vector<std::string> tokens_;
      line_type line_;
    };

  }

}

#endif  // ! TOPPERS_STATIC_API_HPP_
