/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2004 by Witz Corporation, JAPAN  
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/kernel_cfg.cpp
 */
#include "toppers/kernel_cfg.hpp"
#include <cassert>
#include <algorithm>

namespace toppers
{

  /*!
   *  \brief  ftHgRXgN^
   */
  kernel_cfg::initial_block::initial_block() : id_( -1L )
  {
  }

  /*!
   *  \brief  IuWFNgIDԍ̎Q
   *  \return IDԍԂ
   */
  long kernel_cfg::initial_block::id() const
  {
    return id_;
  }

  /*!
   *  \brief  IuWFNgIDԍ̐ݒ
   *  \param  value IDԍ̒l
   */
  void kernel_cfg::initial_block::id( long value )
  {
    id_ = value;
  }

  /*!
   *  \brief  ubÑtB[h擾
   *  \param  key   tB[h\L[
   *  \return tB[hlij
   */
  const std::string& kernel_cfg::initial_block::get( const std::string& key ) const
  {
    std::map<std::string, std::string>::const_iterator iter( field_map_.find( key ) );
    if ( iter == field_map_.end() )
    {
      static const std::string dummy;
      return dummy;
    }
    return iter->second;
  }

  /*!
   *  \brief  tB[h̒li[
   *  \param  key   tB[hw肷L[
   *  \param  field i[lij
   */
  void kernel_cfg::initial_block::set( const std::string& key, const std::string& field )
  {
    std::string t( field ); // OS΍
    field_map_[key].swap( t );
  }

  /*!
   *  \brief  X}[g|C^ubN̔r
   *  \param  lhs   
   *  \param  rhs   E
   *  \retval true  lhs < rhs
   *  \retval false lhs >= rhs
   *
   *  ̊֐́Astd::sortstd::map̔r֐ƂĎgp邽߂̂̂łB
   *  rIDԍ̒PɔrĂ܂B
   */
  bool kernel_cfg::initial_block::less_than( const boost::shared_ptr<initial_block> lhs, const boost::shared_ptr<initial_block> rhs )
  {
    return lhs->id() < rhs->id();
  }

  /*!
   *  \brief  tB[h̒l̎Q
   *  \param  inib_ptr  ubNւ̃X}[g|C^
   *  \param  key       tB[h肷邽߂̃L[
   *  \return tB[h̒lijԂ
   */
  const std::string& kernel_cfg::initial_block::get_field( const boost::shared_ptr<initial_block>& inib_ptr, const std::string& key )
  {
    return inib_ptr->get( key );
  }

  /*!
   *  \brief  RXgN^
   *  \param  file    o̓t@Ciex. kernel_cfg.cj
   *  \param  id_file ID`wb_t@Ciex. kernel_id.hj
   */
  kernel_cfg::kernel_cfg( const std::string& file, const std::string& id_file )
    : cfg_base( file ), id_file_( id_file )
  {
  }

  /*!
   *  \brief  ID`wb_t@C̎擾
   *  \return t@CԂ
   */
  const std::string & kernel_cfg::id_file() const
  {
    return id_file_;
  }

  /*!
   *  \brief  t@Co͂̎
   *  \param  ostr  o̓Xg[
   *
   *  ̊֐ł̓t@Cwb_ƃ{fBɍs܂B
   *  ۂ̏do_file_headerdo_bodyɈϏB
   */
  bool kernel_cfg::do_save( std::ostream& ostr ) const
  {
    do_file_header( ostr );
    do_body( ostr );
    return true;
  }

  /*!
   *  \brief  ubN̑}
   *  \param  key   IuWFNgʂ肷邽߂̕
   *  \param  inib  ubN
   */
  void kernel_cfg::insert_inib( const std::string& key, const boost::shared_ptr<initial_block>& inib )
  {
    if ( inib )
    {
      inib_map_[key].push_back( inib );
    }
  }

  /*!
   *  \brief  ubNz̎Q
   *  \param  key   IuWFNgʂ肷邽߂̕
   *  \return ubNzԂ
   */
  const kernel_cfg::inib_array* kernel_cfg::get_inib_array( const std::string& key ) const
  {
    inib_array_map::const_iterator iter( inib_map_.find( key ) );
    if ( iter == inib_map_.end() )
    {
      static inib_array dummy;
      return &dummy;
    }
    return &iter->second;
  }

  /*!
   *  \brief  ubÑNA
   *  \param  key NA鏉ubN肷L[
   */
  void kernel_cfg::clear_inib_array( const std::string& key )
  {
    inib_map_[key].clear();
  }

}
