/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2004 by Witz Corporation, JAPAN  
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/kernel_id.hpp
 */
#include "toppers/kernel_id.hpp"
#include "toppers/reporter.hpp"
#include <cctype>
#include <ctime>
#include <cstdio>
#include <algorithm>
#include <fstream>
#include <sstream>
#include <boost/format.hpp>
#include <boost/filesystem/path.hpp>

namespace toppers
{

  /*!
   *  \brief  RXgN^
   *  \param  file  t@C
   */
  cfg_base::cfg_base( const std::string& file ) : file_( file )
  {
  }

  /*!
   *  \brief  ݒt@C̃Z[u
   *
   *  ̊֐́AŕێĂ閼Õt@CɁA do_save z֐
   *  `ꂽeo͂܂B\n
   *  do_save ɓno̓Xg[͓IȂ̂łȂɂ
   *  ڃt@Cɏ܂邱Ƃ͂܂BiOŜ߁j
   */
  void cfg_base::save() const
  {
    std::ostringstream osstr;
    if ( do_save( osstr ) )
    {
      try
      {
        std::ofstream ofstr( file_.c_str() );
        if ( ofstr.fail() )
        {
          rout.error( _( "cannot create file `%1%\'" ) % file_ );
        }
        ofstr << osstr.str() << std::endl;
        ofstr.close();
        do_depend();
      }
      catch ( ... )
      {
        std::remove( file_.c_str() );
        throw;
      }
    }
  }

  /*!
   *  \brief  t@C̎Q
   *  \return t@CԂ
   */
  const std::string cfg_base::file() const
  {
    boost::filesystem::path path( file_, boost::filesystem::native );
    return path.leaf();
  }

  /*!
   *  \brief  t@C̃wb_̏o
   *  \param  ostr  o̓Xg[
   */
  void cfg_base::do_file_header( std::ostream& ostr ) const
  {
    std::time_t t = std::time( 0 );
    ostr << boost::format( "/*\n"
                           " *  %1%\n"
                           " *  %2%"  // ctimeԂ͉stȂ̂'\n'ȗ
                           " */\n" ) % file() % std::ctime( &t );
  }

  /*!
   *  \brief  ^[Qbgˑ
   *
   *  M32C̃xN^e[uȂǁA^[QbgɈˑ鏈sKvꍇ
   *  ̉z֐I[o[ChĂB
   */
  void cfg_base::do_depend() const
  {
  }

  /*!
   *  \brief  ftHgRXgN^
   */
  kernel_id::id_number::id_number() : id_( -1L )
  {
  }

  /*!
   *  \brief  IuWFNg̎Q
   *  \return IuWFNgԂ
   */
  const std::string& kernel_id::id_number::name() const
  {
    return name_;
  }

  /*!
   *  \brief  IDԍ̎Q
   *  \retval -1L     IDԍݒ肳ĂȂ
   *  \retval 0ȏ  IDԍ̒lԂ
   */
  long kernel_id::id_number::value() const
  {
    return id_;
  }

  /*!
   *  \brief  IuWFNgIDԍ̐ݒ
   *  \param  name  IuWFNg
   *  \param  id    IDԍ
   */
  void kernel_id::id_number::set( const std::string& name, long id )
  {
    name_ = name;
    id_ = id;
  }

  /*!
   *  \brief  X}[g|C^IDԍ̔r
   *  \param  lhs   
   *  \param  rhs   E
   *  \retval true  lhs < rhs
   *  \retval false lhs >= rhs
   *
   *  ̊֐́Astd::sortstd::map̔r֐ƂĎgp邽߂̂̂łB
   */
  bool kernel_id::id_number::less_than( const boost::shared_ptr<id_number> lhs, const boost::shared_ptr<id_number> rhs )
  {
    return lhs->id_ < rhs->id_;
  }

  /*!
   *  \brief  RXgN^
   *  \param  file  t@C
   */
  kernel_id::kernel_id( const std::string& file ) : cfg_base( file )
  {
  }

  /*!
   *  \brief  id_number ̎Q
   *  \param  key   id_number 肷L[BʏAIuWFNg
   *  \return key ɑΉ id_number ւ̃|C^Ԃ
   */
  const kernel_id::id_array* kernel_id::get_id_array( const std::string& key ) const
  {
    std::map<std::string, id_array>::const_iterator iter( id_map_.find( key ) );
    if ( iter == id_map_.end() )
    {
      return 0;
    }
    return &iter->second;
  }

  /*!
   *  \brief  id_number ̑}
   *  \param  key   id_number 肷L[BʏAIuWFNg
   *  \param  value } id_numeber ւ̃X}[g|C^
   */
  void kernel_id::insert_id( const std::string& key, const boost::shared_ptr<id_number>& value )
  {
    if ( value )
    {
      id_map_[key].push_back( value );
    }
  }

  /*!
   *  \brief  id_number ̏
   *  \param  key id_number 肷L[BʏAIuWFNg
   */
  void kernel_id::clear_id_array( const std::string& key )
  {
    id_map_[key].clear();
  }

  bool kernel_id::do_save( std::ostream& ostr ) const
  {
    do_file_header( ostr );

    const std::string macro( include_guard_macro( file() ) );
    ostr << boost::format( "#ifndef %1%\n"
                           "#define %1%\n" ) % macro;
    ostr << '\n';
    do_body( ostr );
    ostr << boost::format( "#endif\t/* ! %1% */\n" ) % macro;
    return true;
  }

  /*!
   *  \fn     bool cfg_base::do_save( std::ostream& ostr ) const
   *  \brief  t@Co͓e̋K
   *  \param  ostr  o̓Xg[
   *  \retval true  t@CɏޕKv
   *  \retval false t@CɏݕKvȂ
   */

  /*!
   *  \fn     void cfg_base::do_body( std::ostream& ostr ) const
   *  \brief  t@Co͓e̎v̋K
   *  \param  ostr  o̓Xg[
   */

  /*!
   *  \brief  CN[hK[hp̃}N̐
   *  \param  file  t@C
   *  \return }N
   *
   *  t@CɑΉCN[hK[hp̃}N𐶐܂B
   *  [́Apׂ͂đ啶ɕϊApȊO͉ɕϊ܂B
   *  Ⴆ΁At@Ckernel_id.hłKERNEL_ID_HƂȂ܂B
   */
  const std::string kernel_id::include_guard_macro( const std::string& file )
  {
    std::stringstream sstr;
    const std::string::const_iterator last( file.end() );
    for ( std::string::const_iterator iter( file.begin() ); iter != last; ++iter )
    {
      int ch = static_cast<unsigned char>( *iter );
      if ( std::isalnum( ch ) )
      {
        sstr << static_cast<char>( std::toupper( ch ) );
      }
      else if ( std::ispunct( ch ) || ch == ' ' )
      {
        sstr << '_';
      }
      else
      {
        sstr << 'x' << std::hex << ch;
      }
    }
    return sstr.str();
  }

}
