/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  toppers/nm_symbol.cpp
 */
#include "toppers/nm_symbol.hpp"
#include <istream>
#include <sstream>
#include <cctype>

namespace toppers
{

  /*!
   *  \brief  V{e[ũ[h
   *  \param  istr  ̓Xg[
   */
  void nm_symbol::load( std::istream& istr )
  {
    while ( istr )
    {
      std::string buf;
      std::getline( istr, buf );
      std::istringstream isstr( buf );

      unsigned long address = 0;
      char type;
      std::string symbol;
      if ( !std::isspace( buf[0] ) )
      {
        isstr >> std::hex >> address;
      }
      isstr >> type >> symbol;

      if ( !symbol.empty() )
      {
        entry e;
        e.address = address;
        e.type = static_cast<unsigned char>( type );
        symbol_map_[symbol] = e;
      }
    }
  }

  /*!
   *  \brief  V{̒T
   *  \param  symbol  TV{
   *  \return V{ɑΉGgԂ
   */
  const nm_symbol::entry nm_symbol::find( const std::string& symbol ) const
  {
    std::map<std::string, entry>::const_iterator iter( symbol_map_.find( symbol ) );
    entry e = { 0, -1 };
    if ( iter != symbol_map_.end() )
    {
      e = iter->second;
    }
    else
    {
      iter = symbol_map_.find( "_" + symbol );  // ʎq'_'tꍇɑΉ
      if ( iter != symbol_map_.end() )
      {
        e = iter->second;
      }
    }
    return e;
  }

}
