/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: cpu_config.c,v 1.4 2007/02/05 04:55:37 honda Exp $
 */

/*
 *	ץå¸⥸塼ARMѡ
 */

#include "fdmp_kernel.h"
#include "check.h"
#include <arm.h>
#include "task.h"

/*
 * 㳰٥˽񤭹ޤ줿̿᤬Ȥ륢ɥ쥹
 * 
 */
//UW *arm_vector_add[8];


/*
 * 㳰˱ϥɥεư
 */
UW arm_handler_add[8];


/*
 * ߤΥͥȲΥ
 */
UW interrupt_count;


/*
 * CPU/ߥϥɥνǰŪ˻Ѥ륹å
 */
UW int_stack[INT_STACK_SIZE];


/*
 *  CPU㳰ϥɥ
 */
void
define_exc(EXCNO excno, FP exchdr)
{
    arm_install_handler(excno,exchdr);
}


/*
 * ǥեȤ㳰ϥɥ
 */

void
undef_exception(){
    syslog(LOG_EMERG, "Unregistered Exception occurs. UNDEF");
    kernel_exit();
}

void
swi_exception(){
    syslog(LOG_EMERG, "Unregistered Exception occurs. SWI");
    kernel_exit();
}

void
prefetch_exception(){
    syslog(LOG_EMERG, "Unregistered Exception occurs. PREFETCH");
    kernel_exit();
}

void
data_abort_exception(){
    syslog(LOG_EMERG, "Unregistered Exception occurs. DATA ABORT");
    kernel_exit();
}


void
irq_exception(){
    syslog(LOG_EMERG, "Unregistered Exception occurs. IRQ");
    kernel_exit();
}

void
fiq_exception(){
    syslog(LOG_EMERG, "Unregistered Exception occurs. FIQ");
    kernel_exit();
}



/*
 *  ץå¸ν
 */
void
cpu_initialize()
{
	interrupt_count = 1;

    /*
     * ǥեȤ㳰ϥɥϿ
     */
    arm_install_handler(UND_Number, undef_exception);
    arm_install_handler(SWI_Number, swi_exception);
    arm_install_handler(PRFA_Number, prefetch_exception);
    arm_install_handler(DATAA_Number, data_abort_exception);
    arm_install_handler(IRQ_Number, irq_exception);
    arm_install_handler(FIQ_Number, fiq_exception);
}


/*
 *  ץå¸νλ
 */
void
cpu_terminate()
{
}
