/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003      by Advanced Data Controls, Corp
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ct11mpcore_eb.c,v 1.4 2007/07/18 01:57:53 honda Exp $
 *  
 */

/*
 * ARM CT11MPCore with the RealView Emulation Boardѥɥ饤
 */
#include <s_services.h>
#include <ct11mpcore_eb.h>


/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {
#if EB_UART_NO ==  0
    {
		(VP)EB_UART0_BASE,
		DIC_INTID_EB_UART0
    }
#elif EB_UART_NO ==  1
    {
		(VP)EB_UART1_BASE,
		DIC_INTID_EB_UART1
    }	
#elif EB_UART_NO ==  2
    {
		(VP)EB_UART2_BASE,
		DIC_INTID_EB_UART2
    }		
#elif EB_UART_NO ==  3
    {
		(VP)EB_UART3_BASE,
		DIC_INTID_EB_UART3
    }		
#endif /* EB_UART_NO ==  0 */	
};


/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB  siopcb_table[TNUM_SIOP];


/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)  ((UINT)((siopid) - 1))
#define get_siopcb(siopid)  (&(siopcb_table[INDEX_SIOP(siopid)]))


/*
 * ʸ?
 */ 
Inline BOOL
uart_getready(SIOPCB *siopcb)
{
	return ((sil_rew_mem((VP)(siopcb->siopinib->reg_base + EB_UART_FR))
			 & EB_UART_FR_RXFE) != EB_UART_FR_RXFE);
}

/*
 * ʸǤ뤫?
 */
Inline BOOL
uart_putready(SIOPCB *siopcb)
{
	return ((sil_rew_mem((VP)(siopcb->siopinib->reg_base + EB_UART_FR))
			 & EB_UART_FR_TXFF) != EB_UART_FR_TXFF);
}

/*
 *  ʸμФ
 */
Inline UB
uart_getchar(SIOPCB *siopcb)
{
	return ((UB)sil_rew_mem((VP)(siopcb->siopinib->reg_base + EB_UART_DR)));
}

/*
 *  ʸν񤭹
 */
Inline void
uart_putchar(SIOPCB *siopcb, UB c)
{
	sil_wrw_mem((VP)(siopcb->siopinib->reg_base + EB_UART_DR), c);
}

/*
 *  ߵ
 */
Inline void
uart_enable_send(SIOPCB *siopcb)
{
	sil_wrw_mem((VP)(siopcb->siopinib->reg_base + EB_UART_IMSC),
				sil_rew_mem((VP)(siopcb->siopinib->reg_base + EB_UART_IMSC))
				| EB_UART_IMSC_TXIM);
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_send(SIOPCB *siopcb)
{
	sil_wrw_mem((VP)(siopcb->siopinib->reg_base + EB_UART_IMSC),
				sil_rew_mem((VP)(siopcb->siopinib->reg_base + EB_UART_IMSC))
				& ~EB_UART_IMSC_TXIM);
}


/*
 *  ߵ
 */
Inline void
uart_enable_rcv(SIOPCB *siopcb)
{
	sil_wrw_mem((VP)(siopcb->siopinib->reg_base + EB_UART_IMSC),
				sil_rew_mem((VP)(siopcb->siopinib->reg_base + EB_UART_IMSC))
				| EB_UART_IMSC_RXIM);
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_rcv(SIOPCB *siopcb)
{
	sil_wrw_mem((VP)(siopcb->siopinib->reg_base + EB_UART_IMSC),
				sil_rew_mem((VP)(siopcb->siopinib->reg_base + EB_UART_IMSC))
				& ~EB_UART_IMSC_RXIM);
}

/*
 * ͥ뵯ưΥѤν
 */
void
uart_init(SIOPCB *siopcb){
	char c;
	
	/* UART */
	sil_wrw_mem((VP)(siopcb->siopinib->reg_base + EB_UART_CR), 0x00);

	/* FIFOˤ */
	while(uart_getready(siopcb)){
		/* Хåեɤ߹ */
		c = uart_getchar(siopcb);
	}

	/* ܡ졼Ȥ */
	sil_wrw_mem((VP)(siopcb->siopinib->reg_base + EB_UART_IBRD), EB_UART_IBRD_38400);
	sil_wrw_mem((VP)(siopcb->siopinib->reg_base + EB_UART_FBRD), EB_UART_FBRD_38400);
	
	/*
     * FIFO, ǡĹ8bit, 1stopӥå,
	 */
	sil_wrw_mem((VP)(siopcb->siopinib->reg_base + EB_UART_LCR_H),
				 EB_UART_LCR_H_WLEN_8);
		
	/* UARTƳ */
	sil_wrw_mem((VP)(siopcb->siopinib->reg_base + EB_UART_CR),
				sil_rew_mem((VP)(siopcb->siopinib->reg_base + EB_UART_CR))
				| EB_UART_CR_RXE | EB_UART_CR_TXE | EB_UART_CR_UARTEN);
}

/*
 * ܡɵưν
 */
void
eb_uart_init(void){
	SIOPCB  siopcb; /* ߡѰ */
	
	siopcb.siopinib = &(siopinib_table[0]);
	uart_init(&siopcb);
}

/*
 *  åפUARTΥݡ󥰽
 */
void
uart_putc(char c)
{
	SIOPCB  siopcb; /* ߡѰ */
	
	siopcb.siopinib = &(siopinib_table[0]);
	while(!uart_putready(&siopcb));
	uart_putchar(&siopcb, c);
}

/*
 *  SIOɥ饤Фν롼
 */
void
uart_initialize()
{
    SIOPCB  *siopcb;
    UINT    i;

    /*
     *  ꥢI/Oݡȴ֥åν
     */
    for (siopcb = siopcb_table, i = 0; i < TNUM_SIOP; siopcb++, i++) {
        siopcb->siopinib = &(siopinib_table[i]);
        siopcb->openflag = FALSE;
        siopcb->sendflag = FALSE;
    }
}


/*
 * ץ󤷤ƤݡȤ뤫
 */
BOOL
uart_openflag(void)
{
    SIOPCB  *siopcb;
    UINT    i;

	for (siopcb = siopcb_table, i = 0; i < TNUM_SIOP; siopcb++, i++) {
		siopcb->siopinib = &(siopinib_table[i]);
		if(siopcb->openflag == TRUE){
			return TRUE;
		}
	}
	
    return FALSE;
}


/*
 * ꥢI/OݡȤΥץ
 */
SIOPCB *
uart_opn_por(ID siopid, VP_INT exinf)
{
    SIOPCB      *siopcb;
    const SIOPINIB  *siopinib;

    siopcb = get_siopcb(siopid);
    siopinib = siopcb->siopinib;

	/*  */
	uart_init(siopcb);
    
    siopcb->exinf = exinf;
    siopcb->getready = siopcb->putready = FALSE;
    siopcb->openflag = TRUE;

    return(siopcb);    
}


/*
 *  ꥢI/OݡȤΥ
 */
void
uart_cls_por(SIOPCB *siopcb)
{
    siopcb->openflag = FALSE;
}


/*
 *  ꥢI/OݡȤؤʸ
 */
BOOL
uart_snd_chr(SIOPCB *siopcb, char c)
{
    if (uart_putready(siopcb)){
        uart_putchar(siopcb, c);
        return(TRUE);
    }
    return(FALSE);
}


/*
 *  ꥢI/OݡȤʸ
 */
INT
uart_rcv_chr(SIOPCB *siopcb)
{
    if (uart_getready(siopcb)) {
        return((INT)(UB) uart_getchar(siopcb));
    }
    return(-1);
}


/*
 *  ꥢI/OݡȤΥХåε
 */
void
uart_ena_cbr(SIOPCB *siopcb, UINT cbrtn)
{
    switch (cbrtn) {
        case SIO_ERDY_SND:
            uart_enable_send(siopcb);
            break;
        case SIO_ERDY_RCV:
            uart_enable_rcv(siopcb);
            break;
    }
}


/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
uart_dis_cbr(SIOPCB *siopcb, UINT cbrtn)
{
    switch (cbrtn) {
        case SIO_ERDY_SND:
            uart_disable_send(siopcb);
            break;
        case SIO_ERDY_RCV:
            uart_disable_rcv(siopcb);
            break;
    }
}


/*
 *  ꥢI/OݡȤФ߽
 */
static void
uart_isr_siop(SIOPCB *siopcb)
{
    if (uart_getready(siopcb)) {
        /*
         *  ΥХå롼ƤӽФ
         */
        uart_ierdy_rcv(siopcb->exinf);
    }
    if (uart_putready(siopcb)) {
        /*
         *  ǽХå롼ƤӽФ
         */
        uart_ierdy_snd(siopcb->exinf);
    }
}


/*
 *  SIOγߥӥ롼
 */
void
uart_isr()
{
    uart_isr_siop(&(siopcb_table[0]));
}


/*
 *
 * SCUϢδؿ
 *  
 */

/*
 * CP15AUXILIARY쥸SAӥåȤ򥻥åȤSMP⡼ɤˤ
 */
Inline void
enable_sa(void){
    UINT bits;

    CP15_AUXILIARY_READ(bits);
    bits |= CP15_AUXILIARY_SA_BIT;
    CP15_AUXILIARY_WRITE(bits);
}


Inline void
scu_enable(void){
    UINT scu_ctrl;
    
    /* SCUͭ */
    scu_ctrl  = sil_rew_mem((void *)MPCORE_SCU_CTRL);
    scu_ctrl |= MPCORE_SCU_CTRL_EN;
    sil_wrw_mem((void *)MPCORE_SCU_CTRL, scu_ctrl);
}


/*
 * SMP⡼ɤꤹ
 */
void
mpcore_smp_mode_enable(void){
    UINT sr;
    
    /* ߶ػ */
    sr = current_sr();
    set_sr(sr|CPSR_IRQ_BIT|CPSR_FIQ_BIT);

    /* 㥷򥯥꡼ */
    mpcore_dcache_clean_and_invalidate();
    mpcore_icache_invalidate();

    /* Data Synchronization Barrier */
    mpcore_data_sync_barrier();

    /* TLBν */
    mpcore_invalidate_unfied_tlb();

    /* CP15SMP/nAMP bit 򥻥åȤ */
    enable_sa();
    
#if PE1
    /* SCU ͭˤ SMP⡼ɤ˥åȤ */    
    scu_enable();
#endif    
    
    /* ߶ػ߾֤򸵤᤹ */
    set_sr(sr);
}



/*
 * åϢν
 */

/*
 * Då򳫻
 */
void
mpcore_dcache_enable(void)
{
    UINT bits;

    CP15_CONTROL_READ(bits);

    /* ǤONʤ꥿ */
    if (bits & CP15_CONTROL_C_BIT){
        return;
    }

    mpcore_dcache_invalidate();

    bits |= CP15_CONTROL_C_BIT;
    CP15_CONTROL_WRITE(bits);
}


/*
 * Då
 */
void
mpcore_dcache_disable(void)
{
    UINT bits;

    CP15_CONTROL_READ(bits);
    bits &= ~CP15_CONTROL_C_BIT;
    CP15_CONTROL_WRITE(bits);

    mpcore_dcache_clean_and_invalidate();
}


/*
 * Iåγ
 */
void
mpcore_icache_enable(void)
{
    UINT bits;
    
    CP15_CONTROL_READ(bits);

    /*
     * Ǥͭʤ꥿
     */
    if(bits & CP15_CONTROL_I_BIT){
        return;
    }

    mpcore_icache_invalidate();

    bits |= CP15_CONTROL_I_BIT;
    CP15_CONTROL_WRITE(bits);
}


/*
 * Iå
 */
void
mpcore_icache_disable(void)
{
    UINT bits;
    
    CP15_CONTROL_READ(bits);
    bits &= ~CP15_CONTROL_I_BIT;
    CP15_CONTROL_WRITE(bits);
 
    mpcore_icache_invalidate();
}


/*
 * I/Dåξ򳫻
 */
void
mpcore_cache_enable(void)
{
    mpcore_dcache_enable();
    mpcore_icache_enable();
}


/*
 * I/Dåξ
 */
void
mpcore_cache_disable(void)
{
    mpcore_dcache_disable();
    mpcore_icache_disable();
}



/*
 * MMUϢΥ
 */


/*
 * Υ١ɥ쥹ȥ
 */
#define SDRAM_ADDR 0x00000000
#define SRAM_ADDR  0x48000000

#define SDRAM_SIZE 0x08000000 /* 128MB */
#define SRAM_SIZE  0x00200000 /*   1MB */

#define SIZE_1M    0x00100000

#define DOMAIN_NO  1

#define PAGE_TABLE_SIZE  0x00004000 /* 4KB */ 

/*
 * Ѵơ֥ؤ
 * va   : ۥɥ쥹
 * pa   : ʪɥ쥹
 * size :  
 * s    : ͭ
 * tex  : C BȤȤ߹碌Ѳ
 * ap   : 
 * c    : å
 * c    : Хåե
 */
typedef struct{
    UINT   va;
    UINT   pa;
    UINT   size;    
    UB     s;
    UB     tex;
    UB     ap;
    UB     c;
    UB     b;    
}MEMORY_ATTRIBUTE;


/*
 * ڡơ֥
 */
UB PabeTable[PAGE_TABLE_SIZE];


/*
 * ڡơ֥Υꤹ
 */
static void
mmu_set_section(UINT va, UINT pa,
                UB s, UB tex, UB ap, 
                UB c, UB b)
{
    UINT ttb;
    UINT *sptr;

    /*
     * ڡơ֥Υ١ɥ쥹
     */
    CP15_TTB0_READ(ttb);

    /*
     * VA饻Υɥ쥹
     */
    sptr  = (UINT *)((ttb & 0xFFFFC000) | (((va & 0xFFF00000) >> 20) << 2));
    *sptr = pa | (s << 16) | (tex << 12) | (ap << 10) | (c << 3) | (b << 2) | (1 << 1);
}


/*
 * ˽,Υޥåԥ󥰤Ԥ
 * ޥåԥ󥰤ñ̤1MB 
 */
static void
mmu_map_memory(MEMORY_ATTRIBUTE *m_attribute)
{
    UINT size;
    UINT va;
    UINT pa;
    
    size = m_attribute->size;
    va   = m_attribute->va;
    pa   = m_attribute->pa;

    /* MBñ̤ˤʤ褦˥ */
    size = (size + 0x000FFFFF) & ~0x000FFFFF;

    while(size > 0){
        mmu_set_section(va, pa,
                        m_attribute->s,
                        m_attribute->tex,
                        m_attribute->ap,
                        m_attribute->c,
                        m_attribute->b);

        va   += SIZE_1M;
        pa   += SIZE_1M;
        size -= SIZE_1M;
    }
}


void
mpcore_mmu_init(void){
    MEMORY_ATTRIBUTE m_attribute;
    
    UINT bits = 0;

    /* ץեåХåե򥯥ꥢ */
    mpcore_pbuffer_flash();
        
    /*
     * TTBR0ѤѤ˻
     */
    CP15_TTBCR_WRITE(0);

    /*
     * Ѵơ֥(TT)SRAMκǸ16Kbyteݤ(0x481fc000)
     * SharedӥåȤ򥻥å 
     */
    CP15_TTB0_WRITE((((UINT)PabeTable)|CP15_TTB0_RGN_S|CP15_TTB0_RGN_WBWA));    

    /* ץեåХåե򥯥ꥢ */
    mpcore_pbuffer_flash();

    /*
     * ʪɥ쥹 = ۥɥ쥹
     * Υ󥭥å֥롤ΥХåե֥Ȥ 
     */
    m_attribute.pa   = 0x00000000;
    m_attribute.va   = m_attribute.pa;
    m_attribute.size = 0x80000000;
    m_attribute.s    = 1;          /* ͭ         */
    m_attribute.ap   = 3;          /* ե륢 */
    m_attribute.tex  = 0;          /* Strongly Ordered */
    m_attribute.c    = 0;
    m_attribute.b    = 0;

    mmu_map_memory (&m_attribute);
  
    m_attribute.pa   = 0x80000000;
    m_attribute.va   = m_attribute.pa;
    
    mmu_map_memory (&m_attribute);

    
    /*
     * SDRAM
     */
    m_attribute.pa   = SDRAM_ADDR;
    m_attribute.va   = m_attribute.pa;
    m_attribute.size = SDRAM_SIZE;
    m_attribute.s    = 1;          /* ͭ         */
    m_attribute.ap   = 3;          /* ե륢 */
    m_attribute.tex  = 1;          /* Outer and Inner */
    m_attribute.c    = 1;          /* Inner Write-Back, Write Allocate */ 
    m_attribute.b    = 1;

    mmu_map_memory (&m_attribute);
    

    /*
     * Enable caching for the SRAM
     */
    m_attribute.pa    = SRAM_ADDR;     /* pa is started from 0x48000000 (SRAM) */
    m_attribute.va    = m_attribute.pa;
    m_attribute.size  = SRAM_SIZE;     /* 2MB */
    m_attribute.ap    = 3;             /* ե륢 */    
    m_attribute.tex   = 1;             /* Outer and Inner */
    m_attribute.c     = 1;             /* Inner Write-Back, Write Allocate */ 
    m_attribute.b     = 1;    

    mmu_map_memory (&m_attribute);    


    /*
     * ɥᥤֹ򥻥å
     */
    CP15_DOMAINS_WRITE(DOMAIN_NO);


    /*
     * CONTROLץå MӥåȡXPӥåȤ򥻥åȤơ
     * MMUͭˤ  
     */
    CP15_CONTROL_READ(bits);
    bits |= CP15_CONTROL_M_BIT | CP15_CONTROL_XP_BIT;
    CP15_CONTROL_WRITE(bits);
}
