/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ct11mpcore_eb.h,v 1.6 2007/07/18 01:57:53 honda Exp $
 */

/*
 * ARM CT11MPCore with the RealView Emulation Boardѥɥ饤
 */

#ifndef _EB_MPCORE_H_
#define _EB_MPCORE_H_

#ifndef _MACRO_ONLY
#include <itron.h>
#include <sil.h>
#endif /* _MACRO_ONLY */

#include "arm.h"
#include "sys_config.h"
#include "cpu_config.h"

#ifndef _MACRO_ONLY
/*
 * ץؤΥޥ
 */
#define CP15_CONTROL_READ(x)     Asm("mrc p15, 0, %0, c1, c0, 0":"=r"(x))
#define CP15_CONTROL_WRITE(x)    Asm("mcr p15, 0, %0, c1, c0, 0"::"r"(x))

#define CP15_AUXILIARY_READ(x)   Asm("mrc p15, 0, %0, c1, c0, 1":"=r"(x))
#define CP15_AUXILIARY_WRITE(x)  Asm("mcr p15, 0, %0, c1, c0, 1"::"r"(x))

#define CP15_ICACHE_INVALIDATE() Asm("mcr p15, 0, %0, c7, c5, 0"::"r"(0))
#define CP15_DCACHE_INVALIDATE() Asm("mcr p15, 0, %0, c7, c6, 0"::"r"(0))
#define CP15_DCACHE_CLEAN_AND_INVALIDATE() Asm("MCR p15, 0, %0, c7, c14, 0"::"r"(0))
#define CP15_PBUFFER_FLUSH()     Asm("mcr p15, 0, %0, c7, c5, 4"::"r"(0))
#define CP15_DATA_SYNC_BARRIER() Asm("mcr	p15, 0, %0, c7, c10, 4"::"r"(0))
#define CP15_DATA_MEMORY_BARRIER() Asm("mcr p15, 0, %0, c7, c10, 5"::"r" (0));

#define CP15_INVALIDATE_UNIFIED_TLB() Asm("mcr	p15, 0, r0, c7, c10, 4"::"r"(0))

#define CP15_TTBCR_WRITE(x) Asm("mcr p15, 0, %0, c2, c0, 2"::"r"(x))
#define CP15_TTB0_READ(x)   Asm("mrc p15, 0, %0, c2, c0, 0":"=r"(x))
#define CP15_TTB0_WRITE(x)  Asm("mcr p15, 0, %0, c2, c0, 0"::"r"(x))

#define CP15_DOMAINS_WRITE(x) Asm("mcr p15, 0, %0, c3, c0, 0":: "r"(x))

/*
 * ץΥӥå
 */
#define CP15_CONTROL_XP_BIT   (1 << 23)
#define CP15_CONTROL_I_BIT    (1 << 12)
#define CP15_CONTROL_C_BIT    (1 <<  2)
#define CP15_CONTROL_M_BIT    (1 <<  0)

#define CP15_AUXILIARY_SA_BIT (1 << 5)

#define CP15_TTB0_RGN_S    	(1 << 1)
#define CP15_TTB0_RGN_WBWA	(1 << 3)

/*
 * ץѤ롼
 */

/*
 *  Data Synchronization Barrier
 *  ȯԤ줿 read  write νλԤ
 *  å塤֥ץǥTLBνλԤ
 *  ̿θ˽񤫤줿̿ϼ¹Ԥʤ 
 */
Inline void
mpcore_data_sync_barrier(void){
    CP15_DATA_SYNC_BARRIER();
}

/*
 * Data Memory Barrier
 * ץεҤ˽äơ˽񤫤줿̿ǤΥꥢ
 *   λޤԤġ
 *   
 */
Inline void
mpcore_data_memory_barrier(void){
    CP15_DATA_MEMORY_BARRIER();
}

/*
 * TLB̵
 */
Inline void
mpcore_invalidate_unfied_tlb(void){
    CP15_DATA_SYNC_BARRIER();
}


/*
 * Då̵
 */
Inline void
mpcore_dcache_invalidate(void){
    CP15_DCACHE_INVALIDATE();
}


/*
 * DåΥ꡼̵
 */
Inline void
mpcore_dcache_clean_and_invalidate(void){
    CP15_DCACHE_CLEAN_AND_INVALIDATE();
}


/*
 * Iå̵
 */
Inline void
mpcore_icache_invalidate(void){
    CP15_ICACHE_INVALIDATE();
}

/*
 * ץեåХåե򥯥ꥢ
 */
Inline void
mpcore_pbuffer_flash(void){
    CP15_PBUFFER_FLUSH();
}
#endif  /* _MACRO_ONLY */


/*
 *  MPCoreΥ꥽
 */

/*
 *  MPCore 
 */ 
#define MPCORE_TM_LR     0x1f000600  /* ɥ쥸           */
#define MPCORE_TM_COUNT  0x1f000604  /* 󥿡쥸       */
#define MPCORE_TM_CNT    0x1f000608  /* ȥ쥸     */
#define MPCORE_TM_ISR    0x1f00060C  /* ߥơ쥸 */

#define MPCORE_TM_CNT_EN        0x1
#define MPCORE_TM_CNT_AR        0x2
#define MPCORE_TM_CNT_IEN       0x4
#define MPCORE_TM_CNT_PS_OFFSET   8

#define MPCORE_TM_ISR_SCBIT    0x01


/*
 * Snoop Control Unit
 */
#define MPCORE_SCU_CTRL   0x1f000000  /* ȥ쥸 */
#define MPCORE_SCU_CONFIG 0x1f000004  /* ե졼쥸 */
#define MPCORE_SCU_CPUST  0x1f000008  /* CPUơ */
#define MPCORE_SCU_IALL   0x1f00000C  /* Хåɥ */

#define MPCORE_SCU_CTRL_EN (1 << 0)   /* ֥͡ */


/*
 * Distributed Interrupt Controller
 */
#define MPCORE_DIC_CR     0x1f001000   /* ȥ쥸 */
#define MPCORE_DIC_SE     0x1f001100  /* ߥ֥͡륻å   */
#define MPCORE_DIC_CE     0x1f001180  /* ߥ֥͡륯ꥢ */
#define MPCORE_DIC_SP     0x1f001200  /* ߥåȥڥǥ */
#define MPCORE_DIC_CP     0x1f001280  /* ߥꥢڥǥ */
#define MPCORE_DIC_IPR    0x1f001400  /* ͥ٥쥸 */
#define MPCORE_DIC_ITR    0x1f001800  /* ߥåȥ쥸 */
#define MPCORE_DIC_ICR    0x1f001C00  /* ߥե졼쥸 */
#define MPCORE_DIC_SIR    0x1f001F00  /* եȥߥ쥸  */

#define MPCORE_DIC_CR_ENABLE 0x01

#define MPCORE_DIC_ITR_CPU0  0x01
#define MPCORE_DIC_ITR_CPU1  0x02
#define MPCORE_DIC_ITR_CPU2  0x04
#define MPCORE_DIC_ITR_CPU3  0x08

#define MPCORE_DIC_SIR_CPU0  0x01
#define MPCORE_DIC_SIR_CPU1  0x02
#define MPCORE_DIC_SIR_CPU2  0x04
#define MPCORE_DIC_SIR_CPU3  0x08
#define MPCORE_DIC_SIR_CPUS  0x0f

#define MPCORE_DIC_SIR_CPU_OFFSET 16

#define MPCORE_DIC_TNUM_INT      224

/*
 * ֹ(DICǤֹ)
 */
#define DIC_INTID_NUM        47  /*  */

#define DIC_INTID_TM         29
#define DIC_INTID_EB_UART0   36
#define DIC_INTID_EB_UART1   37
//#define DIC_INTID_EB_UART2   42  /* GIC1 */
//#define DIC_INTID_EB_UART3   43  /* GIC2 */
#define DIC_INTID_EB_UART2   44  /* GIC1 */
#define DIC_INTID_EB_UART3   45  /* GIC2 */


/*
 * Distributed Interrupt Controller CPU Interface
 */ 
#define MPCORE_DIC_CPUIF_CR   0x1f000100  /* ȥ쥸 */
#define MPCORE_DIC_CPUIF_PMR  0x1f000104 /* ͥ٥ޥ쥸 */
#define MPCORE_DIC_CPUIF_BPR  0x1f000108 /* Хʥݥȥ쥸 */
#define MPCORE_DIC_CPUIF_IAR  0x1f00010C  /* Interrupt Acknowledge Register */
#define MPCORE_DIC_CPUIF_EOI  0x1f000110  /* End of Interrupt Register */
#define MPCORE_DIC_CPUIF_RII  0x1f000114  /* Running Interrupt Register */

#define MPCORE_DIC_CPUIF_CR_EN      0x01
#define MPCORE_DIC_CPUIF_PMR_OFFSET 0x04
#define MPCORE_DIC_CPUIF_BPR_ALL    0x03  /* ƤΥӥåȤͭ */
#define MPCORE_DIC_CPUIF_BPR_3      0x04  /* 3ӥåͭ        */
#define MPCORE_DIC_CPUIF_BPR_2      0x05  /* 2ӥåͭ        */
#define MPCORE_DIC_CPUIF_BPR_1      0x06  /* 1ӥåͭ        */


/*
 * EBܡɤΥ꥽
 */
#define EB_LED            0x10000008

#define EB_SYS_LOCK       0x10000020
#define EB_SYS_PLD_CTRL1  0x10000074
#define EB_SYS_PLD_CTRL2  0x10000078

#define EB_SYS_LOCK_LOCK   0x0000
#define EB_SYS_LOCK_UNLOCK 0xA05F

#define EB_SYS_PLD_CTRL1_INTMODE            0x01C00000
#define EB_SYS_PLD_CTRL1_INTMODE_LEGACY     0x00000000
#define EB_SYS_PLD_CTRL1_INTMODE_NEW_DCC    0x00400000
#define EB_SYS_PLD_CTRL1_INTMODE_NEW_NODCC  0x00800000

/*
 * ƥॳȥ
 */
#define EB_SYS_CTRL  0x10001000
                          
#define EB_SYS_CTRL_TIMER01_1MHZ   0x00008000 /* 1MHzǥ */

/*
 * EB޴Ϣ
 */
#define EB_TIMER01_BASE       (0x10011000)

#define EB_TIMER01_0_LOAD     (EB_TIMER01_BASE + 0x00)
#define EB_TIMER01_0_VALUE    (EB_TIMER01_BASE + 0x04)
#define EB_TIMER01_0_CTRL     (EB_TIMER01_BASE + 0x08)
#define EB_TIMER01_0_CLR      (EB_TIMER01_BASE + 0x0C)

#define EB_TIMER_CTRL_TIMER_EN     0x00000080
#define EB_TIMER_CTRL_PERIODIC     0x00000040
#define EB_TIMER_CTRL_INT_EN       0x00000020
#define EB_TIMER_CTRL_PRESCALE_1   0x00000000
#define EB_TIMER_CTRL_PRESCALE_16  0x00000004
#define EB_TIMER_CTRL_PRESCALE_256 0x00000008
#define EB_TIMER_CTRL_TIMESIZE_16  0x00000000
#define EB_TIMER_CTRL_TIMESIZE_32  0x00000002
#define EB_TIMER_CTRL_ONE_SHOT     0x00000001

/*
 * UART0Ϣ
 */
#define EB_UART0_BASE  0x10009000
#define EB_UART1_BASE  0x1000A000
#define EB_UART2_BASE  0x1000B000
#define EB_UART3_BASE  0x1000C000

#define EB_UART_DR     0x00  /* ǡ쥸 */
#define EB_UART_RSR    0x04  /* ơ쥸 */
#define EB_UART_TECR   0x04  /* 顼ꥢ쥸 */
#define EB_UART_FR     0x18  /* ե饰쥸 */
#define EB_UART_IBRD   0x24  /* ܡ졼ȥ쥸 */
#define EB_UART_FBRD   0x28  /* ʬܡ졼ȥ쥸 */
#define EB_UART_LCR_H  0x2C  /* 饤󥳥ȥ쥸(H) */
#define EB_UART_CR     0x30  /* ȥ쥸 */
#define EB_UART_IFLS   0x34  /* FIFO٥쥸 */
#define EB_UART_IMSC   0x38  /* ߥޥ쥸 */
#define EB_UART_RIS    0x3C  /* ߥơ쥸 */
#define EB_UART_MIS    0x40  /* ޥߥơ쥸 */
#define EB_UART_ICR    0x44  /* ߥꥢ쥸 */

#define EB_UART_LCR_H_FEN       0x10  /* FIFOͭ */
#define EB_UART_LCR_H_WLEN_8    0x60  /* 8bitĹ       */

#define EB_UART_CR_RXE    0x0200   /* ͭ */
#define EB_UART_CR_TXE    0x0100   /* ͭ */
#define EB_UART_CR_UARTEN 0x0001   /* UARTͭ */

#define EB_UART_FR_TXFF 0x20     /* Хåեեʤ"1"     */
#define EB_UART_FR_RXFE 0x10     /* ͭʥǡʤ"1" */

#define EB_UART_IMSC_RXIM 0x0010 /* ߥޥ          */
#define EB_UART_IMSC_TXIM 0x0020 /* ߥޥ          */

/*
 *  UARTBPS
 */ 
#define EB_UART_IBRD_38400   0x27  /* 38400bps */
#define EB_UART_FBRD_38400   0x04  /* 38400bps */

/*
 *  GIC
 */
#define EB_GIC1_BASE 0x10040000
#define EB_GIC2_BASE 0x10050000
 
#define EB_GIC_CPUIF_CCR   0x0000 /* CPUȥ쥸    */
#define EB_GIC_CPUIF_PR    0x0004 /* ͥ٥쥸             */
#define EB_GIC_CPUIF_BPR   0x0008 /* Хʥݥȥ쥸   */
#define EB_GIC_CPUIF_ACK   0x000C /* Υå쥸       */
#define EB_GIC_CPUIF_EOI   0x0010 /* End of Interrupt 쥸  */
#define EB_GIC_CPUIF_RPR   0x0014 /* Runnning priority 쥸 */
#define EB_GIC_CPUIF_PER   0x0016 /* Pending쥸 */

#define EB_GIC_CR    0x1000 /* ȥ쥸   */
#define EB_GIC_ESR   0x1100 /* ߥ֥͡륻å */
#define EB_GIC_ECR   0x1180 /* ߥ֥͡륯ꥢ */
#define EB_GIC_PSR   0x1200 /* ڥǥ󥰥å     */
#define EB_GIC_PCR   0x1280 /* ڥǥ󥰥ꥢ     */
#define EB_GIC_ACR   0x1300 /* ƥ֥쥸     */
#define EB_GIC_PR    0x1400 /* ͥ٥쥸         */
#define EB_GIC_CFGR  0x1C00 /* ե졼쥸 */
#define EB_GIC_SFT   0x1F00 /* եȥ󥿥ץȥ쥸 */

#define EB_GIC_CPUIF_CCR_EN      0x0001 /* ͭ     */
#define EB_GIC_BPR_ALL           0x0000 /* ͭ */
#define EB_GIC_CR_EN             0x0001 /* ͭ     */

#define EB_GIC_INTID_UART2 46
#define EB_GIC_INTID_UART3 47

#ifdef  USE_GIC1
#define EB_GIC_BASE  EB_GIC1_BASE
#else   /* USE_GIC2 */
#define EB_GIC_BASE  EB_GIC2_BASE
#endif  /* USE_GIC1 */


#ifndef _MACRO_ONLY
/*
 * GICϢΥɥ饤
 */

/*
 * GICͭ
 */
Inline void
eb_gic_enable(void)
{
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CR), EB_GIC_CR_EN);
}

/*
 * GIC̵
 */
Inline void
eb_gic_disable(void)
{
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CR), 0x00);
}


/*
 * GICߵ
 */
Inline void
eb_gic_int_enable(int id)
{
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;
	
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_ESR + offset_addr), (1 << offset_bit));
}

/*
 * GIC߶ػ
 */
Inline void
eb_gic_int_disable(int id)
{
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

    sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_ECR + offset_addr), (1 << offset_bit));
}

/*
 * GICߥڥǥ󥰥ꥢ
 */
Inline void
eb_gic_int_clear(int id)
{
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_PCR + offset_addr), (1 << offset_bit));
}

/*
 * GICߥڥǥ󥰥å
 */
static inline void
eb_gic_int_set(int id){
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

    sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_PSR + offset_addr), (1 << offset_bit));	
}

/*
 * GICͥ٤
 */ 
Inline void
eb_gic_set_priority(int id, int pri)
{
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 4) * 4;
	offset_bit  = ((id % 4) * 8);

    sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_PR + offset_addr),
				(sil_rew_mem((VP)(EB_GIC_BASE + EB_GIC_PR + offset_addr)) & ~(0xff << offset_bit))
				| (pri << offset_bit));
}

/*
 * GICߥե졼
 */ 
Inline void
eb_gic_set_config(int id, int set)
{
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 16) * 4;
	offset_bit  = ((id % 16) * 2);

    sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CFGR + offset_addr),
            (sil_rew_mem((VP)(EB_GIC_BASE + EB_GIC_CFGR + offset_addr)) & ~(0x3 << offset_bit))
			  | (set << offset_bit));	
}


/*
 * GICϤߤν
 *  id  : ID(DICδID)
 *  pri : ͥ
 *  cpu : åCPU
 *        0ꤹsys_defs.hǻꤷPRCIDǻꤷץå
 *        ꤹ 
 *  cfg : ե졼 
 */
Inline void
eb_gic_init_int_source(int id, int pri, int cfg){
	/* ͥ٤  */	
	eb_gic_set_priority(id, pri);

	/* level high + N-N software model */
	eb_gic_set_config(id, cfg);

	/* ߥڥǥ󥰥ꥢ */
	eb_gic_int_clear(id);
	  
	/* ߵ */	  
	eb_gic_int_enable(id);
}


/*
 * GIC CPU󥿥եϢΥɥ饤
 */

/*
 * DICΥץåγͥ٤
 */ 
Inline void
eb_gic_cpu_set_priority(int pri)
{
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CPUIF_PR), pri);
}

/*
 * DICΥץåγͥ٤ΤɤΥӥåȤѤ뤫
 */
Inline void
eb_gic_cpu_enable_priority(int mask_bit)
{
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CPUIF_BPR), mask_bit);
}

Inline void
eb_gic_cpu_disable(void){
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CPUIF_CCR), 0x00);
}
	 
/*
 * GIC CPU󥿥եν
 *  maks_bit : оݤȤͥ٤ΥӥåȤ
 *  pri      : ץåγߥޥ 
 */ 
Inline void
eb_gic_cpu_init(int mask_bit, int pri)
{	
	/* ͭ */
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CPUIF_CCR), EB_GIC_CPUIF_CCR_EN);

	/* ͥ٤Τͭˤbit*/
	eb_gic_cpu_enable_priority(mask_bit); 
	
	/* ץåγߥޥ */
	eb_gic_cpu_set_priority(pri);
}


Inline void
eb_gic_init(int mask_bit, int pri){
	eb_gic_disable();
	eb_gic_cpu_disable();

	/*
	 * ػ
	 */
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_ECR + 0x00), 0xFFFFFFFF);
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_ECR + 0x04), 0xFFFFFFFF);
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_ECR + 0x08), 0xFFFFFFFF);

	/*
	 * ڥǥ󥰥ꥢ
	 */
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_PCR + 0x00), 0xFFFFFFFF);
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_PCR + 0x04), 0xFFFFFFFF);
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_PCR + 0x08), 0xFFFFFFFF);

	/*
	 * ե졼
	 */
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CFGR + 0x00), 0x55555555);
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CFGR + 0x04), 0x55555555);
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CFGR + 0x08), 0x55555555);
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CFGR + 0x0C), 0x55555555);
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CFGR + 0x10), 0x55555555);
	sil_wrw_mem((VP)(EB_GIC_BASE + EB_GIC_CFGR + 0x14), 0x55555555);
	
	eb_gic_enable();
	eb_gic_cpu_init(mask_bit, pri);
}


/*
 *  ɥ饤
 */

/*
 *  DICϢΥɥ饤
 */ 
/*
 * DICͭ
 */
Inline void
mpcore_dic_enable(void)
{
    int i;
    
    /* DIC󥿥ե̵ */
    sil_wrw_mem((VP)MPCORE_DIC_CR, 0x00);

        /* ߤƶػ */
    for(i = 0; i < MPCORE_DIC_TNUM_INT/32; i++){
        sil_wrw_mem((VP)(MPCORE_DIC_CE + (4 * i)), 0xffffffff);    
    }

    /* ڥǥ󥰤򥯥ꥢ */
    for(i = 0; i < MPCORE_DIC_TNUM_INT/32; i++){
        sil_wrw_mem((VP)(MPCORE_DIC_CP + (4 * i)), 0xffffffff);    
    }

    /* ͥٺ  */
    for(i = 0; i < MPCORE_DIC_TNUM_INT/4; i++){
        sil_wrw_mem((VP)(MPCORE_DIC_IPR + (4 * i)), 0xffffffff);    
    }

    /* ⡼ɽ(1-N Level) */
    for(i = 0; i < MPCORE_DIC_TNUM_INT/16; i++){
        sil_wrw_mem((VP)(MPCORE_DIC_ICR + (4 * i)), 0x55555555);
    }
    
    /* DIC󥿥եͭ */
	sil_wrw_mem((VP)MPCORE_DIC_CR, MPCORE_DIC_CR_ENABLE);    
}

/*
 * DICߵ
 */
Inline void
mpcore_dic_int_enable(int id)
{
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;
	
	sil_wrw_mem((VP)(MPCORE_DIC_SE + offset_addr), (1 << offset_bit));
}

/*
 * DIC߶ػ
 */
Inline void
mpcore_dic_int_disable(int id)
{
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

    sil_wrw_mem((VP)(MPCORE_DIC_CE + offset_addr), (1 << offset_bit));
}

/*
 * DICߥڥǥ󥰥ꥢ
 */
Inline void
mpcore_dic_int_clear(int id)
{
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

    sil_wrw_mem((VP)(MPCORE_DIC_CP + offset_addr), (1 << offset_bit));
}

/*
 * DICߥڥǥ󥰥å
 */
static inline void
mpcore_dic_int_set(int id){
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

    sil_wrw_mem((VP)(MPCORE_DIC_SP + offset_addr), (1 << offset_bit));	
}


/*
 * DICͥ٤
 */ 
Inline void
mpcore_dic_set_priority(int id, int pri)
{
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 4) * 4;
	offset_bit  = ((id % 4) * 8) + 4;

    sil_wrw_mem((VP)(MPCORE_DIC_IPR + offset_addr),
				(sil_rew_mem((VP)(MPCORE_DIC_IPR + offset_addr)) & ~(0xf << offset_bit))
				| (pri << offset_bit));
}


/*
 * DICߥåȤ
 * CPUORǻ 
 */ 
Inline void
mpcore_dic_set_target(int id, int cpu)
{
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 4) * 4;
	offset_bit  = ((id % 4) * 8);

	sil_wrw_mem((VP)(MPCORE_DIC_ITR + offset_addr),
				(sil_rew_mem((VP)(MPCORE_DIC_ITR + offset_addr)) & ~(0xf << offset_bit))
				| (cpu << offset_bit));	
}


/*
 * DICߥե졼
 */ 
Inline void
mpcore_dic_set_config(int id, int set)
{
	UW offset_addr;
	UW offset_bit;

	offset_addr = (id / 16) * 4;
	offset_bit  = ((id % 16) * 2);

    sil_wrw_mem((VP)(MPCORE_DIC_ICR + offset_addr),
            (sil_rew_mem((VP)(MPCORE_DIC_ICR + offset_addr)) & ~(0x3 << offset_bit))
			  | (set << offset_bit));	
}

/*
 * DICϤߤν
 *  id  : ID(DICδID)
 *  pri : ͥ
 *  cpu : åCPU
 *        0ꤹsys_defs.hǻꤷPRCIDǻꤷץå
 *        ꤹ 
 *  cfg : ե졼 
 */
Inline void
mpcore_dic_init_int_source(int id, int pri, int cpu, int cfg){
	/* ͥ٤  */	
	mpcore_dic_set_priority(id, pri);

	if(cpu != 0){
		/* åȥץåλ */
		mpcore_dic_set_target(id, cpu);
	}
	else{
		mpcore_dic_set_target(id, (1<<(PRCID-1)));
	}
	  
	/* level high + N-N software model */
	mpcore_dic_set_config(id, cfg);

	/* ߥڥǥ󥰥ꥢ */
	mpcore_dic_int_clear(id);
	  
	/* ߵ */	  
	mpcore_dic_int_enable(id);
}

/*
 *  եȥߤȯ
 */
Inline void
mpcore_dic_swi(int cpu, int id)
{
	sil_wrw_mem((VP)MPCORE_DIC_SIR, (cpu << MPCORE_DIC_SIR_CPU_OFFSET)
				|id);
}


/*
 *  DIC CPU󥿥եϢΥɥ饤
 */
/*
 * DICΥץåγͥ٤
 */ 
Inline void
mpcore_dic_cpu_set_priority(int pri)
{
	sil_wrw_mem((VP)MPCORE_DIC_CPUIF_PMR, (pri << MPCORE_DIC_CPUIF_PMR_OFFSET));
}

/*
 * DICΥץåγͥ٤ΤɤΥӥåȤѤ뤫
 */
Inline void
mpcore_dic_cpu_enable_priority(int mask_bit)
{
	sil_wrw_mem((VP)MPCORE_DIC_CPUIF_BPR, mask_bit);
}


/*
 * DIC CPU󥿥եν
 *  maks_bit : оݤȤͥ٤ΥӥåȤ
 *  pri      : ץåγߥޥ 
 */ 
Inline void
mpcore_dic_cpu_init(int mask_bit, int pri)
{	
	/* ͭ */
	sil_wrw_mem((VP)MPCORE_DIC_CPUIF_CR, MPCORE_DIC_CPUIF_CR_EN);

	/* ͥ٤Τͭˤbit*/
	mpcore_dic_cpu_enable_priority(mask_bit); /* ӥåͭ */
	
	/* ץåγߥޥ */
	mpcore_dic_cpu_set_priority(pri);
}


/*
 *  EBΥ꥽
 */ 
Inline void
eb_led_out(unsigned char ptn){
	sil_wrw_mem((VP)EB_LED, ptn);
}

Inline void
set_led(unsigned char ptn){
	sil_wrw_mem((VP)EB_LED,
				((ptn & 0x3) << (PRCID-1)*2) |
				(sil_rew_mem((VP)EB_LED) & ~(0x03 << (PRCID-1)*2)));
}


/*
 *  EB  Core Tile ֤γߤν
 *  ߥ⡼ɤnew⡼withoutDCC 
 */
Inline void
eb_core_tile_init_int_mode(void){
	/* EBΥƥ쥸򥢥å */
	sil_wrw_mem((VP)EB_SYS_LOCK, EB_SYS_LOCK_UNLOCK);

	/* ߥ⡼ɤnew⡼withoutDCC */
	sil_wrw_mem((VP)EB_SYS_PLD_CTRL1,
				(sil_rew_mem((VP)EB_SYS_PLD_CTRL1) & ~EB_SYS_PLD_CTRL1_INTMODE) | 
				EB_SYS_PLD_CTRL1_INTMODE_NEW_NODCC);
	/* EBΥƥ쥸å */
	sil_wrw_mem((VP)EB_SYS_LOCK, EB_SYS_LOCK_LOCK);
}
  
/*
 * ¢UART ʰSIOɥ饤
 */

/*
 * ͥ뵯ưѤν(sys_putcѤ뤿)
 */
extern void eb_uart_init(void);

/*
 *  ꥢI/OݡȽ֥å
 *  ɥ饤а¸ 
 */
typedef struct sio_port_initialization_block 
{
    VP reg_base;   /* 쥸Υ١ɥ쥹 */
	UW int_id;     /* ֹ               */
}
SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block 
{
    const SIOPINIB  *siopinib;  /* ꥢI/OݡȽ֥å */
    VP_INT          exinf;      /* ĥ */
    BOOL    openflag;       /* ץѤߥե饰 */
    BOOL    sendflag;       /* ߥ֥͡ե饰 */
    BOOL    getready;       /* ʸ */
    BOOL    putready;       /* ʸǤ */

}SIOPCB;

/*
 *  Хå롼μֹ
 */
#define SIO_ERDY_SND    1u      /* ǽХå */
#define SIO_ERDY_RCV    2u      /* ΥХå */

/*
 *  åפUARTΥݡ󥰽
 */
extern void uart_putc(char c);

/*
 *  SIOɥ饤Фν롼
 */
extern void uart_initialize(void);

/*
 *  ץ󤷤ƤݡȤ뤫
 */
extern BOOL uart_openflag(void);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB   *uart_opn_por(ID siopid, VP_INT exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void uart_cls_por(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern BOOL uart_snd_chr(SIOPCB *siopcb, char c);

/*
 *  ꥢI/OݡȤʸ
 */
extern INT  uart_rcv_chr(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void uart_ena_cbr(SIOPCB *siopcb, UINT cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void uart_dis_cbr(SIOPCB *siopcb, UINT cbrtn);

/*
 *  SIOγߥӥ롼
 */
extern void uart_in_isr(void);
extern void uart_out_isr(void);

/*
 *  ꥢI/OݡȤǽХå
 */
extern void uart_ierdy_snd(VP_INT exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void uart_ierdy_rcv(VP_INT exinf);


/*
 * SMP⡼ɤͭ
 */
extern void mpcore_smp_mode_enable(void);

/*
 * åϢδؿ
 */
extern void mpcore_dcache_enable(void);
extern void mpcore_dcache_disable(void);
extern void mpcore_icache_enable (void);
extern void mpcore_icache_disable(void);
extern void mpcore_cache_enable(void);
extern void mpcore_cache_disable(void);

/*
 * MMUν
 */
extern void mpcore_mmu_init(void);

/*
 * ԥå
 */
Inline void
mpcore_spin_lock(UINT *lock){
    UINT locked;
    
    for(;;){
        Asm("   mov      r2, #0x01   \n"
			"\t ldrex    r1, [%1]    \n"
			"\t cmp      r1, #0x00   \n"
            "\t wfene                \n"            
			"\t strexeq  r1, r2,[%1] \n"
			"\t mov      %0, r1      \n"
			:"=r"(locked):"r"(lock):"r1","r2", "cc");

        /* ꥿ */
		if(locked == 0){
            mpcore_data_memory_barrier();
            return;
        }
    }
}


/*
 * ԥå
 */
Inline void
mpcore_spin_unlock(UINT *lock){
    mpcore_data_memory_barrier();
    *lock = 0;
    mpcore_data_sync_barrier();
    Asm("sev");

}
#endif /* _MACRO_ONLY */
#endif /* _EB_MPCORE_H_ */
