/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003      by Advanced Data Controls, Corp
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_serial.h,v 1.1 2006/09/21 07:16:56 honda Exp $
 */

/*
 *  ꥢI/OǥХSIO˥ɥ饤СARM RealView Emulation Boardѡ
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

#include <ct11mpcore_eb.h>
#include "sys_defs.h"

/*
 *  ꥢI/OγߥϥɥΥ٥ֹ
 */
#if   EB_UART_NO == 0
#define INHNO_SIO  DIC_INTID_EB_UART0
#elif EB_UART_NO == 1
#define INHNO_SIO  DIC_INTID_EB_UART1
#elif EB_UART_NO == 2
#define INHNO_SIO  DIC_INTID_EB_UART2
#elif EB_UART_NO == 3
#define INHNO_SIO  DIC_INTID_EB_UART3
#endif /* EB_UART_NO == 0 */

/*
 *  SIOɥ饤Фν롼
 */
#define sio_initialize  uart_initialize

#ifndef _MACRO_ONLY

/*
 *  ꥢI/OݡȤΥץ
 */
Inline SIOPCB *
sio_opn_por(ID siopid, VP_INT exinf)
{
    SIOPCB  *siopcb;

    /*
     *  ǥХ¸Υץ
     */
    siopcb = uart_opn_por(siopid, exinf);

      
    /*
     * ߴϢ
     */
    /* Enable Interrupt Rx */
	mpcore_dic_init_int_source(INHNO_SIO,                 /* ID     */
							   EB_UART_INT_LEVEL,         /* ͥ       */
							   0,                         /* ץå */
							   0x00);                     /* ٥ */
#if defined(USE_GIC1) || defined(USE_GIC2)
#if	EB_UART_NO == 2	
//	eb_gic_init_int_source(EB_GIC_INTID_UART2,        /* ID     */
//						   EB_UART_INT_LEVEL,         /* ͥ       */
//						   0x05);                     /* ٥ */
#else /* EB_UART_NO == 3 */	
//	eb_gic_init_int_source(EB_GIC_INTID_UART3,        /* ID     */
//						   EB_UART_INT_LEVEL,         /* ͥ       */
//						   0x05);                     /* ٥ */	
#endif	/* EB_UART_NO == 2	*/						   
#endif 	/* defined(USE_GIC1) || defined(USE_GIC2) */	

	
    
    return(siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
Inline void
sio_cls_por(SIOPCB *siopcb)
{
    /*
     *  ǥХ¸Υ
     */
    uart_cls_por(siopcb);

    /*
     *  ꥢI/Oߤػߤ
     */
    if (!uart_openflag()) {
		mpcore_dic_int_disable(INHNO_SIO);
    }
}


/*
 *  SIOγߥϥɥ
 */
#define sio_handler  uart_isr

/*
 *  ꥢI/OݡȤؤʸ
 */
#define sio_snd_chr uart_snd_chr

/*
 *  ꥢI/OݡȤʸ
 */
#define sio_rcv_chr uart_rcv_chr

/*
 *  ꥢI/OݡȤΥХåε
 */
#define sio_ena_cbr uart_ena_cbr

/*
 *  ꥢI/OݡȤΥХåζػ
 */
#define sio_dis_cbr uart_dis_cbr

/*
 *  ꥢI/OݡȤǽХå
 */
#define sio_ierdy_snd   uart_ierdy_snd

/*
 *  ꥢI/OݡȤμΥХå
 */
#define sio_ierdy_rcv   uart_ierdy_rcv

#endif /* _MACRO_ONLY */
#endif /* _HW_SERIAL_H_ */

