/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *                2003      by  Advanced Data Controls, Corp
 *  Copyright (C) 2006      by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN      
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_timer.h,v 1.1 2006/09/21 07:16:56 honda Exp $
 */

/*
 *  CPU¸ޥ⥸塼MPCoreѡ
 *  ¢ޤ
 */

#ifndef _HW_TIMER_H_
#define _HW_TIMER_H_

#include <s_services.h>
#include <ct11mpcore_eb.h>

/*
 *  ޳ߤγֹ
 */
#define    INHNO_TIMER    DIC_INTID_TM

#ifndef _MACRO_ONLY

/*
 *  ͤɽη
 */
typedef UW    CLOCK;

/*
 *  ͤɽȥߥáñ̤ȤѴ
 *  TIMER_CLOCK ϥåȥܡ
 */
#define TO_CLOCK(nume, deno) (TIMER_CLOCK * (nume) / (deno))
#define TO_USEC(clock)       ((clock) * 1000 / TIMER_CLOCK)

/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK    ((CLOCK) 0xffffffff)
/*
 *  ޤθͤȯͤȤߤʤȽ
 */
#define GET_TOLERANCE    100
#define BEFORE_IREQ(clock) \
        ((clock) >= TO_CLOCK(TIC_NUME, TIC_DENO) - GET_TOLERANCE)


/*
 *  ޳׵Υꥢ
 */
Inline void
hw_timer_int_clear()
{
	/* ڥǥ󥰥ӥåȤ򥯥ꥢ */
	sil_wrw_mem((VP)MPCORE_TM_ISR, MPCORE_TM_ISR_SCBIT);
}


/*
 *  ޤ߽
 */
Inline void
hw_timer_terminate()
{
	/*   */ 
	sil_wrw_mem((VP)MPCORE_TM_CNT, 0x00);
	
	/* ڥǥ󥰥ӥåȥꥢ */ 
	hw_timer_int_clear();
	
	/*
	 * ߶ػ
	 */ 
	mpcore_dic_int_disable(DIC_INTID_TM);
}


/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
Inline void
hw_timer_initialize()
{
	/* ޡ*/
	hw_timer_terminate();

	/* ͤ */
	sil_wrw_mem((VP)MPCORE_TM_LR, TO_CLOCK(TIC_NUME, TIC_DENO) - 1);

	/*
     * ޡ(ߵ)
     * 1MhzǥȤ褦˥ץꥹ顼
	 */
	sil_wrw_mem((VP)MPCORE_TM_CNT,
				(MPCORE_TM_PS_1MHZ << MPCORE_TM_CNT_PS_OFFSET)
				| MPCORE_TM_CNT_IEN | MPCORE_TM_CNT_AR | MPCORE_TM_CNT_EN);

	/*
	 * ߤĤ
	 */ 
	mpcore_dic_init_int_source(DIC_INTID_TM,
							   MPCORE_TM_INT_LEVEL, /* ͥ       */
							   0,                   /* ץå */
							   0x00);               /* ٥ */	
}


/*
 *  ޤθͤɤߤ
 *
 *  ߶ػ߶ǸƤӽФȡ
 */
Inline CLOCK
hw_timer_get_current(void)
{
    return(TO_CLOCK(TIC_NUME, TIC_DENO) - sil_rew_mem((VP)MPCORE_TM_COUNT));
		   
}


/*
 * ߾֤Υå
 */ 
Inline BOOL
hw_timer_fetch_interrupt(void)
{
	if((sil_rew_mem((VP)MPCORE_TM_ISR) & MPCORE_TM_ISR_SCBIT) == MPCORE_TM_ISR_SCBIT){
		return TRUE;
	}
	else {
		return FALSE;		
	}
}

#endif /* _MACRO_ONLY */
#endif /* _HW_TIMER_H_ */



