/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003      by Advanced Data Controls, Corp
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sys_config.c,v 1.4 2007/02/05 04:56:53 honda Exp $
 */

/*
 *    åȥƥ¸⥸塼ARM CT11MPCore with the RealView Emulation Boardѡ
 */

#include "fdmp_kernel.h"
#include <ct11mpcore_eb.h>


/*
 * ߥϥɥϿѥơ֥
 */
FP   int_table[DIC_INTID_NUM];


/*
 *  ߴϢν
 */
void
init_IRQ(){
    int i;

#ifdef PE1
	/*
	 * EBCoreTile֤γߤ³ν
	 */
	eb_core_tile_init_int_mode();

	/*
	 *  DICͭ
	 */ 
	mpcore_dic_enable();
#endif /* PE1 */
    
	/*
	 *  DIC CPU󥿥եν
	 *  ͥӡͥٺǾ 
	 */ 
	mpcore_dic_cpu_init(MPCORE_DIC_CPUIF_BPR_ALL, 0xf);


#if defined(USE_GIC1) || defined(USE_GIC2)
	/*
	 *  DIC CPU󥿥եν
	 *  ͥӡͥٺǾ 
	 */
	eb_gic_init(0x00, 0xff);
#endif 	/* defined(USE_GIC1) || defined(USE_GIC2) */
	
    /*
     *  ߥơ֥ν
     */
    for(i = 0; i < DIC_INTID_NUM; i++){
        int_table[i] = 0x00;        /* ̤Ͽ */   
    }
}


/*
 *  åȥƥ¸ν
 */
void
sys_initialize()
{
    init_IRQ();

    /*
     *  ARMΥ٥ơ֥سߥϥɥϿ
     */
    arm_install_handler(IRQ_Number,IRQ_Handler);
     
    /*
     *  sys_putc ǽˤʤ褦UART
     */
	eb_uart_init();

    /*
     * å̵
     */
    mpcore_cache_disable();
    
    /*
     * MMUͭ
     */
    mpcore_mmu_init();

    /*
     * SMP⡼ɤ
     */
    mpcore_smp_mode_enable();

    /*
     * åͭ
     */
    mpcore_cache_enable();
}


/*
 *  åȥƥνλ
 */
void
sys_exit(void)
{
    syslog(LOG_EMERG, "End Kernel.....!");
    while(1);
}


/*
 *  åȥƥʸ
 */

void
sys_putc(char c)
{
    if (c == '\n') {
        uart_putc('\r');
    }
    uart_putc(c);
}


/*
 *  ߥϥɥ
 *
 *  ֹ inhno γߥϥɥεưϤ inthdr ꤹ롥
 */
void
define_inh(INHNO inhno, FP inthdr)
{
    assert(inhno < DIC_INTID_NUM);
    int_table[inhno] = inthdr;

}

/*
 *  ̤γߤäν
 */
void
undef_interrupt(){
    syslog(LOG_EMERG, "Unregistered Interrupt occurs.");
    while(1);
}
