/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 * 
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mp_config.c,v 1.3 2007/02/05 00:59:07 honda Exp $
 */

/** \file
 *  ޥץåݡȥ⥸塼 եNios2ѡ
 */
#include "fdmp_kernel.h"
#include "check.h"
#include "task.h"
#include <arm.h>

/**
 *  ƱѤΥޥåʥС
 */
#define MAGIC_START 0x87654321

/**
 *  ưƱѿ
 */
BOOL    proc_init[NO_PROC] __attribute__((section(".shared"),nocommon));

/**
 *  ưƱѿ
 */
volatile INT sys_start __attribute__((section(".shared"),nocommon));

/**
 *  ưƱѿ
 */
volatile INT exccb_available __attribute__((section(".shared"),nocommon));

/**
 *  EXCCBΥꥢ
 */
EXCCB exported_ccb_table[NUM_CLASS] __attribute__((section(".shared"),nocommon));


/**
 *  ƱѤΥǡ(ޥץåΤ߼¹)
 */
void
mp_initialize(void)
{
    INT i;

    sys_start = 0;
    exccb_available = 0;
    for (i = 1; i <= NO_PROC; i++) {
        proc_init[i-1] = FALSE;
    }
    exccb_available = MAGIC_START;
}

/**
 *  ޥץåˤԤ(ޥץåʳ¹)
 */
void
mp_init_sync(void)
{
    INT i;
    INT cnt = 0;

    if (!((exccb_available == (INT)0) || (exccb_available == (INT)MAGIC_START))) {
        exccb_available = 0;
    }

    while (1) {
        for (i = 0; i < 300; i++);
        cnt++;
        if (exccb_available == (INT)MAGIC_START) {
            break;
        }
    }
    
    syslog(LOG_NOTICE,"receive %x(cnt=%d)",exccb_available, cnt);
}

/**
 *  ץåEXCCBνԤ
 */
void
mp_start(void)
{
    INT i, j, flag;

	proc_init[PRCID-1] = TRUE;

    if (MASTER_PROC()) {
        do {
            flag = 0;
            for (i = 1; i <= NO_PROC; i++) {
                if (proc_init[i-1] == TRUE) {
                    flag++;
                }
            }
            for (j =0; j < 100; j++);
        } while (flag < NO_PROC);
        sys_start = MAGIC_START;
        exccb_available = 0;
    }
    else {
        while (sys_start != (INT)MAGIC_START) {
            for (j = 0; j < 100; j++);
        }
    }
}

/*
 * ץå֥å
 */
UW    tsk_lock;

/*
 * ץå֥֥ȥå
 */
UW    obj_lock;

/**
 *  (¾ץåΥ񸻤)åμ
 */
BOOL
local_acquire_lock(LOCKOBJ *lockobj) 
{
	int locked;

	for(;;){
        Asm("   mov      r2, #0x01   \n"
			"\t ldrex    r1, [%1]    \n"
            "\t cmp      r1, #0x00   \n"
            "\t wfene                \n"            
			"\t strexeq  r1, r2,[%1] \n"
			"\t mov      %0, r1      \n"
			:"=r"(locked):"r"(lockobj->lock_ptr):"r1","r2", "cc");

        /* ꥿ */
		if(locked == 0){
            mpcore_data_memory_barrier();
            return(FALSE);
        }
    }

    return (FALSE);
}

/**
 * ץåΥ񸻤ΥåƱ롼ѡ
 */
asm(".globl my_local_acquire_lock");
asm("my_local_acquire_lock = local_acquire_lock");

/**
 *  (¾ץåΥ񸻤)åβ 
 */ 
void
local_release_lock(LOCKOBJ *lockobj)
{
    mpcore_data_memory_barrier();    
    *(UW *)(lockobj->lock_ptr) = 0;    
    mpcore_data_sync_barrier();
    Asm("sev");
}

/**
 * ץåΥ񸻤γƱ롼
 */
asm(".globl my_local_release_lock");
asm("my_local_release_lock = local_release_lock");

