/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: start.S,v 1.3 2006/12/25 07:18:07 honda Exp $
 */
                
/*
 *    ͥѤΥȥåץ⥸塼(ARM)
 */
#define _MACRO_ONLY
#include <arm.h>
#include <sys_defs.h>       
#include <t_config.h>
 

/*
 * Vectorơ֥1ܤΥϥɥ
 * ƤΥץåǶͭ
 */
        /*
         * Vectorơ֥ȥץơ֥
         * Ϲ0x3c
         */
        .section .vector,"axw"
        .code 32
        .align 0
        .global vector_table
vector_table:
        ldr pc,=reset_handler       /* ꥻå             */
        ldr pc,=undef_handler       /* ̤̿           */
        ldr pc,=swi_handler         /* եȥ   */
        ldr pc,=prefech_handler     /* ץեåܡ */
        ldr pc,=data_abort_handler  /* ǡܡ       */
        ldr pc,=reset_handler
        ldr pc,=irq_handler         /* IRQ                  */
        ldr pc,=fiq_handler         /* IRQ                  */


/*
 *
 *  1ܤΥϥɥ
 *  CPU IDˤ٥ơ֥뤫饸
 *  
 */
        .align 4
        .code 32    
reset_handler:
        mrc p15, 0, r0, c0, c0, 5 /* ץåIDμ */
        and r0, r0, #0x0f         /* 4bitΤͭ   */
        ldr r1,=reset_vector
        ldr pc, [r1, r0, asl #2]  /* ɥ쥹     */
  		
        .align 4
        .code 32    		
undef_handler:        
        ldr   sp,int_stack        /* åڤؤ    */
        sub   lr,lr,#4               
        stmfd sp!, {r0 - r2,lr}   /* Ūint_stack   */ 
        mrc p15, 0, r0, c0, c0, 5 /* ץåIDμ */
        and r0, r0, #0x0f         /* 4bitΤͭ   */
        ldr r1,=undef_vector
        ldr pc, [r1, r0, asl #2]  /* ɥ쥹     */

        .align 4
        .code 32    
swi_handler:
        ldr   sp,int_stack        /* åڤؤ    */
        sub   lr,lr,#4               
        stmfd sp!, {r0 - r2,lr}   /* Ūint_stack   */ 
        mrc p15, 0, r0, c0, c0, 5 /* ץåIDμ */
        and r0, r0, #0x0f         /* 4bitΤͭ   */
        ldr r1,=swi_vector
        ldr pc, [r1, r0, asl #2]  /* ɥ쥹     */

        .align 4
        .code 32    
prefech_handler:
        ldr   sp,int_stack        /* åڤؤ    */
        sub   lr,lr,#4               
        stmfd sp!, {r0 - r2,lr}   /* Ūint_stack   */ 
        mrc p15, 0, r0, c0, c0, 5 /* ץåIDμ */
        and r0, r0, #0x0f         /* 4bitΤͭ   */
        ldr r1,=prefech_vector
        ldr pc, [r1, r0, asl #2]  /* ɥ쥹     */

        .align 4
        .code 32    
data_abort_handler:
        ldr   sp,int_stack        /* åڤؤ    */
        sub   lr,lr,#4               
        stmfd sp!, {r0 - r2,lr}   /* Ūint_stack   */ 
        mrc p15, 0, r0, c0, c0, 5 /* ץåIDμ */
        and r0, r0, #0x0f         /* 4bitΤͭ   */
        ldr r1,=data_abort_vector
        ldr pc, [r1, r0, asl #2]  /* ɥ쥹     */

        .section .vector,"axw"
        .align 4
        .code 32    
irq_handler:
        /* 
         *  ư⡼(ѡХ⡼)
         */
        mov   sp,#(CPSR_SVC | CPSR_FIQ_BIT | CPSR_IRQ_BIT) 
        msr   cpsr_all, sp
        stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */
        mrc p15, 0, r0, c0, c0, 5 /* ץåIDμ */
        and r0, r0, #0x0f         /* 4bitΤͭ   */
        ldr r1,=irq_vector
        ldr pc, [r1, r0, asl #2]  /* ɥ쥹     */				

fiq_handler:
		/* ̤ */


		/*
		 * 1ܤΥϥɥǻѤ륹å(cpu_config.c)ǻ
		 */
		.align 2
int_stack:
       .long _kernel_int_stack + 6 * 4

		/*
         * 1ܤΥϥɥǻȤơ֥
         * ץå
         */
		.align 4
reset_vector:
        .long CORE0_START_ADDER  
        .long CORE1_START_ADDER  
        .long CORE2_START_ADDER  
        .long CORE3_START_ADDER
undef_vector:
        .long 0x00000000
        .long 0x00000000
        .long 0x00000000
        .long 0x00000000
swi_vector:
        .long 0x00000000
        .long 0x00000000
        .long 0x00000000
        .long 0x00000000
prefech_vector:
        .long 0x00000000
        .long 0x00000000
        .long 0x00000000
        .long 0x00000000
data_abort_vector:
        .long 0x00000000
        .long 0x00000000
        .long 0x00000000
        .long 0x00000000
irq_vector:
        .long 0x00000000
        .long 0x00000000
        .long 0x00000000
        .long 0x00000000
fiq_vector:
        .long 0x00000000
        .long 0x00000000
        .long 0x00000000
        .long 0x00000000


/*
 *     ȥɥ쥹
 *     textƤΥץåǶͭ
 */
        .text
        .code 32
        .align     0
        .global    start
start:
        mov  r1,  #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT) /* To System mode */
		msr  cpsr, r1

        /*
         * åݥ󥿤ȡե졼ݥ󥿤ν
         * SL(å¥쥸r10)ꤹɬפ뤫?
         * gccϥǥեȤǤ-mapcsʤΤɬפʤ
         */
        ldr  r3, =STACKTOP
        mov  sp, r3
        mov  r11, #0        /* Arm⡼ѥե졼ݥ   */         
        mov  r7, #0         /* Thubm⡼ѥե졼ݥ */

        /*
         * hardware_init_hookθƤӽФ 0Ǥʤ
         *
         * åȥϡɥ˰¸ɬפʽ
         * ϡhardware_init_hook ȤؿѰդ
         */
        ldr  r0, =hardware_init_hook
        cmp  r0, #0x00
        blne hardware_init_hook


        /*
         *  bssΥꥢ
         */        
start_1:
        ldr  r1, =__bss_start
        ldr  r2, =__bss_end
        cmp  r1,r2
        bhs  start_3
        mov  r0,#0
start_2:
        str  r0,[r1],#4
        cmp  r1, r2
        blo  start_2
        
        /*
         *  dataν(ROMб)
         *  __idata_start  __idata_end ޤǤ__data_start ʹߤ
         *  ԡ
         */
start_3:
        ldr  r1, =__idata_start
        ldr  r3, =__idata_end
        cmp  r1, r3
        bhs  start_5
        ldr  r2, =__data_start
start_4:        
        ldr  r0, [r1],#4
        str  r0, [r2],#4
        cmp  r1, r3
        blo  start_4

        
        /*
         *  software_init_hook ƽФ0 Ǥʤ
         *
         *  եȥĶä˥饤֥ˤ˰¸ɬפʽ
         *  ϡsoftware_init_hook ȤؿѰդ
         *  褤
         */
start_5:
        ldr   r0, =software_init_hook
        cmp   r0, #0x00
        blne  software_init_hook

start_6:        
        bl    kernel_start
        
       /*
		*  1ܤΥϥɥ餬Ȥơ֥ؤΥݥ
        *  ץåIDˤϿΥɥ쥹ѹ
        */
        .align 4
        .global arm_vector_add
arm_vector_add:
        .long reset_vector       + (PRCID-1)*4
        .long undef_vector       + (PRCID-1)*4	
        .long swi_vector	     + (PRCID-1)*4	
        .long prefech_vector	 + (PRCID-1)*4	
        .long data_abort_vector	 + (PRCID-1)*4	
        .long reset_vector 	     + (PRCID-1)*4	
        .long irq_vector	     + (PRCID-1)*4	
        .long fiq_vector	     + (PRCID-1)*4	
