/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sys_defs.h,v 1.4 2006/09/19 11:14:19 honda Exp $
 */


/*
 *  ƥ˰¸Altera Nios II ȯå Stratix ѡ
 *
 *  Υ󥯥롼ɥեϡkernel.h  sil.h ǥ󥯥롼ɤ롥
 *  ¾Υե뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥
 *  롼ɤˡt_stddef.h  itron.h 󥯥롼ɤΤǡ
 *  ˰¸Ƥ褤
 */


#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/*
 *  ưåΥå̾
 */
#ifdef PE1
#define    TARGET_NAME    "Nios2 Development Board(PE1)"
#elif  PE2
#define    TARGET_NAME    "Nios2 Development Board(PE2)"
#elif  PE3
#define    TARGET_NAME    "Nios2 Development Board(PE3)"
#elif  PE4
#define    TARGET_NAME    "Nios2 Development Board(PE4)"
#endif 


/*
 *  ե졼¸
 */


/*
 * ץåID
 */
#ifdef PE1
#define PRCID 1
#elif  PE2
#define PRCID 2
#elif  PE3
#define PRCID 3
#elif  PE4
#define PRCID 4
#endif 


/*
 * ROM  RAM Υ١ɥ쥹
 */
#ifdef PE1
#define ROM_BASE   0x00000000
#define RAM_BASE   0x01100000 
#elif  PE2
#define ROM_BASE   0x00040000 
#define RAM_BASE   0x02100000 
#elif  PE3
#define ROM_BASE   0x00080000 
#define RAM_BASE   0x03100000 
#elif  PE4
#define ROM_BASE   0x000C0000 
#define RAM_BASE   0x04100000 
#endif 


/*
 * ROMԤ
 */ 
//#define BOOT_ROM

/*
 *   Ωѥåν
 */
#ifdef PE1
#define STACKTOP    0x01110000
#elif  PE2
#define STACKTOP    0x02110000
#elif  PE3
#define STACKTOP    0x03110000
#elif  PE4
#define STACKTOP    0x04110000
#endif 

/*
 *  ͤɽȥߥñ̤ȤѴ
 */
#define TIMER_CLOCK     50000

/*
 *  ƥå
 */
#define    TIC_NUME    1        /* ƥåμʬ */
#define    TIC_DENO    1        /* ƥåμʬ */

#define USE_JTAG_UART

/**
 *   ڥեΥڡɥ쥹
 */
#ifdef PE1
#define PERI_BASEADDR  0x01000000
#elif  PE2
#define PERI_BASEADDR  0x02000000
#elif  PE3
#define PERI_BASEADDR  0x03000000
#elif  PE4
#define PERI_BASEADDR  0x04000000
#endif

/*
 *  TIMER Υ١ɥ쥹
 */
#define TIM_BASE    (0x00000840 + PERI_BASEADDR)

/*
 * ͥǻѤ UART Υ١ɥ쥹
 */
#define UART_BASE   (0x00000860 + PERI_BASEADDR)

/*
 *  Mutex
 */ 
#define TSK_MUTEX   (0x00000810 + PERI_BASEADDR) 
#define OBJ_MUTEX   (0x00000820 + PERI_BASEADDR)

/*
 * ץåֳߥ쥸Υɥ쥹
 */
#define INTERPROC_BASE     0x800
#define INTERPROC_OFFSET   0x01000000
#define INTERPROC_CLEAR    (0x00000800 + PERI_BASEADDR)

/*
 *  TIM ߤγֹ
 */
#define TIM_INTLVL      0

/*
 * UART ߤγֹ
 */
#define UART_INTLVL     1

/*
 * ץåֳߤγֹ
 */ 
#define INTERPROCLVL    2

/*
 *  ꥢݡֹ˴ؤ
 */
#define TNUM_PORT   1   /* ݡȤ륷ꥢݡȤο */
#define TNUM_SIOP   1   /* ݡȤ륷ꥢI/OݡȤο */

/*
 *  ƥॿ˴ؤ
 */
#define LOGTASK_PORTID    1    /* ƥϤ륷ꥢݡֹ */

/*
 *  ԤΤ
 */
#define SIL_DLY_TIM1    420
#define SIL_DLY_TIM2    90


/*
 *  LED³ξ
 */
#define    LED_BASE  0x07110010


#endif /* _SYS_DEFS_H_ */
