/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: check.h,v 1.1 2005/04/03 13:33:19 honda Exp $
 */

/** \file
 *	顼åѥޥ
 *
 *  FDMPˤѹ
 *    - ֥IDϰϤȽ
 *        tmax_xxxǤϤʤccbΥȥ򸫤ƥåԤ
 *    - ֥IDΥå
 *       ccbȤƼVALID_XXIDƤӽФ.
 */

#ifndef _CHECK_H_
#define _CHECK_H_

/**
 *  ͥ٤ϰϤȽ
 */
#define VALID_TPRI(tpri) \
	(TMIN_TPRI <= (tpri) && (tpri) <= TMAX_TPRI)

/**
 *  ͥ٤ΥåE_PAR
 */
#define CHECK_TPRI(tpri) {					\
	if (!VALID_TPRI(tpri)) {				\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

#define CHECK_TPRI_INI(tpri) {					\
	if (!(VALID_TPRI(tpri) || (tpri) == TPRI_INI)) {	\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

#define CHECK_TPRI_SELF(tpri) {					\
	if (!(VALID_TPRI(tpri) || (tpri) == TPRI_SELF)) {	\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

/**
 *  ॢȻͤΥåE_PAR
 */
#define CHECK_TMOUT(tmout) {					\
	if (!(TMO_FEVR <= (tmout))) {				\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

/**
 *  ¾Υѥ᡼顼ΥåE_PAR
 */
#define CHECK_PAR(exp) {					\
	if (!(exp)) {						\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

/**
 *  ֥IDϰϤȽ
 */
#define VALID_TSKID(cbtcb, tskid) \
	(TMIN_ID <= (tskid) && (tskid) <= (cbtcb).max_id)

#define VALID_SEMID(cbtcb, semid) \
	(TMIN_ID <= (semid) && (semid) <= (cbtcb).max_id)

#define VALID_FLGID(cbtcb, flgid) \
	(TMIN_ID <= (flgid) && (flgid) <= (cbtcb).max_id)

#define VALID_DTQID(cbtcb, dtqid) \
	(TMIN_ID <= (dtqid) && (dtqid) <= (cbtcb).max_id)

#define VALID_MBXID(cbtcb, mbxid) \
	(TMIN_ID <= (mbxid) && (mbxid) <= (cbtcb).max_id)

#define VALID_MPFID(cbtcb, mpfid) \
	(TMIN_ID <= (mpfid) && (mpfid) <= (cbtcb).max_id)

#define VALID_CYCID(cbtcb, cycid) \
	(TMIN_ID <= (cycid) && (cycid) <= (cbtcb).max_id)

/*
 *  ֥IDΥåE_ID
 */
#define CHECK_TSKID(ccb, tskid) {				\
	if (!VALID_TSKID(ccb->tsk, tskid)) {			\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_TSKID_SELF(ccb, tskid) {			\
	if (!(VALID_TSKID(ccb->tsk, tskid) || (tskid) == TSK_SELF)) {	\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_SEMID(ccb, semid) {					\
	if (!VALID_SEMID(ccb->sem, semid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_FLGID(ccb, flgid) {					\
	if (!VALID_FLGID(ccb->sem, flgid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_DTQID(ccb, dtqid) {					\
	if (!VALID_DTQID(ccb->dtq, dtqid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_MBXID(ccb, mbxid) {					\
	if (!VALID_MBXID(ccb->mbx, mbxid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_MPFID(ccb, mpfid) {					\
	if (!VALID_MPFID(ccb->mpf, mpfid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_CYCID(ccb, cycid) {					\
	if (!VALID_CYCID(ccb->cyc, cycid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

/*
 *  ƽФƥȤΥåE_CTX
 */
#define CHECK_TSKCTX() {					\
	if (sense_context()) {					\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

#define CHECK_INTCTX() {					\
	if (!sense_context()) {					\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

/*
 *  ƽФƥȤCPUå֤ΥåE_CTX
 */
#define CHECK_TSKCTX_UNL() {					\
	if (sense_context() || t_sense_lock()) {		\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

#define CHECK_INTCTX_UNL() {					\
	if (!sense_context() || i_sense_lock()) {		\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

/**
 *  ǥѥåα֤ǤʤΥåE_CTX
 */
#define CHECK_DISPATCH() {					\
	if (sense_context() || t_sense_lock() || !(enadsp)) {	\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

/**
 *  ¾Υƥȥ顼ΥåE_CTX
 */
#define CHECK_CTX(exp) {					\
	if (!(exp)) {						\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

/**
 *  ꤷƤʤΥåE_ILUSE
 */
#define CHECK_NONSELF(tcb) {					\
	if ((tcb) == runtsk) {					\
		ercd = E_ILUSE;					\
		goto exit;					\
	}							\
}

/**
 *  ¾ѥ顼ΥåE_ILUSE
 */
#define CHECK_ILUSE(exp) {					\
	if (!(exp)) {						\
		ercd = E_ILUSE;					\
		goto exit;					\
	}							\
}

#endif /* _CHECK_H_ */
