/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: class.c,v 1.5 2007/05/28 01:44:28 honda Exp $
 */

/** \file
 *  饹⥸塼
 */

#include "fdmp_kernel.h"
#include "task.h"
#include "class.h"

#ifdef __classini

/**
 *  CCB Υꥢ
 */
CCB	ccb_table[NUM_CLASS];

/**
 *  CCB Ψɤ뤿Υݥѿ
 */
CCB	*my_local_ccb;


/**
 *  EXCCB Ψɤ뤿Υݥѿ
 */
EXCCB	*my_local_exccb;

/**
 *  ѥ饹ȥ֥åν
 *
 *  ХCCBơ֥μץå륯饹 (Ūˤϡ
 *  ץåΥ륯饹) б륨ȥ롥
 *  ƥ֥ȤΥȥϳƥ֥Ȥexccb롼ǽ
 *  롥
 */

void
exccb_initialize()
{
	my_local_exccb = get_exccb(CLS_MY_LOCAL);
	my_local_exccb->prcid = PRCID;
	my_local_exccb->tsk_lock_ptr = init_tsk_lock();
	my_local_exccb->obj_lock_ptr = init_obj_lock();

	my_local_ccb = get_ccb(CLS_MY_LOCAL);
}

#endif /* __classini */

/**
 *  ƥץåˤĤƥХCCBơ֥CCBơ֥Ѵ
 *
 *  ץå CCB ˤĤƤϤǤ˽
 */
#ifdef __classconv

void
ccb_convert()
{
	EXCCB	*exccb;
	CCB		*ccb;
	ID		clsid;

	/*
	 * 饹֤
	 */
	for (clsid = 1; clsid <= NUM_CLASS; clsid++) {
		exccb = get_exccb(clsid);
		ccb = get_ccb(clsid);

		if (clsid == CLS_MY_LOCAL) {
			ccb->prcid = 0;
			ccb->tsk_lock.lock_ops.acquire_lock
			  = LOCKOPS_MY_LOCAL_ACQUIRE_LOCK;
			ccb->tsk_lock.lock_ops.release_lock
			  = LOCKOPS_MY_LOCAL_RELEASE_LOCK;
			ccb->obj_lock.lock_ops.acquire_lock
			  = LOCKOPS_MY_LOCAL_ACQUIRE_LOCK;
			ccb->obj_lock.lock_ops.release_lock
			  = LOCKOPS_MY_LOCAL_RELEASE_LOCK;
		} else {
			ccb->prcid = exccb->prcid;
            ccb->clsid = clsid;
			ccb->tsk_lock.lock_ops.acquire_lock
			  = LOCKOPS_LOCAL_ACQUIRE_LOCK;
			ccb->tsk_lock.lock_ops.release_lock
			  = LOCKOPS_LOCAL_RELEASE_LOCK;
			ccb->obj_lock.lock_ops.acquire_lock
			  = LOCKOPS_LOCAL_ACQUIRE_LOCK;
			ccb->obj_lock.lock_ops.release_lock
			  = LOCKOPS_LOCAL_RELEASE_LOCK;
		}

		ccb->obj_lock.lock_ptr = exccb->obj_lock_ptr;
		ccb->tsk_lock.lock_ptr = exccb->tsk_lock_ptr;
		
		ccb->p_ready_queue  = exccb->p_ready_queue;
		ccb->p_ready_primap = exccb->p_ready_primap;
		ccb->p_runtsk       = exccb->p_runtsk;
		ccb->p_schedtsk     = exccb->p_schedtsk;
		ccb->p_enadsp       = exccb->p_enadsp;
		ccb->p_tmevt_heap   = exccb->p_tmevt_heap;
		ccb->p_last_index   = exccb->p_last_index;
        ccb->p_current_time = exccb->p_current_time;
        ccb->p_next_time    = exccb->p_next_time;
#if TIC_DENO != 1
        ccb->p_next_subtime = exccb->p_next_subtime;
#endif /* TIC_DENO != 1 */        
        
		ccb->tsk = exccb->tsk;
		ccb->sem = exccb->sem;
		ccb->flg = exccb->flg;
		ccb->dtq = exccb->dtq;
		ccb->mbx = exccb->mbx;
		ccb->mpf = exccb->mpf;
		ccb->cyc = exccb->cyc;

		ccb->p_activate_r  = exccb->p_activate_r;
		ccb->p_call_cychdr = exccb->p_call_cychdr;
	}
}

#endif /* __classconv */
