/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: class.h,v 1.6 2007/05/28 01:44:28 honda Exp $
 */

/** \file
 *  饹⥸塼
 */

#ifndef _CLASS_H_
#define _CLASS_H_

/*
 *  
 */ 
typedef struct time_event_node  TMEVTN;
typedef struct task_control_block TCB;

#include "queue.h"
#include "lock.h"

/**
 *  饹ο
 * 
 *  ܥͥϡ줾ΥץåΥ륯饹ΤߥݡȤ
 *  뤿ᡤ
 *     NUM_CLASS = ץå
 *  Ȥ롥
 */
#define NUM_CLASS (NO_PROC)

/**
 *  饹ID 
 *
 *  ܥͥϥ륯饹ΤߥݡȤƤ뤿ᡤ
 *  륯饹ID = ץåID(PROCID) Ȥ롥
 *
 */
#define CLS_MY_LOCAL	(PRCID)	/* ץåΥ륯饹 */

/**
 * CB Table Control Block(CBTCB)
 *
 * CCBإ䥪֥ȡʥޥե䥤٥ȥե饰ʤɡˤID
 * Ͽ빽¤Ρcb_tableˤϥƥ֥Ȥδ֥åϿ
 * 롥
 */
typedef struct cb_table_control_block {
	void *cb_table;
	ID   max_id;
} CBTCB;

/**
 *  ֥ID ϰϡʺͰ⤫ˤå롥
 */
#define CHK_OBJID(cbtcb, id) (0 < (id) && (id) <= (cbtcb)->max_id)

/**
 *  Exported Class Control Block(EXCCB)
 *
 *  ƥץåˤơ¾Υץå˸񸻤˴ؤ
 *  Ͽ뤿ι¤Ρ
 *  ͭ ex_ccb_table ȤPEΰݤ롥
 *  ¹ԻϡEXCCBƥץåǤμ¹Ի˻Ȥפ
 *  CCB˥ԡ
 *
 */
typedef struct ex_class_control_block {
	INT     prcid;
	void    *tsk_lock_ptr;
	void    *obj_lock_ptr;

	QUEUE   *p_ready_queue;
	UINT    *p_ready_primap;
	TCB	    **p_runtsk;
	TCB	    **p_schedtsk;
	BOOL    *p_enadsp;
	TMEVTN  *p_tmevt_heap;
	UINT    *p_last_index;
    SYSTIM	*p_current_time;
    SYSTIM	*p_next_time;
#if TIC_DENO != 1    
    UINT    *p_next_subtime;
#endif /* TIC_DENO != 1 */    
	CBTCB   tsk;
	CBTCB   sem;
	CBTCB   flg;
	CBTCB   dtq;
	CBTCB   mbx;
	CBTCB   mpf;
	CBTCB   cyc;

	FP      p_activate_r;
	FP      p_call_cychdr;
} EXCCB;

/**
 *  EXCCBΥꥢ
 *    EXCCBΥꥢϥƥΤ1
 *    EXCCBΰϥåȰ¸ǳݤ 
 */
extern EXCCB	exported_ccb_table[NUM_CLASS];

/**
 * 饹IDEXCCBФ
 */
#define get_exccb(clsid) (&exported_ccb_table[(clsid) - 1])

/**
 *  Class Control Block(CCB)
 *
 *  PE¸
 *  PEEXCCB򸵤ˤΥǡʼʬ䤹ˤ
 *  饹ʬǿʰʲ,ڡˢpri+locproc+glo
 */
typedef struct class_control_block {
	INT     prcid;
    ID      clsid;
	LOCKOBJ tsk_lock;
	LOCKOBJ obj_lock;

	QUEUE   *p_ready_queue;
	UINT    *p_ready_primap;
	TCB	    **p_runtsk;
	TCB	    **p_schedtsk;
	BOOL    *p_enadsp;
	TMEVTN  *p_tmevt_heap;
	UINT    *p_last_index;
    SYSTIM	*p_current_time;
    SYSTIM	*p_next_time;
#if TIC_DENO != 1    
    UINT    *p_next_subtime;
#endif /* TIC_DENO != 1 */    
	CBTCB   tsk;
	CBTCB   sem;
	CBTCB   flg;
	CBTCB   dtq;
	CBTCB   mbx;
	CBTCB   mpf;
	CBTCB   cyc;

	FP      p_activate_r;
	FP      p_call_cychdr;
}CCB;

/**
 *  CCB Υꥢ
 * 
 *  CCB ΥꥢϡPEˡ̾ϤPEΥѰդ롥
 */
extern CCB	ccb_table[NUM_CLASS];

/**
 *  CCB Ψɤ뤿Υݥѿ
 */
extern CCB	*my_local_ccb;


/**
 *  EXCCB Ψɤ뤿Υݥѿ
 */
extern EXCCB	*my_local_exccb;


/**
 *  ¹楿CCB (task.c)
 *
 *  Ǥϥ륿ʤᡤmy_local_ccb  define 
 */
#define runccb my_local_ccb

/**
 *  ID 򥯥饹ID Ȥ¾ʬʬ򤹤뤿Υޥ
 *
 *  32bit ͤH (16bitդ) ˥㥹Ȥ塤ID (32bit
 *  դ) ˥㥹Ȥ뤳Ȥǡ 16bit  32bit ĥ롥
 * 
 *  @todo
 *  桼˳ɬפϤʤ 
 */
#define get_clsid(id)		((ID)((H)((id) >> 16)))
#define get_clsid_self(id)   \
  (((id) >> 16) == TCLS_SELF ? CLS_MY_LOCAL : ((ID)((H)((id) >> 16))))
#define remove_clsid(id)	((ID)((H)(id)))

/**
 *  饹ID  CCB Ф
 */
#define get_ccb(clsid) (&ccb_table[(clsid) - 1])

/**
 * 饹ID  CCB Ф(IDб)
 * 
 * 󥿥ƥȤˤ my_local_ccb ְȤ
 */
#define t_get_ccb_self(clsid)	\
    ((clsid) == TCLS_SELF ? runccb : get_ccb(clsid))

#define i_get_ccb_self(clsid)	\
    ((clsid) == TCLS_SELF ? my_local_ccb : get_ccb(clsid))

/**
 * 饹ID Υå(IDб)
 */
#define VALID_CLSID(clsid) \
	(0 < (clsid) && (clsid) <= NUM_CLASS)

#define CHECK_CLSID_SELF(clsid) { \
	if (!(VALID_CLSID(clsid) || (clsid) == TCLS_SELF)) {	\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

extern void	init_my_local_ccb();
extern void	exccb_initialize();
extern void	ccb_convert();

#endif /*_CLASS_H_*/
