/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: cyclic.c,v 1.6 2007/05/28 01:44:28 honda Exp $
 */

/** \file
 *	ϥɥ鵡ǽ
 *
 *  MPˤѹ
 *   - cyclic_initialize() : exported_ccb_table[] νɲ
 */

#include "fdmp_kernel.h"
#include "check.h"
#include "cyclic.h"


/**
 *  ϥɥIDκ͡kernel_cfg.c
 */
extern const ID	tmax_cycid;

/**
 *  ϥɥ֥åΥꥢkernel_cfg.c
 */
extern const CYCINIB	cycinib_table[];

/**
 *  ϥɥ֥åΥꥢkernel_cfg.c
 */
extern CYCCB	cyccb_table[];

/**
 *  ϥɥο
 */
#define TNUM_CYC	((UINT)(tmax_cycid - TMIN_ID + 1))

/*
 *  ϥɥIDϥɥ֥åФΥޥ
 */
#define INDEX_CYC(cycid)	((UINT)((cycid) - TMIN_ID))
#define get_cyccb(ccb, cycid)	(&(((CYCCB *)(ccb->cyc.cb_table))[INDEX_CYC(cycid)]))

/**
 *  ޤϥɥη
 */
typedef void	(*CYCHDR)(VP_INT exinf);

/**
 *  ϥɥ鵡ǽν
 */
#ifdef __cycini

void
cyclic_initialize()
{	
	my_local_exccb->p_call_cychdr = call_cychdr;
	
	my_local_exccb->cyc.cb_table = &cyccb_table[0];
	my_local_exccb->cyc.max_id   = tmax_cycid;
}

#endif /* __cycini */

/**
 * ͥ뵯ưTA_STAμϥɥФ뵯ư
 *   my_local_ccbƤ򻲾Ȥɬפ뤿ᡤmy_local_ccb
 *   ˸ƤӽФcyclic_initialize() ʬΥ
 */
#ifdef __cycinista

void
cyclic_init_sta(void)
{
	UINT	i;
	CYCCB	*cyccb;

	for (cyccb = cyccb_table, i = 0; i < TNUM_CYC; cyccb++, i++) {
		cyccb->cycinib = &(cycinib_table[i]);
		if ((cyccb->cycinib->cycatr & TA_STA) != 0) {
			cyccb->cycsta = TRUE;
			tmevtb_enqueue_cyc(my_local_ccb, cyccb, cyccb->cycinib->cycphs);
		}
		else {
			cyccb->cycsta = FALSE;
		}
	}
}

#endif /* __cycinista */

/**
 *  ϥɥ鵯ưΤΥ।٥ȥ֥åϿ
 */
#ifdef __cycenq

void
tmevtb_enqueue_cyc(CCB *ccb, CYCCB *cyccb, EVTTIM evttim)
{
	tmevtb_enqueue_evttim(ccb, &(cyccb->tmevtb), evttim,
						  (CBACK) ccb->p_call_cychdr, (VP) cyccb);
	cyccb->evttim = evttim;
}

#endif /* __cycenq */

/**
 *  ϥɥư
 */
#ifdef __sta_cyc

SYSCALL ER
sta_cyc(ID cycid)
{
	CYCCB	*cyccb;
	ER		ercd;
	CCB		*ccb;

	LOG_STA_CYC_ENTER(cycid);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(cycid)); 
	ccb = t_get_ccb_self(get_clsid(cycid)); 
	cycid = remove_clsid(cycid);
	CHECK_CYCID(ccb, cycid);
	cyccb = get_cyccb(ccb, cycid);

  retry:
	T_ACQUIRE_LOCK(ccb->tsk_lock);
	if (cyccb->cycsta) {
		tmevtb_dequeue(ccb, &(cyccb->tmevtb));
	}
	else {
		cyccb->cycsta = TRUE;
	}
	tmevtb_enqueue_cyc(ccb, cyccb, base_time(ccb) + cyccb->cycinib->cyctim);
	ercd = E_OK;
	T_RELEASE_LOCK(ccb->tsk_lock);
	
	exit:
	LOG_STA_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __sta_cyc */

/**
 *  ϥɥư
 */
#ifdef __stp_cyc

SYSCALL ER
stp_cyc(ID cycid)
{
	CYCCB	*cyccb;
	ER		ercd;
	CCB		*ccb;

	LOG_STP_CYC_ENTER(cycid);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(cycid)); 
	ccb = i_get_ccb_self(get_clsid(cycid));
	cycid = remove_clsid(cycid);
	CHECK_CYCID(ccb, cycid);
	cyccb = get_cyccb(ccb, cycid);

  retry:
	T_ACQUIRE_LOCK(ccb->tsk_lock);
	if (cyccb->cycsta) {
		cyccb->cycsta = FALSE;
		tmevtb_dequeue(ccb, &(cyccb->tmevtb));
	}
	ercd = E_OK;
	T_RELEASE_LOCK(ccb->tsk_lock);

	exit:
	LOG_STP_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __stp_cyc */

/**
 *  ϥɥ鵯ư롼
 */
#ifdef __cyccal

void
call_cychdr(CYCCB *cyccb)
{
	
	/*
	 *  εưΤΥ।٥ȥ֥åϿ롥
	 *
	 *  ƱƥåǼϥɥٵư٤ˤϡ
	 *  δؿ isig_tim äˡ٤δؿƤФ
	 *  Ȥˤʤ롥
	 */
	tmevtb_enqueue_cyc(my_local_ccb, cyccb, cyccb->evttim + cyccb->cycinib->cyctim);

	/*
	 *  ϥɥCPUå֤ĥå
	 *  ǸƤӽФ
	 */
	I_RELEASE_LOCK(my_local_ccb->tsk_lock);
	LOG_CYC_ENTER(cyccb);
	((CYCHDR)(*cyccb->cycinib->cychdr))(cyccb->cycinib->exinf);
	LOG_CYC_LEAVE(cyccb);
  retry:
	I_ACQUIRE_LOCK(my_local_ccb->tsk_lock);
}

#endif /* __cyccal */
