/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: dataqueue.c,v 1.7 2007/05/28 01:44:28 honda Exp $
 */

/** \file
 *	ǡ塼ǽ
 *
 */

#include "fdmp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "dataqueue.h"

/**
 *  ǡ塼IDκ͡kernel_cfg.c
 */
extern const ID	tmax_dtqid;

/**
 *  ǡ塼֥åΥꥢkernel_cfg.c
 */
extern const DTQINIB	dtqinib_table[];

/**
 *  ǡ塼ο
 */
#define TNUM_DTQ	((UINT)(tmax_dtqid - TMIN_ID + 1))

/**
 *  ǡ塼֥åΥꥢkernel_cfg.c
 */
extern DTQCB	dtqcb_table[];

/*
 *  ǡ塼IDǡ塼֥åФΥޥ
 */
#define INDEX_DTQ(dtqid)	((UINT)((dtqid) - TMIN_ID))
#define get_dtqcb(ccb, dtqid)	(&(((DTQCB *)(ccb->dtq.cb_table))[INDEX_DTQ(dtqid)]))


/**
 *  ǡ塼Ԥ֥å
 *
 *  ǡ塼ؤԤȥǡ塼μԤǡƱԤ
 *  ֥åȤ
 */
typedef struct dataqueue_waiting_information {
	WINFO	winfo;		/* ɸԤ֥å */
	WOBJCB	*wobjcb;	/* Ԥ֥Ȥδ֥å */
    ID		clsid;		/* Ԥ֥Ȥ°Ƥ륯饹Υ饹ID */
	VP_INT	data;		/* ǡ  */
} WINFO_DTQ;

/**
 *  ǡ塼ǽν
 */
#ifdef __dtqini

void
dataqueue_initialize(void)
{
	UINT	i;
	DTQCB	*dtqcb;

	for (dtqcb = dtqcb_table, i = 0; i < TNUM_DTQ; dtqcb++, i++) {
		queue_initialize(&(dtqcb->swait_queue));
		dtqcb->dtqinib = &(dtqinib_table[i]);
		queue_initialize(&(dtqcb->rwait_queue));
		dtqcb->count = 0;
		dtqcb->head = 0;
		dtqcb->tail = 0;
	}

	my_local_exccb->dtq.cb_table = &dtqcb_table[0];
	my_local_exccb->dtq.max_id   = tmax_dtqid;
}

#endif /* __dtqini */

/**
 *  ǡ塼ΰ˥ǡǼ
 */
#ifdef __dtqenq

BOOL
enqueue_data(DTQCB *dtqcb, VP_INT data)
{
	if (dtqcb->count < dtqcb->dtqinib->dtqcnt) {
		*((VP_INT *)(dtqcb->dtqinib->dtq) + dtqcb->tail) = data;
		dtqcb->count++;
		dtqcb->tail++;
		if (dtqcb->tail >= dtqcb->dtqinib->dtqcnt) {
			dtqcb->tail = 0;
		}
		return(TRUE);
	}
	return(FALSE);
}

#endif /* __dtqenq */

/**
 *  ǡ塼ΰ˥ǡǼ
 */
#ifdef __dtqfenq

void
force_enqueue_data(DTQCB *dtqcb, VP_INT data)
{
	*((VP_INT *)(dtqcb->dtqinib->dtq) + dtqcb->tail) = data;
	dtqcb->tail++;
	if (dtqcb->tail >= dtqcb->dtqinib->dtqcnt) {
		dtqcb->tail = 0;
	}
	if (dtqcb->count < dtqcb->dtqinib->dtqcnt) {
		dtqcb->count++;
	}
	else {
		dtqcb->head = dtqcb->tail;
	}
}

#endif /* __dtqfenq */

/**
 *  ǡ塼ΰ褫ǡФ
 */
#ifdef __dtqdeq

void
dequeue_data(DTQCB *dtqcb, VP_INT *p_data)
{	
	*p_data = *((VP_INT *)(dtqcb->dtqinib->dtq) + dtqcb->head);
	dtqcb->count--;
	dtqcb->head++;
	if (dtqcb->head >= dtqcb->dtqinib->dtqcnt) {
		dtqcb->head = 0;
	}	
}

#endif /* __dtqdeq */

/**
 *  ǡ塼ؤ
 *
 */
#ifdef __snd_dtq

SYSCALL ER
snd_dtq(ID dtqid, VP_INT data)
{
	DTQCB	*dtqcb;
	WINFO_DTQ winfo;
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb, *tccb;
	BOOL	dspreq = FALSE;	

	LOG_SND_DTQ_ENTER(dtqid, data);
	CHECK_CLSID_SELF(get_clsid(dtqid)); 
	ccb = t_get_ccb_self(get_clsid(dtqid));
	dtqid = remove_clsid(dtqid);
	CHECK_DTQID(ccb, dtqid);
	dtqcb = get_dtqcb(ccb, dtqid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	/*
	 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
	 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
	 */
	if (!(queue_empty(&(dtqcb->rwait_queue)))) {
		tcb = (TCB *)(dtqcb->rwait_queue.next);
		tccb = get_ccb(tcb->clsid);
		T_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		/* Ԥ塼Ƭإǡ */
		queue_delete((QUEUE *) tcb);
		((WINFO_DTQ *)(tcb->winfo))->data = data;
		if (wait_complete(tccb, tcb)) {
			dspreq = dispatch_request(tccb->prcid);
		}
		T_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq);
		ercd = E_OK;
	}
	else if (enqueue_data(dtqcb, data)) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_OK;
	}
	else {
		winfo.data = data;
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(ccb->obj_lock);
		wobj_make_wait(ccb->clsid, (WOBJCB *) dtqcb, (WINFO_WOBJ *) &winfo);
		T_RELEASE_NESTED_LOCK(runccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK(ccb->obj_lock);
		dispatch();
		ercd = winfo.winfo.wercd;
	}
	t_unlock_cpu();

  exit:
	LOG_SND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __snd_dtq */

/**
 *  ǡ塼ؤʥݡ󥰡
 */
#ifdef __psnd_dtq

SYSCALL ER
psnd_dtq(ID dtqid, VP_INT data)
{
	DTQCB	*dtqcb;
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb, *tccb;
	BOOL	dspreq = FALSE;
	
	LOG_PSND_DTQ_ENTER(dtqid, data);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(dtqid)); 
	ccb = t_get_ccb_self(get_clsid(dtqid));
	dtqid = remove_clsid(dtqid);
	CHECK_DTQID(ccb, dtqid);
	dtqcb = get_dtqcb(ccb, dtqid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	/*
	 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
	 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
	 */
	if (!(queue_empty(&(dtqcb->rwait_queue)))) {
		tcb = (TCB *)(dtqcb->rwait_queue.next);
		tccb = get_ccb(tcb->clsid);
		T_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		/* Ԥ塼Ƭإǡ */
		queue_delete((QUEUE *) tcb);
		((WINFO_DTQ *)(tcb->winfo))->data = data;
		if (wait_complete(tccb, tcb)) {
			dspreq = dispatch_request(tccb->prcid);
		}
		T_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		ercd = E_OK;
	}
	else if (enqueue_data(dtqcb, data)) {
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	T_RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq);

  exit:
	LOG_PSND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __psnd_dtq */

/**
 *  ǡ塼ؤʥݡ󥰡󥿥ƥѡ
 */
#ifdef __ipsnd_dtq

SYSCALL ER
ipsnd_dtq(ID dtqid, VP_INT data)
{
	DTQCB	*dtqcb;
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb, *tccb;

	LOG_IPSND_DTQ_ENTER(dtqid, data);
	CHECK_INTCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(dtqid)); 
	ccb = i_get_ccb_self(get_clsid(dtqid));
	dtqid = remove_clsid(dtqid);
	CHECK_DTQID(ccb, dtqid);
	dtqcb = get_dtqcb(ccb, dtqid);

  retry:
	I_ACQUIRE_LOCK(ccb->obj_lock);
	/*
	 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
	 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
	 */
	if (!(queue_empty(&(dtqcb->rwait_queue)))) {	
		tcb = (TCB *)(dtqcb->rwait_queue.next);
		tccb = get_ccb(tcb->clsid);
		I_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		/* Ԥ塼Ƭإǡ */
		queue_delete((QUEUE *) tcb);
		((WINFO_DTQ *)(tcb->winfo))->data = data;
		if (wait_complete(tccb, tcb)) {
			if (dispatch_request(tccb->prcid)) {
				reqflg = TRUE;
			}
		}
		I_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		ercd = E_OK;
	}
	else if (enqueue_data(dtqcb, data)) {
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	I_RELEASE_LOCK(ccb->obj_lock);

  exit:
	LOG_IPSND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __ipsnd_dtq */

/**
 *  ǡ塼ؤʥॢȤ
 */
#ifdef __tsnd_dtq

SYSCALL ER
tsnd_dtq(ID dtqid, VP_INT data, TMO tmout)
{
	DTQCB	*dtqcb;
	WINFO_DTQ winfo;
	TMEVTB	tmevtb;
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb, *tccb;
	BOOL	dspreq = FALSE;
	
	LOG_TSND_DTQ_ENTER(dtqid, data, tmout);
	CHECK_DISPATCH();
	CHECK_CLSID_SELF(get_clsid(dtqid)); 
	ccb = t_get_ccb_self(get_clsid(dtqid));    
	dtqid = remove_clsid(dtqid);
	CHECK_DTQID(ccb, dtqid);
	CHECK_TMOUT(tmout);
	dtqcb = get_dtqcb(ccb, dtqid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	/*
	 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
	 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
	 */
	if (!(queue_empty(&(dtqcb->rwait_queue)))) {
		tcb = (TCB *)(dtqcb->rwait_queue.next);
		tccb = get_ccb(tcb->clsid);
		T_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		/* Ԥ塼Ƭإǡ */
		queue_delete((QUEUE *) tcb);
		((WINFO_DTQ *)(tcb->winfo))->data = data;
		if (wait_complete(tccb, tcb)) {
			dspreq = dispatch_request(tccb->prcid);
		}
		T_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq);
		ercd = E_OK;
	}
	else if (enqueue_data(dtqcb, data)) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_TMOUT;
	}
	else {
		winfo.data = data;
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(ccb->obj_lock);
		wobj_make_wait_tmout(ccb->clsid, (WOBJCB *) dtqcb, (WINFO_WOBJ *) &winfo,
						&tmevtb, tmout);
		T_RELEASE_NESTED_LOCK(runccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK(ccb->obj_lock);
		dispatch();
		ercd = winfo.winfo.wercd;
	}
	t_unlock_cpu();

  exit:
	LOG_TSND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __tsnd_dtq */

/*
 *  ǡ塼ؤζ
 * 
 */
#ifdef __fsnd_dtq

SYSCALL ER
fsnd_dtq(ID dtqid, VP_INT data)
{
	DTQCB	*dtqcb;	
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb, *tccb;
	BOOL	dspreq = FALSE;
	
	LOG_FSND_DTQ_ENTER(dtqid, data);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(dtqid)); 
	ccb = t_get_ccb_self(get_clsid(dtqid));        
	dtqid = remove_clsid(dtqid);
	CHECK_DTQID(ccb, dtqid);
	dtqcb = get_dtqcb(ccb, dtqid);
	CHECK_ILUSE(dtqcb->dtqinib->dtqcnt > 0);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	/*
	 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
	 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
	 */
	if (!(queue_empty(&(dtqcb->rwait_queue)))) {
		tcb = (TCB *)(dtqcb->rwait_queue.next);
		tccb = get_ccb(tcb->clsid);
		T_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		/* Ԥ塼Ƭإǡ */
		queue_delete((QUEUE *) tcb);
		((WINFO_DTQ *)(tcb->winfo))->data = data;
		if (wait_complete(tccb, tcb)) {
			dspreq = dispatch_request(tccb->prcid);
		}
		T_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
	}
	else {
		force_enqueue_data(dtqcb, data);
	}
	T_RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq)
	ercd = E_OK;

  exit:
	LOG_FSND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __fsnd_dtq */

/**
 *  ǡ塼ؤζ󥿥ƥѡ
 */
#ifdef __ifsnd_dtq

SYSCALL ER
ifsnd_dtq(ID dtqid, VP_INT data)
{
	DTQCB	*dtqcb;
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb, *tccb;

	LOG_IFSND_DTQ_ENTER(dtqid, data);
	CHECK_INTCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(dtqid)); 
	ccb = i_get_ccb_self(get_clsid(dtqid));
	CHECK_DTQID(ccb, dtqid);
	dtqcb = get_dtqcb(ccb, dtqid);
	CHECK_ILUSE(dtqcb->dtqinib->dtqcnt > 0);

  retry:
	I_ACQUIRE_LOCK(ccb->obj_lock);
	/*
	 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
	 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
	 */
	if (!(queue_empty(&(dtqcb->rwait_queue)))) {
		tcb = (TCB*) (dtqcb->rwait_queue.next);
		tccb = get_ccb(tcb->clsid);
		I_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		/* Ԥ塼Ƭإǡ */
		queue_delete((QUEUE *) tcb);
		((WINFO_DTQ *)(tcb->winfo))->data = data;
		if (wait_complete(tccb, tcb)) {
			if (dispatch_request(tccb->prcid)) {
				reqflg = TRUE;
			}
		}
		I_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
	}
	else {
		force_enqueue_data(dtqcb, data);
	}
	I_RELEASE_LOCK(ccb->obj_lock);
	ercd = E_OK;

  exit:
	LOG_IFSND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __ifsnd_dtq */

/**
 *  ǡ塼μ
 */
#ifdef __rcv_dtq

SYSCALL ER
rcv_dtq(ID dtqid, VP_INT *p_data)
{
	DTQCB	*dtqcb;
	WINFO_DTQ winfo;
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb, *tccb;
	BOOL	dspreq = FALSE;

	LOG_RCV_DTQ_ENTER(dtqid, p_data);
	CHECK_DISPATCH();
	CHECK_CLSID_SELF(get_clsid(dtqid)); 
	ccb = t_get_ccb_self(get_clsid(dtqid));
	dtqid = remove_clsid(dtqid);
	CHECK_DTQID(ccb, dtqid);
	dtqcb = get_dtqcb(ccb, dtqid);
	
  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	/*
	 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
	 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
	 */	
	if (!(queue_empty(&(dtqcb->swait_queue)))) {
		/* Ԥ */
		tcb = (TCB *)(dtqcb->swait_queue.next);
		tccb = get_ccb(tcb->clsid);
		T_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		queue_delete((QUEUE *) tcb);
		if (dtqcb->count > 0) {
			dequeue_data(dtqcb, p_data);
			enqueue_data(dtqcb, ((WINFO_DTQ *)(tcb->winfo))->data);
		}
		else {
			*p_data = ((WINFO_DTQ *)(tcb->winfo))->data;
		}
		if (wait_complete(tccb, tcb)) {
			dspreq = dispatch_request(tccb->prcid);
		}
		T_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq);
		ercd = E_OK;
	}
	else if (dtqcb->count > 0) {
		/* Хåե˥ǡꡤԤʤ */
		dequeue_data(dtqcb, p_data);
		RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq);
		ercd = E_OK;
	}
	else {
		/* Хåե Ԥʤ */
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(ccb->obj_lock);
		runtsk->tstat = (TS_WAITING | TS_WAIT_WOBJ);
		make_wait(&(winfo.winfo));
		queue_insert_prev(&(dtqcb->rwait_queue),
						  &(runtsk->task_queue));
		winfo.clsid = ccb->clsid;
		winfo.wobjcb = (WOBJCB *) dtqcb;
		T_RELEASE_NESTED_LOCK(runccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK(ccb->obj_lock);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_data = winfo.data;
		}
	}
	t_unlock_cpu();

  exit:
	LOG_RCV_DTQ_LEAVE(ercd, *p_data);
	return(ercd);
}

#endif /* __rcv_dtq */

/**
 *  ǡ塼μʥݡ󥰡
 */
#ifdef __prcv_dtq

SYSCALL ER
prcv_dtq(ID dtqid, VP_INT *p_data)
{
	DTQCB	*dtqcb;
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb, *tccb;
	BOOL	dspreq = FALSE;

	LOG_PRCV_DTQ_ENTER(dtqid, p_data);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(dtqid)); 
	ccb = t_get_ccb_self(get_clsid(dtqid));
	dtqid = remove_clsid(dtqid);
	CHECK_DTQID(ccb, dtqid);
	dtqcb = get_dtqcb(ccb, dtqid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	/*
	 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
	 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
	 */	
	if (!(queue_empty(&(dtqcb->swait_queue)))) {
		/* Ԥ */
		tcb = (TCB *)(dtqcb->swait_queue.next);
		tccb = get_ccb(tcb->clsid);
		T_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		queue_delete((QUEUE *) tcb);
		if (dtqcb->count > 0) {
			dequeue_data(dtqcb, p_data);
			enqueue_data(dtqcb, ((WINFO_DTQ *)(tcb->winfo))->data);
		}
		else {
			*p_data = ((WINFO_DTQ *)(tcb->winfo))->data;
		}
		if (wait_complete(tccb, tcb)) {
			dspreq = dispatch_request(tccb->prcid);
		}
		T_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		ercd = E_OK;
	}
	else if (dtqcb->count > 0) {
		/* Хåե˥ǡꡤԤʤ */
		dequeue_data(dtqcb, p_data);
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	T_RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq);

  exit:
	LOG_PRCV_DTQ_LEAVE(ercd, *p_data);
	return(ercd);
}

#endif /* __prcv_dtq */

/**
 *  ǡ塼μʥॢȤ
 */
#ifdef __trcv_dtq

SYSCALL ER
trcv_dtq(ID dtqid, VP_INT *p_data, TMO tmout)
{
	DTQCB	*dtqcb;
	WINFO_DTQ winfo;
	TMEVTB	tmevtb;
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb, *tccb;
	ID		clsid;
	BOOL	dspreq = FALSE;

	LOG_TRCV_DTQ_ENTER(dtqid, p_data, tmout);
	CHECK_DISPATCH();
	CHECK_CLSID_SELF(get_clsid(dtqid)); 
	ccb = t_get_ccb_self(get_clsid(dtqid));
	clsid = get_clsid_self(dtqid);
	dtqid = remove_clsid(dtqid);
	CHECK_DTQID(ccb, dtqid);
	CHECK_TMOUT(tmout);
	dtqcb = get_dtqcb(ccb, dtqid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	/*
	 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
	 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
	 */	
	if (!(queue_empty(&(dtqcb->swait_queue)))) {
		/* Ԥ */
		tcb = (TCB *)(dtqcb->swait_queue.next);
		tccb = get_ccb(tcb->clsid);
		T_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		queue_delete((QUEUE *) tcb);
		if (dtqcb->count > 0) {
			dequeue_data(dtqcb, p_data);
			enqueue_data(dtqcb, ((WINFO_DTQ *)(tcb->winfo))->data);
		}
		else {
			*p_data = ((WINFO_DTQ *)(tcb->winfo))->data;
		}
		if (wait_complete(tccb, tcb)) {
			dspreq = dispatch_request(tccb->prcid);
		}
		T_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq);
		ercd = E_OK;
	}
	else if (dtqcb->count > 0) {
		/* Хåե˥ǡꡤԤʤ */
		dequeue_data(dtqcb, p_data);
		RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq);
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_TMOUT;
	}
	else {
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(ccb->obj_lock);
		runtsk->tstat = (TS_WAITING | TS_WAIT_WOBJ);
		make_wait_tmout(&(winfo.winfo), &tmevtb, tmout);
		queue_insert_prev(&(dtqcb->rwait_queue),
						  &(runtsk->task_queue));
		winfo.clsid = clsid;
		winfo.wobjcb = (WOBJCB *) dtqcb;
		T_RELEASE_NESTED_LOCK(runccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK(ccb->obj_lock);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_data = winfo.data;
		}
	}
	t_unlock_cpu();

  exit:
	LOG_TRCV_DTQ_LEAVE(ercd, *p_data);
	return(ercd);
}

#endif /* __trcv_dtq */
