/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: eventflag.c,v 1.6 2006/12/25 08:50:50 honda Exp $
 */

/** \file
 *	٥ȥե饰ǽ
 *
 */

#include "fdmp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "eventflag.h"

/**
 *  ٥ȥե饰IDκ͡kernel_cfg.c
 */
extern const ID	tmax_flgid;

/**
 *  ٥ȥե饰֥åΥꥢkernel_cfg.c
 */
extern const FLGINIB	flginib_table[];

/**
 *  ٥ȥե饰֥åΥꥢkernel_cfg.c
 */
extern FLGCB	flgcb_table[];

/**
 *  ٥ȥե饰ο
 */
#define TNUM_FLG	((UINT)(tmax_flgid - TMIN_ID + 1))

/*
 *  ٥ȥե饰ID饤٥ȥե饰֥åФΥޥ
 */
#define INDEX_FLG(flgid)	((UINT)((flgid) - TMIN_ID))
#define get_flgcb(ccb, flgid)	(&(((FLGCB *)(ccb->flg.cb_table))[INDEX_FLG(flgid)]))

/**
 *  ٥ȥե饰Ԥ֥å
 *
 *  flgptn ϡwaiptn  wfmode Ʊ˻ȤȤϤʤᡤunion 
 *  ȤХ󤹤뤳ȤǽǤ롥
 */
typedef struct eventflag_waiting_information {
	WINFO	winfo;		/* ɸԤ֥å */
	WOBJCB	*wobjcb;	/* Ԥ֥Ȥδ֥å */
    ID		clsid;		/* Ԥ֥Ȥ°Ƥ륯饹Υ饹ID */    
	FLGPTN	waiptn;		/* Ԥѥ */
	MODE	wfmode;		/* Ԥ⡼ */
	FLGPTN	flgptn;		/* ԤΥѥ */
} WINFO_FLG;

/**
 *  ٥ȥե饰ǽν
 */
#ifdef __flgini

void
eventflag_initialize(void)
{
	UINT	i;
	FLGCB	*flgcb;

	for (flgcb = flgcb_table, i = 0; i < TNUM_FLG; flgcb++, i++) {
		queue_initialize(&(flgcb->wait_queue));
		flgcb->flginib = &(flginib_table[i]);
		flgcb->flgptn = flgcb->flginib->iflgptn;
	}
	
	my_local_exccb->flg.cb_table = &flgcb_table[0];
	my_local_exccb->flg.max_id = tmax_flgid;
}

#endif /* __flgini */

/**
 *  ٥ȥե饰ԤΥå
 */
#ifdef __flgcnd

BOOL
eventflag_cond(FLGCB *flgcb, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	if ((wfmode & TWF_ORW) != 0 ? (flgcb->flgptn & waiptn) != 0
				: (flgcb->flgptn & waiptn) == waiptn) {
		*p_flgptn = flgcb->flgptn;
		if ((flgcb->flginib->flgatr & TA_CLR) != 0) {
			flgcb->flgptn = 0;
		}
		return(TRUE);
	}
	return(FALSE);
}

#endif /* __flgcnd */

/**
 *  ٥ȥե饰Υå
 */
#ifdef __set_flg

SYSCALL ER
set_flg(ID flgid, FLGPTN setptn)
{
	FLGCB	*flgcb;
	TCB		*tcb;
	WINFO_FLG *winfo;
	ER		ercd;
	CCB		*ccb, *tccb;
	BOOL	dspreq = FALSE;

	LOG_SET_FLG_ENTER(flgid, setptn);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(flgid)); 
	ccb = t_get_ccb_self(get_clsid(flgid));
	flgid = remove_clsid(flgid);
	CHECK_FLGID(ccb, flgid);
	flgcb = get_flgcb(ccb, flgid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (!(queue_empty(&(flgcb->wait_queue)))) {
		tcb = (TCB *)(flgcb->wait_queue.next);
		tccb = get_ccb(tcb->clsid);
		winfo = (WINFO_FLG *)(tcb->winfo);
		/*
		 * eventflag_cond() TRUEξΤߥåФ褤
		 * eventflag_cond() ˲ŪɤǤ뤿(flgcb->flgptn = 0)
		 * ¹˥å롥
		 */ 
		T_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		flgcb->flgptn |= setptn;
		if (eventflag_cond(flgcb, winfo->waiptn,
					winfo->wfmode, &(winfo->flgptn))) {
			queue_delete(&(tcb->task_queue));
			if (wait_complete(tccb, tcb)) {
				dspreq = dispatch_request(tccb->prcid);
			}

		}
		T_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
	}
	else {
		flgcb->flgptn |= setptn;
	}
	T_RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq);
	ercd = E_OK;

  exit:
	LOG_SET_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __set_flg */

/**
 *  ٥ȥե饰Υåȡ󥿥ƥѡ
 */
#ifdef __iset_flg

SYSCALL ER
iset_flg(ID flgid, FLGPTN setptn)
{
	FLGCB	*flgcb;
	TCB		*tcb;
	WINFO_FLG *winfo;
	ER		ercd;
	CCB		*ccb, *tccb;
	
	LOG_ISET_FLG_ENTER(flgid, setptn);
	CHECK_INTCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(flgid)); 
	ccb = i_get_ccb_self(get_clsid(flgid));
	flgid = remove_clsid(flgid);
	CHECK_FLGID(ccb, flgid);
	flgcb = get_flgcb(ccb, flgid);

  retry:
	I_ACQUIRE_LOCK(ccb->obj_lock);
	if (!(queue_empty(&(flgcb->wait_queue)))) {
		tcb = (TCB *)(flgcb->wait_queue.next);
		tccb = get_ccb(tcb->clsid);
		winfo = (WINFO_FLG *)(tcb->winfo);
		/*
		 * eventflag_cond() TRUEξΤߥåФ褤
		 * eventflag_cond() ˲ŪɤǤ뤿(flgcb->flgptn = 0)
		 * ¹˥å롥 
		 */		 
		I_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		flgcb->flgptn |= setptn;
		if (eventflag_cond(flgcb, winfo->waiptn,
					winfo->wfmode, &(winfo->flgptn))) {
			queue_delete(&(tcb->task_queue));
			if (wait_complete(ccb, tcb)) {
				if (dispatch_request(tccb->prcid)) {
					reqflg = TRUE;
				}
			}
		}
		I_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
	}
	else {
		flgcb->flgptn |= setptn;
	}
	I_RELEASE_LOCK(ccb->obj_lock);
	ercd = E_OK;

  exit:
	LOG_ISET_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __iset_flg */

/**
 *  ٥ȥե饰Υꥢ
 */
#ifdef __clr_flg

SYSCALL ER
clr_flg(ID flgid, FLGPTN clrptn)
{
	FLGCB	*flgcb;
	ER		ercd;
	CCB		*ccb;

	LOG_CLR_FLG_ENTER(flgid, clrptn);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(flgid)); 
	ccb = t_get_ccb_self(get_clsid(flgid));    
	flgid = remove_clsid(flgid);
	CHECK_FLGID(ccb, flgid);
	flgcb = get_flgcb(ccb, flgid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	flgcb->flgptn &= clrptn; 
	T_RELEASE_LOCK(ccb->obj_lock);
	ercd = E_OK;
	
  exit:
	LOG_CLR_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __clr_flg */

/**
 *  ٥ȥե饰Ԥ
 */
#ifdef __wai_flg

SYSCALL ER
wai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	FLGCB	*flgcb;
	WINFO_FLG winfo;
	ER		ercd;
	CCB		*ccb;

	LOG_WAI_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn);
	CHECK_DISPATCH();
	CHECK_CLSID_SELF(get_clsid(flgid)); 
	ccb = t_get_ccb_self(get_clsid(flgid));
	flgid = remove_clsid(flgid);
	CHECK_FLGID(ccb, flgid);
	CHECK_PAR(waiptn != 0);
	CHECK_PAR((wfmode & ~TWF_ORW) == 0);
	flgcb = get_flgcb(ccb, flgid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (!(queue_empty(&(flgcb->wait_queue)))) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_ILUSE;
	}
	else if (eventflag_cond(flgcb, waiptn, wfmode, p_flgptn)) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_OK;
	}
	else {
		winfo.waiptn = waiptn;
		winfo.wfmode = wfmode;
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(ccb->obj_lock);
		wobj_make_wait(ccb->clsid, (WOBJCB *) flgcb, (WINFO_WOBJ *) &winfo);
		T_RELEASE_NESTED_LOCK(runccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK(ccb->obj_lock);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_flgptn = winfo.flgptn;
		}		
	}
	t_unlock_cpu();

  exit:
	LOG_WAI_FLG_LEAVE(ercd, *p_flgptn);
	return(ercd);
}

#endif /* __wai_flg */

/**
 *  ٥ȥե饰Ԥʥݡ󥰡
 */
#ifdef __pol_flg

SYSCALL ER
pol_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	FLGCB	*flgcb;
	ER		ercd;
	CCB		*ccb;

	LOG_POL_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(flgid)); 
	ccb = t_get_ccb_self(get_clsid(flgid));    
	flgid = remove_clsid(flgid);
	CHECK_FLGID(ccb, flgid);
	CHECK_PAR(waiptn != 0);
	CHECK_PAR((wfmode & ~TWF_ORW) == 0);
	flgcb = get_flgcb(ccb, flgid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (!(queue_empty(&(flgcb->wait_queue)))) {
		ercd = E_ILUSE;
	}
	else if (eventflag_cond(flgcb, waiptn, wfmode, p_flgptn)) {
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	T_RELEASE_LOCK(ccb->obj_lock);

  exit:
	LOG_POL_FLG_LEAVE(ercd, *p_flgptn);
	return(ercd);
}

#endif /* __pol_flg */

/**
 *  ٥ȥե饰ԤʥॢȤ
 */
#ifdef __twai_flg

SYSCALL ER
twai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn, TMO tmout)
{
	FLGCB	*flgcb;
	WINFO_FLG winfo;
	TMEVTB	tmevtb;
	ER		ercd = E_OK;
	CCB		*ccb;
    
	LOG_TWAI_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn, tmout);
	CHECK_DISPATCH();
	CHECK_CLSID_SELF(get_clsid(flgid)); 
	ccb = t_get_ccb_self(get_clsid(flgid));    
	flgid = remove_clsid(flgid);
	CHECK_FLGID(ccb, flgid);
	CHECK_PAR(waiptn != 0);
	CHECK_PAR((wfmode & ~TWF_ORW) == 0);
	CHECK_TMOUT(tmout);
	flgcb = get_flgcb(ccb, flgid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (!(queue_empty(&(flgcb->wait_queue)))) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_ILUSE;
	}
	else if (eventflag_cond(flgcb, waiptn, wfmode, p_flgptn)) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_TMOUT;
	}
	else {
		winfo.waiptn = waiptn;
		winfo.wfmode = wfmode;
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(ccb->obj_lock);
		wobj_make_wait_tmout(ccb->clsid, (WOBJCB *) flgcb, (WINFO_WOBJ *) &winfo,
						&tmevtb, tmout);
		T_RELEASE_NESTED_LOCK(runccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK(ccb->obj_lock);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_flgptn = winfo.flgptn;
		}
	}
	t_unlock_cpu();

  exit:
	LOG_TWAI_FLG_LEAVE(ercd, *p_flgptn);
	return(ercd);
}

#endif /* __twai_flg */
