/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 * 
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: lock.h,v 1.2 2006/09/16 02:21:04 honda Exp $
 */

/** \file
 *  å֥Ȥ
 *
 *  å֥Ȥϡå¤ؤݥ󥿤ȡå뤿
 *  Υꥢåؿʤ롥å
 *  ˤϡʲ2Ĥޤޤ롥
 *
 *  acquire_lockϡåμ FALSE
 *  åԤδ֤˳ߤȯ TRUE ֤
 *
 *  acquire_lock		å
 *  release_lock		å
 */

#ifndef _LOCK_H_
#define _LOCK_H_

/**
 *  å֥
 *
 */
typedef struct lock_object	LOCKOBJ;

/**
 * åؿ¤
 */   
typedef struct lock_operations {
	BOOL	(*acquire_lock)(LOCKOBJ *lockobj);
	void	(*release_lock)(LOCKOBJ *lockobj);
} LOCKOPS;

struct lock_object {
	void	*lock_ptr;  /* åо */
	LOCKOPS	lock_ops;   
};

/*
 *  åؿƤӽФޥ
 */

/*
 * CPUå֤ѹʤ
 */
#define ACQUIRE_LOCK(lockobj)						\
	((lockobj).lock_ops.acquire_lock(&(lockobj)))	

#define RELEASE_LOCK(lockobj) 						\
	((lockobj).lock_ops.release_lock(&(lockobj)))

#define RELEASE_LOCK_AND_DISPATCH(lockobj, dspreq) {	\
	(lockobj).lock_ops.release_lock(&(lockobj));		\
	if (dspreq == TRUE){ 								\
		dispatch();										\
	}													\
}

/**
 *  åޥ
 * 
 *  åǤʤ硤δ֤γ׵ưCPU
 *  å 
 */
#define T_ACQUIRE_LOCK(lockobj) {							\
	t_lock_cpu();											\
	if ((lockobj).lock_ops.acquire_lock(&(lockobj))) {		\
		t_unlock_cpu();										\
		goto retry;											\
	}														\
}

/** 
 *  åޥ
 * 
 *  åǤʤ硤δ֤γ׵ưCPU
 *  åޤCPUå塤åޤǤδ֤˼
 *  ξ֤RUNNABLEʳѹƤʤå롥
 *  ξ֤ѲƤС٥åƳƥȥ饤
 *  롥
 *  ܥޥλѤϡΥåФξΤߤǤ
 *  ᡤϤȤ餺runccbФԤ
 */
#define T_ACQUIRE_LOCK_AND_CHECK_RUNNABLE() {				\
	t_lock_cpu();											\
	if ((runccb->tsk_lock).lock_ops.acquire_lock(&(runccb->tsk_lock))) {\
		t_unlock_cpu();										\
		goto retry;											\
	}                                                       \
    else if(!TSTAT_RUNNABLE(runtsk->tstat)){				\
		(runccb->tsk_lock).lock_ops.release_lock(&(runccb->tsk_lock));	\
		t_unlock_cpu();										\
		goto retry;											\
	}														\
}

/** 
 *  ܤΥåޥ
 * 
 *  åǤʤ硤δ֤γ׵ưCPU
 *  åȳ¦ΥåϤ 
 */
#define T_ACQUIRE_NESTED_LOCK(lockobj, lockobj1) {			\
	if ((lockobj).lock_ops.acquire_lock(&(lockobj))) {		\
		(lockobj1).lock_ops.release_lock(&(lockobj1));		\
		t_unlock_cpu();										\
		goto retry;											\
	}														\
}

/** 
 *  ܤΥåޥ
 * 
 *  åǤʤ硤δ֤γ׵ưCPU
 *  åޤCPUå塤åޤǤδ֤˼
 *  ξ֤RUNNABLEʳѹƤʤå롥
 *  ξ֤ѲƤС٥åƳƥȥ饤
 *  
 *  ܥޥλѤϡΥåФξΤߤǤ
 *  ᡤå֥ȤϰȤƤȤ餺runccbФ
 *  Ԥ 
 */
#define T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(lockobj1) {\
	if ((runccb->tsk_lock).lock_ops.acquire_lock(&(runccb->tsk_lock))) {\
		(lockobj1).lock_ops.release_lock(&(lockobj1));		\
		t_unlock_cpu();										\
		goto retry;											\
    }                                                       \
    else if(!TSTAT_RUNNABLE(runtsk->tstat)){				\
        (runccb->tsk_lock).lock_ops.release_lock(&(runccb->tsk_lock));\
        (lockobj1).lock_ops.release_lock(&(lockobj1));		\
		t_unlock_cpu();										\
		goto retry;											\
	}														\
}


/**
 *  åޥ
 * 
 *  dispatch,lock뤳Ȥɬ
 *  ä,dispatch()˰ʲΥޥȯԤ뤳
 */
#define T_RELEASE_LOCK(lockobj) {					\
	(lockobj).lock_ops.release_lock(&(lockobj));	\
	t_unlock_cpu();									\
}

/**
 *  åޥ
 *
 *  ξΥåƱ˲ΤǤϤʤ
 */ 
#define T_RELEASE_NESTED_LOCK(lockobj, lockobj1) {	\
	(lockobj).lock_ops.release_lock(&(lockobj));	\
}

/**
 *  å&ǥѥåޥ
 *
 *  åǥѥåꥯȤХǥѥå㡼
 *  ƤӽФ 
 */ 
#define T_RELEASE_LOCK_AND_DISPATCH(lockobj, dspreq) {	\
	(lockobj).lock_ops.release_lock(&(lockobj));		\
	if (dspreq) { 										\
		dispatch();										\
	}													\
	t_unlock_cpu();										\
}

/*
 * 󥿥ƥ
 */
#define I_ACQUIRE_LOCK(lockobj) {						\
	i_lock_cpu();										\
	if ((lockobj).lock_ops.acquire_lock(&(lockobj))) {	\
		goto retry;										\
	}													\
}

#define I_ACQUIRE_NESTED_LOCK(lockobj, lockobj1) {			\
	if ((lockobj).lock_ops.acquire_lock(&(lockobj))) {		\
		(lockobj1).lock_ops.release_lock(&(lockobj1));		\
		i_unlock_cpu();										\
		goto retry;											\
	}														\
}

#define I_RELEASE_LOCK(lockobj) {					\
	(lockobj).lock_ops.release_lock(&(lockobj));	\
	i_unlock_cpu();									\
}

#define I_RELEASE_NESTED_LOCK(lockobj, lockobj1) {	\
	(lockobj).lock_ops.release_lock(&(lockobj));	\
}

/*
 *  ץåΥ񸻤Υå(in mp_config.c)
 *
 */
extern BOOL	my_local_acquire_lock(LOCKOBJ *lockobj);
extern void	my_local_release_lock(LOCKOBJ *lockobj);

#define LOCKOPS_MY_LOCAL_ACQUIRE_LOCK my_local_acquire_lock
#define LOCKOPS_MY_LOCAL_RELEASE_LOCK my_local_release_lock

/*
 *  ¾ץåΥ񸻤Υå(in mp_config.c)
 */
extern BOOL	local_acquire_lock(LOCKOBJ *lockobj);
extern void	local_release_lock(LOCKOBJ *lockobj);

#define LOCKOPS_LOCAL_ACQUIRE_LOCK local_acquire_lock
#define LOCKOPS_LOCAL_RELEASE_LOCK local_release_lock

#endif /* _LOCK_H_ */
