/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mailbox.c,v 1.6 2006/12/25 08:50:50 honda Exp $
 */

/** \file
 *	᡼ܥåǽ
 */

#include "fdmp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "mailbox.h"

/**
 *  ᡼ܥåIDκ͡kernel_cfg.c
 */
extern const ID	tmax_mbxid;

/**
 *  ᡼ܥå֥åΥꥢkernel_cfg.c
 */
extern const MBXINIB	mbxinib_table[];

/**
 *  ᡼ܥå֥åΥꥢkernel_cfg.c
 */
extern MBXCB	mbxcb_table[];

/**
 *  ᡼ܥåο
 */
#define TNUM_MBX	((UINT)(tmax_mbxid - TMIN_ID + 1))

/**
 *  ᡼ܥåID᡼ܥå֥åФΥޥ
 */
#define INDEX_MBX(mbxid)	((UINT)((mbxid) - TMIN_ID))
#define get_mbxcb(ccb, mbxid)	(&(((MBXCB *)(ccb->mbx.cb_table))[INDEX_MBX(mbxid)]))

/**
 *  ᡼ܥåԤ֥å
 */
typedef struct mailbox_waiting_information {
	WINFO	winfo;		/* ɸԤ֥å */
	WOBJCB	*wobjcb;	/* Ԥ֥Ȥδ֥å */
    ID		clsid;		/* Ԥ֥Ȥ°Ƥ륯饹Υ饹ID */
	T_MSG	*pk_msg;	/* å */
} WINFO_MBX;

/** 
 *  ᡼ܥåǽν
 */
#ifdef __mbxini

void
mailbox_initialize()
{
	UINT	i;
	MBXCB	*mbxcb;

	for (mbxcb = mbxcb_table, i = 0; i < TNUM_MBX; mbxcb++, i++) {
		queue_initialize(&(mbxcb->wait_queue));
		mbxcb->mbxinib = &(mbxinib_table[i]);
		mbxcb->head = NULL;
	}

	my_local_exccb->mbx.cb_table = &mbxcb_table[0];
	my_local_exccb->mbx.max_id   = tmax_mbxid;
}

#endif /* __mbxini */

/**
 *  åͥ٤μФ
 */
#define	MSGPRI(pk_msg)	(((T_MSG_PRI *) pk_msg)->msgpri)

/**
 *  ͥٽå塼ؤ
 */
Inline void
enqueue_msg_pri(T_MSG **p_prevmsg_next, T_MSG *pk_msg)
{
	T_MSG	*pk_nextmsg;

	while ((pk_nextmsg = *p_prevmsg_next) != NULL) {
		if (MSGPRI(pk_nextmsg) > MSGPRI(pk_msg)) {
			break;
		}
		p_prevmsg_next = &(pk_nextmsg->next);
	}
	pk_msg->next = pk_nextmsg;
	*p_prevmsg_next = pk_msg;
}


/**
 *  ᡼ܥåؤ
 */
#ifdef __snd_mbx

SYSCALL ER
snd_mbx(ID mbxid, T_MSG *pk_msg)
{
	MBXCB	*mbxcb;
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb, *tccb;
	BOOL	dspreq = FALSE;
	
	LOG_SND_MBX_ENTER(mbxid, pk_msg);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(mbxid)); 
	ccb = t_get_ccb_self(get_clsid(mbxid));
	mbxid = remove_clsid(mbxid);
	CHECK_MBXID(ccb, mbxid);
	mbxcb = get_mbxcb(ccb, mbxid);
	CHECK_PAR((mbxcb->mbxinib->mbxatr & TA_MPRI) == 0
		|| (TMIN_MPRI <= MSGPRI(pk_msg)
			&& MSGPRI(pk_msg) <= mbxcb->mbxinib->maxmpri));

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (!(queue_empty(&(mbxcb->wait_queue)))) {
		tcb = (TCB *) (mbxcb->wait_queue.next);
		tccb = get_ccb(tcb->clsid);
		((WINFO_MBX *)(tcb->winfo))->pk_msg = pk_msg;
		/*
		 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
		 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
		 */				 
		T_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		/* Ԥ塼 */
		queue_delete_next(&(mbxcb->wait_queue));
		if (wait_complete(tccb, tcb)) {
			dspreq = dispatch_request(tccb->prcid);
		}
		T_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		ercd = E_OK;
	}
	else if ((mbxcb->mbxinib->mbxatr & TA_MPRI) != 0) {
		enqueue_msg_pri(&(mbxcb->head), pk_msg);
		ercd = E_OK;
	}
	else {
		pk_msg->next = NULL;
		if (mbxcb->head != NULL) {
			mbxcb->last->next = pk_msg;
		}
		else {
			mbxcb->head = pk_msg;
		}
		mbxcb->last = pk_msg;
		ercd = E_OK;
	}
	T_RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq);	

  exit:
	LOG_SND_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __snd_mbx */

/**
 *  ᡼ܥåμ
 */
#ifdef __rcv_mbx

SYSCALL ER
rcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	MBXCB	*mbxcb;
	WINFO_MBX winfo;
	ER		ercd;
	CCB		*ccb;
    
	LOG_RCV_MBX_ENTER(mbxid, ppk_msg);
	CHECK_DISPATCH();
	CHECK_CLSID_SELF(get_clsid(mbxid)); 
	ccb = t_get_ccb_self(get_clsid(mbxid));    
	mbxid = remove_clsid(mbxid);
	CHECK_MBXID(ccb, mbxid);
	mbxcb = get_mbxcb(ccb, mbxid);	

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (mbxcb->head != NULL) {
		*ppk_msg = mbxcb->head;
		mbxcb->head = (*ppk_msg)->next;
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_OK;
	}
	else {
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(ccb->obj_lock);
		wobj_make_wait(ccb->clsid, (WOBJCB *) mbxcb, (WINFO_WOBJ *) &winfo);
		T_RELEASE_NESTED_LOCK(runccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK(ccb->obj_lock);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*ppk_msg = winfo.pk_msg;
		}
	}
	t_unlock_cpu();

  exit:
	LOG_RCV_MBX_LEAVE(ercd, *ppk_msg);
	return(ercd);
}

#endif /* __rcv_mbx */

/**
 *  ᡼ܥåμʥݡ󥰡
 */
#ifdef __prcv_mbx

SYSCALL ER
prcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	MBXCB	*mbxcb;
	ER		ercd;
	CCB		*ccb;
	
	LOG_PRCV_MBX_ENTER(mbxid, ppk_msg);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(mbxid)); 
	ccb = t_get_ccb_self(get_clsid(mbxid));    
	mbxid = remove_clsid(mbxid);
	CHECK_MBXID(ccb, mbxid);
	mbxcb = get_mbxcb(ccb, mbxid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (mbxcb->head != NULL) {
		*ppk_msg = mbxcb->head;
		mbxcb->head = (*ppk_msg)->next;
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	T_RELEASE_LOCK(ccb->obj_lock);

  exit:
	LOG_PRCV_MBX_LEAVE(ercd, *ppk_msg);
	return(ercd);
}

#endif /* __prcv_mbx */

/**
 *  ᡼ܥåμʥॢȤ
 */
#ifdef __trcv_mbx

SYSCALL ER
trcv_mbx(ID mbxid, T_MSG **ppk_msg, TMO tmout)
{
	MBXCB	*mbxcb;
	WINFO_MBX winfo;
	TMEVTB	tmevtb;
	ER		ercd;
	CCB		*ccb;
    
	LOG_TRCV_MBX_ENTER(mbxid, ppk_msg, tmout);
	CHECK_DISPATCH();
	CHECK_CLSID_SELF(get_clsid(mbxid)); 
	ccb = t_get_ccb_self(get_clsid(mbxid));        
	mbxid = remove_clsid(mbxid);
	CHECK_MBXID(ccb, mbxid);
	CHECK_TMOUT(tmout);
	mbxcb = get_mbxcb(ccb, mbxid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (mbxcb->head != NULL) {
		*ppk_msg = mbxcb->head;
		mbxcb->head = (*ppk_msg)->next;
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_TMOUT;
	}
	else {
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(ccb->obj_lock);
		wobj_make_wait_tmout(ccb->clsid, (WOBJCB *) mbxcb, (WINFO_WOBJ *) &winfo,
						&tmevtb, tmout);
		T_RELEASE_NESTED_LOCK(runccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK(ccb->obj_lock);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*ppk_msg = winfo.pk_msg;
		}
	}
	t_unlock_cpu();

  exit:
	LOG_TRCV_MBX_LEAVE(ercd, *ppk_msg);
	return(ercd);
}

#endif /* __trcv_mbx */
