/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mempfix.c,v 1.6 2006/12/25 08:50:50 honda Exp $
 */

/** \file
 *	Ĺס뵡ǽ
 *
 */

#include "fdmp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "mempfix.h"

/**
 *  ĹסIDκ͡kernel_cfg.c
 */
extern const ID	tmax_mpfid;

/**
 *  Ĺס֥åΥꥢkernel_cfg.c
 */
extern const MPFINIB	mpfinib_table[];

/**
 *  Ĺס֥åΥꥢkernel_cfg.c
 */
extern MPFCB	mpfcb_table[];

/**
 *  Ĺסο
 */
#define TNUM_MPF	((UINT)(tmax_mpfid - TMIN_ID + 1))

/*
 *  ĹסIDĹס֥åФ
 *  Υޥ
 */
#define INDEX_MPF(mpfid)	((UINT)((mpfid) - TMIN_ID))
#define get_mpfcb(ccb, mpfid)	(&(((MPFCB *)(ccb->mpf.cb_table))[INDEX_MPF(mpfid)]))


/**
 *  ĹסԤ֥å
 */
typedef struct fixed_memorypool_waiting_information {
	WINFO	winfo;		/* ɸԤ֥å */
	WOBJCB	*wobjcb;	/* Ԥ֥Ȥδ֥å */	
    ID		clsid;		/* Ԥ֥Ȥ°Ƥ륯饹Υ饹ID */        
	VP	blk;			/* ֥å */
} WINFO_MPF;


/** 
 *  Ĺס뵡ǽν
 */
#ifdef __mpfini

void
mempfix_initialize()
{
	UINT	i;
	MPFCB	*mpfcb;

	for (mpfcb = mpfcb_table, i = 0; i < TNUM_MPF; mpfcb++, i++) {
		queue_initialize(&(mpfcb->wait_queue));
		mpfcb->mpfinib = &(mpfinib_table[i]);
		mpfcb->unused = mpfcb->mpfinib->mpf;
		mpfcb->freelist = NULL;
	}

	my_local_exccb->mpf.cb_table = &mpfcb_table[0];
	my_local_exccb->mpf.max_id   = tmax_mpfid;
}

#endif /* __mpfini */

/**
 *  Ĺס뤫֥å
 */
#ifdef __mpfget

BOOL
mempfix_get_block(MPFCB *mpfcb, VP *p_blk)
{
	FREEL	*free;

	if (mpfcb->freelist != NULL) {
		free = mpfcb->freelist;
		mpfcb->freelist = free->next;
		*p_blk = (VP) free;
		return(TRUE);
	}
	else if (mpfcb->unused < mpfcb->mpfinib->limit) {
		*p_blk = mpfcb->unused;
		mpfcb->unused = (VP)((SIZE)(mpfcb->unused)
						+ mpfcb->mpfinib->blksz);
		return(TRUE);
	}
	return(FALSE);
}

#endif /* __mpfget */

/**
 *  Ĺ֥åγ
 */
#ifdef __get_mpf

SYSCALL ER
get_mpf(ID mpfid, VP *p_blk)
{
	MPFCB	*mpfcb;
	WINFO_MPF winfo;
	ER		ercd;
	CCB		*ccb;
    
	LOG_GET_MPF_ENTER(mpfid, p_blk);
	CHECK_DISPATCH();
	CHECK_CLSID_SELF(get_clsid(mpfid)); 
	ccb = t_get_ccb_self(get_clsid(mpfid));    
	mpfid = remove_clsid(mpfid);
	CHECK_MPFID(ccb, mpfid);
	mpfcb = get_mpfcb(ccb, mpfid);
	
  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (mempfix_get_block(mpfcb, p_blk)) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_OK;
	}
	else {
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(ccb->obj_lock);
		wobj_make_wait(ccb->clsid, (WOBJCB *) mpfcb, (WINFO_WOBJ *) &winfo);
		T_RELEASE_NESTED_LOCK(runccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK(ccb->obj_lock);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_blk = winfo.blk;
		}
	}
	t_unlock_cpu();

  exit:
	LOG_GET_MPF_LEAVE(ercd, *p_blk);
	return(ercd);
}

#endif /* __get_mpf */

/**
 *  Ĺ֥åγʥݡ󥰡
 */
#ifdef __pget_mpf

SYSCALL ER
pget_mpf(ID mpfid, VP *p_blk)
{
	MPFCB	*mpfcb;
	ER		ercd;
	CCB		*ccb;
	
	LOG_PGET_MPF_ENTER(mpfid, p_blk);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(mpfid)); 
	ccb = t_get_ccb_self(get_clsid(mpfid));    
	mpfid = remove_clsid(mpfid);
	CHECK_MPFID(ccb, mpfid);
	mpfcb = get_mpfcb(ccb, mpfid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (mempfix_get_block(mpfcb, p_blk)) {
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	T_RELEASE_LOCK(ccb->obj_lock);

  exit:
	LOG_PGET_MPF_LEAVE(ercd, *p_blk);
	return(ercd);
}

#endif /* __pget_mpf */

/**
 *  Ĺ֥åγʥॢȤ
 */
#ifdef __tget_mpf

SYSCALL ER
tget_mpf(ID mpfid, VP *p_blk, TMO tmout)
{
	MPFCB	*mpfcb;
	WINFO_MPF winfo;
	TMEVTB	tmevtb;
	ER		ercd = E_OK;
	CCB		*ccb;

	LOG_TGET_MPF_ENTER(mpfid, p_blk, tmout);
	CHECK_DISPATCH();
	CHECK_CLSID_SELF(get_clsid(mpfid)); 
	ccb = t_get_ccb_self(get_clsid(mpfid));    
	mpfid = remove_clsid(mpfid);
	CHECK_MPFID(ccb, mpfid);
	CHECK_TMOUT(tmout);
	mpfcb = get_mpfcb(ccb, mpfid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (mempfix_get_block(mpfcb, p_blk)) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_TMOUT;
	}
	else {
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(ccb->obj_lock);
		wobj_make_wait_tmout(ccb->clsid, (WOBJCB *) mpfcb, (WINFO_WOBJ *) &winfo,
						&tmevtb, tmout);
		T_RELEASE_NESTED_LOCK(runccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK(ccb->obj_lock);
		LOG_TSKSTAT(runtsk);
		dispatch();		
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_blk = winfo.blk;
		}
	}
	t_unlock_cpu();

  exit:
	LOG_TGET_MPF_LEAVE(ercd, *p_blk);
	return(ercd);
}

#endif /* __tget_mpf */

/**
 *  Ĺ֥åֵ
 */
#ifdef __rel_mpf

SYSCALL ER
rel_mpf(ID mpfid, VP blk)
{
	MPFCB	*mpfcb;
	TCB		*tcb;
	FREEL	*free;
	ER		ercd;
	CCB		*ccb, *tccb;
	BOOL	dspreq = FALSE;
	
	LOG_REL_MPF_ENTER(mpfid, blk);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(mpfid)); 
	ccb = t_get_ccb_self(get_clsid(mpfid));    
	mpfid = remove_clsid(mpfid);
	CHECK_MPFID(ccb, mpfid);
	mpfcb = get_mpfcb(ccb, mpfid);	
	CHECK_PAR(mpfcb->mpfinib->mpf <= blk
			&& blk < mpfcb->mpfinib->limit
			&& ((SIZE)(blk) - (SIZE)(mpfcb->mpfinib->mpf))
					% mpfcb->mpfinib->blksz == 0);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (!(queue_empty(&(mpfcb->wait_queue)))) {
		/*
		 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
		 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
		 */		 
		tcb = (TCB *) (mpfcb->wait_queue.next);
		tccb = get_ccb(tcb->clsid);		
		((WINFO_MPF *)(tcb->winfo))->blk = blk;
		T_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		/* Ԥ塼 */
		queue_delete_next(&(mpfcb->wait_queue));
		if (wait_complete(tccb, tcb)) {
			dspreq = dispatch_request(tccb->prcid);
		}
		T_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		ercd = E_OK;
	}
	else {
		free = (FREEL *) blk;
		free->next = mpfcb->freelist;
		mpfcb->freelist = free;
		ercd = E_OK;
	}
	T_RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq);

	exit:
	LOG_REL_MPF_LEAVE(ercd);
	return(ercd);
}

#endif /* __rel_mpf */
