/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: semaphore.c,v 1.7 2006/12/25 08:50:50 honda Exp $
 */

/** \file
 *	ޥեǽ
 */

#include "fdmp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "semaphore.h"

/**
 *  ޥեIDκ͡kernel_cfg.c
 */
extern const ID	tmax_semid;

/**
 *  ޥե֥åΥꥢkernel_cfg.c
 */
extern const SEMINIB	seminib_table[];

/**
 *  ޥե֥åΥꥢkernel_cfg.c
 */
extern SEMCB	semcb_table[];

/**
 *  ޥեο
 */
#define TNUM_SEM	((UINT)(tmax_semid - TMIN_ID + 1))

/*
 *  ޥեID饻ޥե֥åФΥޥ
 */
#define INDEX_SEM(semid)	((UINT)((semid) - TMIN_ID))
#define get_semcb(ccb, semid)	(&(((SEMCB *)(ccb->sem.cb_table))[INDEX_SEM(semid)]))


/* 
 *  ޥեǽν
 */
#ifdef __semini

void
semaphore_initialize()
{
	UINT	i;
	SEMCB	*semcb;

	for (semcb = semcb_table, i = 0; i < TNUM_SEM; semcb++, i++) {
		queue_initialize(&(semcb->wait_queue));
		semcb->seminib = &(seminib_table[i]);
		semcb->semcnt = semcb->seminib->isemcnt;
	}

	my_local_exccb->sem.cb_table = &semcb_table[0];
	my_local_exccb->sem.max_id   = tmax_semid;	
}

#endif /* __semini */

/**
 *  ޥե񸻤ֵ
 *
 */
#ifdef __sig_sem

SYSCALL ER
sig_sem(ID semid)
{
	SEMCB	*semcb;
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb, *tccb;
	BOOL	dspreq = FALSE;
	
	LOG_SIG_SEM_ENTER(semid);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(semid)); 
	ccb = t_get_ccb_self(get_clsid(semid));    
	semid = remove_clsid(semid);
	CHECK_SEMID(ccb, semid);
	semcb = get_semcb(ccb, semid);

  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (!(queue_empty(&(semcb->wait_queue)))) {
		/*
		 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
		 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
		 */ 
		tcb = (TCB *)(semcb->wait_queue.next);
		tccb = get_ccb(tcb->clsid);
		T_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		/* Ԥ塼 */
		queue_delete((QUEUE *) tcb);
		if (wait_complete(tccb, tcb)) {
			dspreq = dispatch_request(tccb->prcid);
		}
		T_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		ercd = E_OK;
	}
	else if (semcb->semcnt < semcb->seminib->maxsem) {
		semcb->semcnt += 1;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}
	T_RELEASE_LOCK_AND_DISPATCH(ccb->obj_lock, dspreq);
  exit:
	LOG_SIG_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __sig_sem */

/**
 *  ޥե񸻤ֵѡ󥿥ƥѡ
 */
#ifdef __isig_sem

SYSCALL ER
isig_sem(ID semid)
{
	SEMCB	*semcb;
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb, *tccb;
	
	LOG_ISIG_SEM_ENTER(semid);
	CHECK_INTCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(semid)); 
	ccb = i_get_ccb_self(get_clsid(semid));
	semid = remove_clsid(semid);
	CHECK_SEMID(ccb, semid);
	semcb = get_semcb(ccb, semid);

  retry:
	I_ACQUIRE_LOCK(ccb->obj_lock);	
	if (!queue_empty(&(semcb->wait_queue))) {
		/*
		 * T_ACQUIRE_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
		 * ֤¹Ԥ뤿ᡤδ˲ɤǤʤФʤʤ
		 */		 
		tcb = (TCB *)(semcb->wait_queue.next);
		tccb = get_ccb(tcb->clsid);
		I_ACQUIRE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		/* Ԥ塼 */
		queue_delete_next(&(semcb->wait_queue));
		if (wait_complete(tccb, tcb)) {
			if (dispatch_request(tccb->prcid)){
				reqflg = TRUE;
			}
		}
		I_RELEASE_NESTED_LOCK(tccb->tsk_lock, ccb->obj_lock);
		ercd = E_OK;
	}
	else if (semcb->semcnt < semcb->seminib->maxsem) {
		semcb->semcnt += 1;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}
	I_RELEASE_LOCK(ccb->obj_lock);

  exit:
	LOG_ISIG_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __isig_sem */

/**
 *  ޥե񸻤γ
 */
#ifdef __wai_sem


SYSCALL ER
wai_sem(ID semid)
{
	SEMCB	*semcb;
	WINFO_WOBJ winfo;
	ER		ercd;
	CCB		*ccb;

	LOG_WAI_SEM_ENTER(semid);
	CHECK_DISPATCH();
	CHECK_CLSID_SELF(get_clsid(semid)); 
	ccb = t_get_ccb_self(get_clsid(semid));    
    semid = remove_clsid(semid);
	CHECK_SEMID(ccb, semid);
	semcb = get_semcb(ccb, semid);

  retry:	
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (semcb->semcnt >= 1) {
		semcb->semcnt -= 1;
        RELEASE_LOCK(ccb->obj_lock);
		ercd = E_OK;
	}
	else {
        T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(ccb->obj_lock);
		wobj_make_wait(ccb->clsid, (WOBJCB *) semcb, &winfo);
		T_RELEASE_NESTED_LOCK(runccb->tsk_lock, ccb->obj_lock);
        RELEASE_LOCK(ccb->obj_lock);
		dispatch();
		ercd = winfo.winfo.wercd;
	}
	t_unlock_cpu();

  exit:
	LOG_WAI_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __wai_sem */

/**
 *  ޥե񸻤γʥݡ󥰡
 */
#ifdef __pol_sem

SYSCALL ER
pol_sem(ID semid)
{
	SEMCB	*semcb;
	ER		ercd;
	CCB		*ccb;
	
	LOG_POL_SEM_ENTER(semid);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(semid)); 
	ccb = t_get_ccb_self(get_clsid(semid));    
	semid = remove_clsid(semid);
	CHECK_SEMID(ccb, semid);
	semcb = get_semcb(ccb, semid);
	
  retry:
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (semcb->semcnt >= 1) {
		semcb->semcnt -= 1;
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	T_RELEASE_LOCK(ccb->obj_lock);

  exit:
	LOG_POL_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __pol_sem */

/**
 *  ޥե񸻤γʥॢȤ
 */
#ifdef __twai_sem

SYSCALL ER
twai_sem(ID semid, TMO tmout)
{
	SEMCB  *semcb;
	WINFO_WOBJ winfo;
	TMEVTB	tmevtb;
	ER	 ercd;
	CCB  *ccb;
    
	LOG_TWAI_SEM_ENTER(semid, tmout);
	CHECK_DISPATCH();
	CHECK_CLSID_SELF(get_clsid(semid)); 
	ccb = t_get_ccb_self(get_clsid(semid));    
	semid = remove_clsid(semid);
	CHECK_SEMID(ccb, semid);
	semcb = get_semcb(ccb, semid);

  retry:	
	T_ACQUIRE_LOCK(ccb->obj_lock);
	if (semcb->semcnt >= 1) {
		semcb->semcnt -= 1;
		RELEASE_LOCK(ccb->obj_lock);
		ercd  = E_OK;
	}
	else if (tmout == TMO_POL) {
		RELEASE_LOCK(ccb->obj_lock);
		ercd = E_TMOUT;
		
	}
	else {
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(ccb->obj_lock);
		wobj_make_wait_tmout(ccb->clsid, (WOBJCB *) semcb, &winfo, &tmevtb, tmout);
		T_RELEASE_NESTED_LOCK(runccb->tsk_lock, ccb->obj_lock);
		RELEASE_LOCK(ccb->obj_lock);
		dispatch();
		ercd = winfo.winfo.wercd;
	}
	t_unlock_cpu();

  exit:
	LOG_TWAI_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __twai_sem */
