/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: task.c,v 1.3 2006/03/14 04:37:54 honda Exp $
 */

/** \file
 *	⥸塼
 */

#include "fdmp_kernel.h"
#include "task.h"
#include "cpu_context.h"

#ifdef __tskini

/**
 *  ¹Ծ֤Υ
 */
TCB		*runtsk;

/**
 *  ǹ̤ͥΥ
 */
TCB 	*schedtsk;

/**
 *  ǥѥå㳰롼ư׵ե饰
 */
BOOL	reqflg;

/**
 *  ǥѥåľ
 */
BOOL	enadsp;

/**
 *  ǥ塼
 */
QUEUE	ready_queue[TNUM_TPRI];

/**
 *  ǥ塼ΤΥӥåȥޥå
 *
 *  ӥåȥޥåפ UINT Ƥ뤬ӥåȥޥåץؿͥ
 *  ٤16ʳʲǤ뤳ȤꤷƤ롥
 */
UINT	ready_primap;


/**
 *  ⥸塼ν
 */

void
task_initialize()
{
	UINT	i;
	TCB		*tcb;

	runtsk = schedtsk = NULL;
	runccb = my_local_ccb; /* Ǥϰ̵̣ */
	reqflg = FALSE;
	enadsp = TRUE;

	for (i = 0; i < TNUM_TPRI; i++) {
		queue_initialize(&(ready_queue[i]));
	}
	ready_primap = 0;

	for (i = 0; i < MY_TNUM_TSK; i++) {
		tcb = &(tcb_table[i]);
		tcb->tinib = &(tinib_table[i]);
		tcb->actcnt = FALSE;

		tcb->clsid = CLS_MY_LOCAL;
		tcb->pend_chgpri = FALSE;
		tcb->pend_tertsk = FALSE;
		tcb->pend_relwai = FALSE;
		tcb->terflg = FALSE;
		
		make_dormant(tcb);
	}

	my_local_exccb->p_ready_queue = &ready_queue[0];
	my_local_exccb->p_ready_primap = &ready_primap;	
	my_local_exccb->p_runtsk = &runtsk;
	my_local_exccb->p_schedtsk = &schedtsk;
	my_local_exccb->p_enadsp = &enadsp;
	
	my_local_exccb->tsk.cb_table = &tcb_table[0];
	my_local_exccb->tsk.max_id = tmax_tskid;

	my_local_exccb->p_activate_r = activate_r;	
}

#endif /* __tskini */


/**
 * ͥ뵯ưTA_ACTΥФ뵯ư
 *   my_local_ccbƤ򻲾Ȥɬפ뤿ᡤmy_local_ccb
 *   ˸ƤӽФtask_initialize() ʬΥ
 */
#ifdef __tskiniact

void
task_init_activate()
{
	UINT i, j;
	TCB		*tcb;
	
	for (i = 0; i < MY_TNUM_TSK; i++) {
		j = INDEX_TSK(torder_table[i]);
		tcb = &(tcb_table[j]);		
		if ((tcb->tinib->tskatr & TA_ACT) != 0) {
			make_active(my_local_ccb, tcb);
		}
	}
}

#endif /* __tskiniact */

/**
 *  ӥåȥޥåץؿ
 *
 *  bitmap  1 ΥӥåȤ⡤ǤⲼ̡ʱˤΤΤ򥵡Υ
 *  åֹ֤ӥåֹϡǲ̥ӥåȤ 0 Ȥ롥bitmap  0
 *  ꤷƤϤʤʤδؿǤϡͥ٤16ʳʲǤ뤳Ȥ
 *  ꤷbitmap β16ӥåȤΤߤ򥵡롥
 *  ӥåȥ̿ĥץåǤϡӥåȥ̿Ȥ褦
 *  ľΨɤΤ褦ʾˤϡcpu_insn.h 
 *  ӥåȥ̿Ȥä bitmap_search CPU_BITMAP_SEARCH 
 *  ޥФ褤ޤӥåȥ̿Υդʤ
 *  ͳͥ٤ȥӥåȤȤбѹˤϡPRIMAP_BIT 
 *  ޥФ褤
 *  ޤɸ饤֥ ffs ʤ顤Τ褦ɸ饤
 *  ֥ȤäΨɤǽ⤢롥
 *	#define	bitmap_search(bitmap) (ffs(bitmap) - 1)
 */
#ifndef PRIMAP_BIT
#define	PRIMAP_BIT(pri)		(1u << (pri))
#endif /* PRIMAP_BIT */

#ifndef CPU_BITMAP_SEARCH

Inline UINT
bitmap_search(UINT bitmap)
{
	static const VB search_table[] = { 0, 1, 0, 2, 0, 1, 0,
					3, 0, 1, 0, 2, 0, 1, 0 };
	INT	n = 0;

	assert((bitmap & 0xffff) != 0);
	if ((bitmap & 0x00ff) == 0) {
		bitmap >>= 8;
		n += 8;
	}
	if ((bitmap & 0x0f) == 0) {
		bitmap >>= 4;
		n += 4;
	}
	return(n + search_table[(bitmap & 0x0f) - 1]);
}

#endif /* CPU_BITMAP_SEARCH */


/**
 *  ǹ̥ͥΥ
 */
#ifdef __tsksched

TCB *
search_schedtsk(CCB *ccb)
{
	UINT	schedpri;

	schedpri = bitmap_search(*(ccb->p_ready_primap));
	return((TCB *)(ccb->p_ready_queue[schedpri].next));
}

#endif /* __tsksched */

/**
 *  ¹ԤǤ֤ؤΰܹ
 *
 *  ǹ̤ͥΥ򹹿Τϡ¹ԤǤ륿ʤä
 *  ȡtcb ͥ٤ǹ̤ͥΥͥ٤⤤Ǥ롥
 */
#ifdef __tskrun

BOOL
make_runnable(CCB *ccb, TCB *tcb)
{
	UINT	pri = tcb->priority;
	
	tcb->tstat = TS_RUNNABLE;
	LOG_TSKSTAT(tcb);	   
	queue_insert_prev(&(ccb->p_ready_queue[pri]), &(tcb->task_queue));
	*(ccb->p_ready_primap) |= PRIMAP_BIT(pri);
	
	if (*(ccb->p_schedtsk) == (TCB *) NULL || pri < (*(ccb->p_schedtsk))->priority){
		*(ccb->p_schedtsk) = tcb;
		return(*(ccb->p_enadsp));
	}
	return(FALSE);
}

#endif /* __tskrun */

/**
 *  ¹ԤǤ֤¾ξ֤ؤΰܹ
 *
 *  ǹ̤ͥΥ򹹿Τϡtcb ǹ̤ͥΥǤ
 *  Ǥ롥tcb Ʊͥ٤Υ¾ˤϡtcb μ
 *  ǹ̤ͥˤʤ롥Ǥʤϡǥ塼򥵡
 *  ɬפ롥
 */
#ifdef __tsknrun

BOOL
make_non_runnable(CCB *ccb, TCB *tcb)
{
	UINT	pri = tcb->priority;
	QUEUE	*queue = &(ccb->p_ready_queue[pri]);
	
	queue_delete(&(tcb->task_queue));
	if (queue_empty(queue)) {
		*(ccb->p_ready_primap) &= ~PRIMAP_BIT(pri);
		if (*(ccb->p_schedtsk) == tcb) {
			*(ccb->p_schedtsk) = (*(ccb->p_ready_primap) == 0) ? (TCB * ) NULL
			  : search_schedtsk(ccb);
			return(*(ccb->p_enadsp));
		}
	}
	else {
		if (*(ccb->p_schedtsk) == tcb) {
			*(ccb->p_schedtsk) = (TCB *)(queue->next);
			return(*(ccb->p_enadsp));
		}
	}
	return(FALSE);
}

#endif /* __tsknrun */

/**
 *  ٻ߾֤ؤΰܹ
 */
#ifdef __tskdmt

void
make_dormant(TCB *tcb)
{
	tcb->priority = tcb->tinib->ipriority;
	tcb->tstat = TS_DORMANT;
	tcb->wupcnt = FALSE;
	tcb->enatex = FALSE;
	tcb->texptn = 0;
	tcb->pend_chgpri = FALSE;
	tcb->pend_tertsk = FALSE;
	tcb->pend_relwai = FALSE;
	LOG_TSKSTAT(tcb);
}

#endif /* __tskdmt */

/**
 *  ٻ߾֤¹ԤǤ֤ؤΰܹ
 */
#ifdef __tskact

BOOL
make_active(CCB *ccb, TCB *tcb)
{
	activate_context(ccb, tcb);
	return(make_runnable(ccb,tcb));
}

#endif /* __tskact */

/**
 *  ǥѥåεư׵
 *
 *  оݤPEξϡƥॳ뽪λޤǥǥѥåα	
 */
#ifdef __tskdisreq

BOOL
dispatch_request(INT prcid)
{
	if (prcid != 0 && prcid != PRCID) { 
		raise_ipi(prcid);
		return(FALSE);
	}
	return(TRUE);
}

#endif /* __tskdisreq */

/**
 *  ǥ塼Υͥ٤ѹ
 *
 *  ǹ̤ͥΥ򹹿Τϡ(1) tcb ǹ̤ͥΥ
 *  Ǥäơͥ٤򲼤硤(2) tcb ǹ̤ͥΥ
 *  Ϥʤѹͥ٤ǹ̤ͥΥͥ٤⤤
 *  Ǥ롥(1) ξˤϡǥ塼򥵡ɬפ롥
 */
#ifdef __tskpri

BOOL
change_priority(CCB *ccb, TCB *tcb, UINT newpri)
{
	UINT	oldpri = tcb->priority;

	tcb->priority = newpri;
	queue_delete(&(tcb->task_queue));
	if (queue_empty(&(ccb->p_ready_queue[oldpri]))) {
		*(ccb->p_ready_primap) &= ~PRIMAP_BIT(oldpri);
	}
	queue_insert_prev(&(ccb->p_ready_queue[newpri]), &(tcb->task_queue));
	*(ccb->p_ready_primap) |= PRIMAP_BIT(newpri);

	if (*(ccb->p_schedtsk) == tcb) {
		if (newpri >= oldpri) {
			*(ccb->p_schedtsk) = search_schedtsk(ccb);
			return(*(ccb->p_schedtsk) != tcb && *(ccb->p_enadsp));
		}
	}
	else {
		if (newpri < (*ccb->p_schedtsk)->priority) {
			*(ccb->p_schedtsk) = tcb;
			return(*(ccb->p_enadsp));
		}
	}
	return(FALSE);
}

#endif /* __tskpri */

/**
 *  ǥ塼βž
 *
 *  ǹ̤ͥΥ򹹿Τϡǹ̤ͥΥ
 *  塼˰ưǤ롥
 */
#ifdef __tskrot

BOOL
rotate_ready_queue(CCB *ccb,UINT pri)
{
	QUEUE	*queue = &(ccb->p_ready_queue[pri]);
	QUEUE	*entry;

	if (!(queue_empty(queue)) && queue->next->next != queue) {
		entry = queue_delete_next(queue);
		queue_insert_prev(queue, entry);
		if (*(ccb->p_schedtsk) == (TCB *) entry) {
			*(ccb->p_schedtsk) = (TCB *)(queue->next);
			return(*(ccb->p_enadsp));
		}
	}
	return(FALSE);
}

#endif /* __tskrot */

/**
 *  ޤ㳰롼η
 */
typedef void	(*TEXRTN)(TEXPTN texptn, VP_INT exinf);


/**
 *  㳰롼θƽФ
 */
#ifdef __tsktex

void
call_texrtn()
{
	TEXPTN	texptn;
	
	do {		
		texptn = runtsk->texptn;
		runtsk->enatex = FALSE;
		runtsk->texptn = 0;
		T_RELEASE_LOCK(runccb->tsk_lock);

		LOG_TEX_ENTER(texptn);
		((TEXRTN)(*runtsk->tinib->texrtn))(texptn,
						runtsk->tinib->exinf);
		/*
		 * 㳰롼󤫤CPUå֤
		 * äƤȤн
		 */
		if (t_sense_lock()) {
			t_unlock_cpu();
		}
		LOG_TEX_LEAVE(texptn);

	  retry:
		T_ACQUIRE_LOCK(runccb->tsk_lock);
	} while (runtsk->texptn != 0);
	runtsk->enatex = TRUE;
}


/**
 *  㳰롼θƽФ(ǥѥå㡼)
 */

void
dispatch_call_texrtn()
{
  retry:
	if (ACQUIRE_LOCK(runccb->tsk_lock)) {
		t_unlock_cpu();
		t_lock_cpu();
		goto retry;
	}
	if (runtsk->enatex && runtsk->texptn != 0) {
		call_texrtn();
	}
	RELEASE_LOCK(runccb->tsk_lock);
}

/*
 *  㳰롼εư
 */
#ifndef OMIT_CALLTEX

void
calltex()
{
	if (runtsk->enatex && runtsk->texptn != 0) {
		dispatch_call_texrtn();
	}
}

#endif /* OMIT_CALLTEX */
#endif /* __tsktex */
