/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: task_except.c,v 1.4 2006/12/25 08:50:50 honda Exp $
 */

/** \file
 *	㳰ǽ
 */

#include "fdmp_kernel.h"
#include "check.h"
#include "task.h"

/**
 *  㳰׵
 */
#ifdef __ras_tex

SYSCALL ER
ras_tex(ID tskid, TEXPTN rasptn)
{
	TCB	*tcb;
	ER	ercd;
	CCB	*ccb;

	LOG_RAS_TEX_ENTER(tskid, rasptn);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(tskid)); 
	ccb = t_get_ccb_self(get_clsid(tskid));    
	tskid = remove_clsid(tskid);
	CHECK_TSKID_SELF(ccb, tskid);
	CHECK_PAR(rasptn != 0);
	tcb = get_tcb_self(ccb, tskid);

  retry:
	T_ACQUIRE_LOCK(ccb->tsk_lock);
	if (TSTAT_DORMANT(tcb->tstat) || tcb->tinib->texrtn == NULL
		|| (tcb == runtsk && tcb->terflg)) {
		ercd = E_OBJ;
	}
	else {
		tcb->texptn |= rasptn;
		if (dispatch_request(ccb->prcid)){
			/* ץåξ */
			if (tcb == runtsk && runtsk->enatex) {
				call_texrtn();
			}
		}
		ercd = E_OK;
	}
	T_RELEASE_LOCK(ccb->tsk_lock);

  exit:
	LOG_RAS_TEX_LEAVE(ercd);
	return(ercd);
}

#endif /* __ras_tex */

/**
 *  㳰׵󥿥ƥѡ
 */
#ifdef __iras_tex

SYSCALL ER
iras_tex(ID tskid, TEXPTN rasptn)
{
	TCB	*tcb;
	ER	ercd;
	CCB	*ccb;

	LOG_IRAS_TEX_ENTER(tskid, rasptn);
	CHECK_INTCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(tskid)); 
	ccb = i_get_ccb_self(get_clsid(tskid));
	tskid = remove_clsid(tskid);
	CHECK_TSKID_SELF(ccb, tskid);
	CHECK_PAR(rasptn != 0);
	tcb = get_tcb(ccb, tskid);

  retry:
	I_ACQUIRE_LOCK(ccb->tsk_lock);
	if (TSTAT_DORMANT(tcb->tstat) || tcb->tinib->texrtn == NULL) {
		ercd = E_OBJ;
	}
	else {
		tcb->texptn |= rasptn;
		if (dispatch_request(ccb->prcid)){
			/* ץåξ */
			if (tcb == runtsk && runtsk->enatex) {
				reqflg = TRUE;
			}
		}
		ercd = E_OK;
	}
	I_RELEASE_LOCK(ccb->tsk_lock);

  exit:
	LOG_IRAS_TEX_LEAVE(ercd);
	return(ercd);
}

#endif /* __iras_tex */

/**
 *  㳰ζػ
 */
#ifdef __dis_tex

SYSCALL ER
dis_tex()
{
	ER	ercd;

	LOG_DIS_TEX_ENTER();
	CHECK_TSKCTX_UNL();

  retry:
	T_ACQUIRE_LOCK(runccb->tsk_lock);
	if (runtsk->tinib->texrtn == NULL || runtsk->terflg) {
		ercd = E_OBJ;
	}
	else {
		runtsk->enatex = FALSE;
		ercd = E_OK;
	}
	T_RELEASE_LOCK(runccb->tsk_lock);

	exit:
	LOG_DIS_TEX_LEAVE(ercd);
	return(ercd);
}

#endif /* __dis_tex */

/**
 *  㳰ε
 */
#ifdef __ena_tex

SYSCALL ER
ena_tex()
{
	ER	ercd;

	LOG_ENA_TEX_ENTER();
	CHECK_TSKCTX_UNL();

  retry:
	T_ACQUIRE_LOCK_AND_CHECK_RUNNABLE();
	if (runtsk->tinib->texrtn == NULL || runtsk->terflg) {
		ercd = E_OBJ;
	}
	else {
		runtsk->enatex = TRUE;
		if (runtsk->texptn != 0) {
			call_texrtn();
		}
		ercd = E_OK;
	}
	T_RELEASE_LOCK(runccb->tsk_lock);

  exit:
	LOG_ENA_TEX_LEAVE(ercd);
	return(ercd);
}

#endif /* __ena_tex */

/**
 *  㳰ػ߾֤λ
 */
#ifdef __sns_tex

SYSCALL BOOL
sns_tex()
{
	BOOL	state;

	LOG_SNS_TEX_ENTER();
	state = (runtsk != NULL && runtsk->enatex) ? FALSE : TRUE;
	LOG_SNS_TEX_LEAVE(state);
	return(state);
}

#endif /* __sns_tex */
