/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: task_manage.c,v 1.7 2006/12/25 08:50:50 honda Exp $
 */

/** \file
 *	ǽ
 */

#include "fdmp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"

/**
 *  εư
 */
#ifdef __act_tsk

SYSCALL ER
act_tsk(ID tskid)
{
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb;
	BOOL	dspreq = FALSE;
 
	LOG_ACT_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(tskid)); 
	ccb = t_get_ccb_self(get_clsid(tskid));    
	tskid = remove_clsid(tskid);
	CHECK_TSKID_SELF(ccb, tskid);
	tcb = get_tcb_self(ccb, tskid);

  retry:
	T_ACQUIRE_LOCK(ccb->tsk_lock);
	if (TSTAT_DORMANT(tcb->tstat)) {
		if (make_active(ccb, tcb)) {
			dspreq = dispatch_request(ccb->prcid);
		}
		ercd = E_OK;
	}
	else if (!(tcb->actcnt)) {
		tcb->actcnt = TRUE;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}
	T_RELEASE_LOCK_AND_DISPATCH(ccb->tsk_lock, dspreq);

  exit:
	LOG_ACT_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __act_tsk */

/**
 *  εư󥿥ƥѡ
 */
#ifdef __iact_tsk

SYSCALL ER
iact_tsk(ID tskid)
{
	TCB		*tcb;
	ER		ercd;
	CCB		*ccb;

	LOG_IACT_TSK_ENTER(tskid);
	CHECK_INTCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(tskid)); 
	ccb = i_get_ccb_self(get_clsid(tskid));    
	tskid = remove_clsid(tskid);
	CHECK_TSKID(ccb, tskid);
	tcb = get_tcb(ccb, tskid);

  retry:
	I_ACQUIRE_LOCK(ccb->tsk_lock);
	if (TSTAT_DORMANT(tcb->tstat)) {
		if (make_active(ccb, tcb)) {
			if (dispatch_request(ccb->prcid)) {
				reqflg = TRUE;
			}
		}
		ercd = E_OK;
	}
	else if (!(tcb->actcnt)) {
		tcb->actcnt = TRUE;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}
	I_RELEASE_LOCK(ccb->tsk_lock);

  exit:
	LOG_IACT_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __iact_tsk */

/**
 *  ư׵Υ󥻥
 */
#ifdef __can_act

SYSCALL ER_UINT
can_act(ID tskid)
{
	TCB	    *tcb;
	ER_UINT	ercd;
	CCB     *ccb;

	LOG_CAN_ACT_ENTER(tskid);
	CHECK_TSKCTX_UNL();	
	CHECK_CLSID_SELF(get_clsid(tskid)); 
	ccb = t_get_ccb_self(get_clsid(tskid));    
	tskid = remove_clsid(tskid);
	CHECK_TSKID_SELF(ccb, tskid);
	tcb = get_tcb_self(ccb, tskid);
		
  retry:	
	T_ACQUIRE_LOCK(ccb->tsk_lock);
	if (tcb == runtsk && tcb->terflg) {
		ercd = E_OBJ;
	}
	else {
		ercd = tcb->actcnt ? 1 : 0;	
		tcb->actcnt = FALSE;
	}
	T_RELEASE_LOCK(ccb->tsk_lock);

  exit:
	LOG_CAN_ACT_LEAVE(ercd);
	return(ercd);
}

#endif /* __can_act */

/**
 *  νλ
 *
 */
#ifdef __ext_tsk

SYSCALL void
ext_tsk(void)
{
	LOG_EXT_TSK_ENTER();

	if (sense_context()) {
		/*
		 *  󥿥ƥȤ ext_tsk ƤФ줿硤
		 *  ƥ˥顼ϿΤޤ޼¹Ԥ³롥
		 *  η̡Ū˥ƥȤڤ괹ơ
		 *  ¹Ծ֤Υλ뤳Ȥˤʤ롥ͥ
		 *  Τޤ޼¹Ԥ³뤬åȤˤäƤϡ
		 *  ƥѤΥå˥ߤĤäꡤ
		 *  ߥϥɥΥͥȿδ̷⤬ꤹ
		 *  礬롥
		 */
		syslog_0(LOG_ALERT,
			"ext_tsk is called from non-task contexts.");
	}

  retry:
	if (sense_lock()) {
		/*
		 *  CPUå֤ ext_tsk ƤФ줿ϡCPUå
		 *  Ƥ饿λ롥ϡӥ
		 *  ǤCPUåάФ褤
		 */
		syslog_0(LOG_WARNING,
			"ext_tsk is called from CPU locked state.");
	}
	else {
		if (sense_context()) {
			i_lock_cpu();
		}
		else  {
			t_lock_cpu();
		}
	}

	if (ACQUIRE_LOCK(runccb->tsk_lock)) {
		if (sense_context()) {
			i_unlock_cpu();
		}
		else  {
			t_unlock_cpu();
		}		
		goto retry;
	}
	
	if (!(enadsp)) {
		/*
		 *  ǥѥåػ߾֤ ext_tsk ƤФ줿ϡ
		 *  ǥѥåľ֤ˤƤ饿λ롥
		 */
		syslog_0(LOG_WARNING,
			"ext_tsk is called from dispatch disabled state.");
		enadsp = TRUE;
	}

	/**
	 *  CPUå֤ޤϥǥѥåػ߾֤ext_tsk()ƤФȡ
	 *  terflgTRUEξ֤Ǥǽ롥
	 *  terflgTRUEξϲԤ鷺exit_and_distpatch()ƤӽФ
	 */   
	if (!(runtsk->terflg)) {
		make_non_runnable(runccb, runtsk);
		make_dormant(runtsk);
		if (runtsk->actcnt) {
			runtsk->actcnt = FALSE;
			make_active(runccb, runtsk);
		}		
	}
	RELEASE_LOCK(runccb->tsk_lock);
	exit_and_dispatch();
}

#endif /* __ext_tsk */

/**
 *  ζλ
 */
#ifdef __ter_tsk

SYSCALL ER
ter_tsk(ID tskid)
{
	TCB		*tcb;
	CCB		*ccb, *occb;
	UINT	tstat;
	ER		ercd;
   	BOOL	dspreq = FALSE;

	LOG_TER_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(tskid)); 
	ccb = t_get_ccb_self(get_clsid(tskid));    
	tskid = remove_clsid(tskid);
	CHECK_TSKID(ccb, tskid);
	tcb = get_tcb(ccb, tskid);
	CHECK_NONSELF(tcb);

  retry:	
	T_ACQUIRE_LOCK(ccb->tsk_lock);
	if (TSTAT_DORMANT(tstat = tcb->tstat)) {
		ercd = E_OBJ;
	}
	else {
		if (TSTAT_RUNNABLE(tstat)) {
			if (make_non_runnable(ccb, tcb)) {
				/*
				 * оݥ¾ץåΥRUNNABLEξ硤
				 * RUN֤βǽ뤿ᡤǥѥå׵Ф 
				 */
				assert(ccb != my_local_ccb);
				dspreq = TRUE;
			}
		}
		else if (TSTAT_WAITING(tstat)) {
			if ((tstat & TS_WAIT_WOBJCB) == 0) {
				wait_cancel(ccb, tcb);
			}
			else {				
				/*
                 * ֥Ԥξ
				 */
				/*
				 * 
				 * ǥåȥåΤᡤ٥å֤
				 * İʾter_tsk礷˰ʬ¹Ԥʤǽ
				 * 롥ǡ¾ter_tskȯԤƤ(pend_tertskTRUE)
				 * actcntΤߤԤ꥿󤹤롥
				 */ 
				if (tcb->pend_tertsk) {
					if (tcb->actcnt) {
						tcb->actcnt = FALSE;
						ercd = E_OK;
					}
					else {
						ercd = E_OBJ;
					}
					RELEASE_LOCK(ccb->tsk_lock);
					goto exit;
				}
				
				/*
				 * ǥåɥåԤ 
				 * ԤоݤˤʤäƤ륪֥ȤCCB
				 * λαե饰ΥåȤ顤
				 * ٥å(ץååϳʤ) 
				 */
                occb = get_ccb(((WINFO_WOBJ *)(tcb->winfo))->clsid);                
				tcb->pend_tertsk = TRUE;
				RELEASE_LOCK(ccb->tsk_lock);

				/*
				 * 餿
				 *   ֥ȥå -> å
				 * νǥå
				 */
				if (ACQUIRE_LOCK(occb->obj_lock)) {
					t_unlock_cpu();
					goto retry;
				}			
				T_ACQUIRE_NESTED_LOCK(ccb->tsk_lock, occb->obj_lock);

				/* ¾βսǽλʤ줿å */
				if (!(tcb->pend_tertsk)){
					/* ¾βսǽλʤ줿 */
					T_RELEASE_NESTED_LOCK(ccb->tsk_lock, occb->obj_lock);
					T_RELEASE_LOCK(occb->obj_lock);
					ercd = E_OK;
					goto exit;
				}				
				wait_cancel(ccb, tcb);
				RELEASE_LOCK(occb->obj_lock);
			}
		}		
		/*
		 * TCBơterflgTRUEˤ롥
		 */ 
		make_dormant(tcb);	   
		tcb->terflg = TRUE;
		if (tcb->actcnt) {
			tcb->actcnt = FALSE;
			if (make_active(ccb, tcb)) {
				dspreq = TRUE;
			}
		}
		if (dspreq){
			dspreq = dispatch_request(ccb->prcid);
		}		
		ercd = E_OK;
	}
	T_RELEASE_LOCK_AND_DISPATCH(ccb->tsk_lock, dspreq);

  exit:
	LOG_TER_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __ter_tsk */

/**
 *  ͥ٤ѹ
 */
#ifdef __chg_pri

SYSCALL ER
chg_pri(ID tskid, PRI tskpri)
{
   	CCB		*ccb, *occb;
	TCB		*tcb;  
	UINT	newpri;
	UINT	tstat;
	ER		ercd;
	BOOL	dspreq = FALSE;

	LOG_CHG_PRI_ENTER(tskid, tskpri);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(tskid)); 
	ccb = t_get_ccb_self(get_clsid(tskid));        
	tskid = remove_clsid(tskid);
	CHECK_TSKID_SELF(ccb, tskid);
	CHECK_TPRI_INI(tskpri);
	tcb = get_tcb_self(ccb, tskid);
	newpri = (tskpri == TPRI_INI) ? tcb->tinib->ipriority
					: INT_PRIORITY(tskpri);

  retry:
	T_ACQUIRE_LOCK(ccb->tsk_lock);
	if (TSTAT_DORMANT(tstat = tcb->tstat) || (tcb == runtsk && tcb->terflg)) {
		ercd = E_OBJ;
	}
	else if (TSTAT_RUNNABLE(tstat)) {
		if (change_priority(ccb, tcb, newpri)) {
			dspreq = dispatch_request(ccb->prcid);
		}
		ercd = E_OK;
	}
	else {
		if ((tstat & TS_WAIT_WOBJCB) == 0) {
			tcb->priority = newpri;
		}
		else {
			/*
			 * ֥Ԥξ硤ǥåɥåԤ
			 */
			
			/*
			 * ͥѹαåȤ
			 * ԤоݤˤʤäƤ륪֥ȤCCB顤
			 * ٥å(ץååϳʤ) 
			 */
			occb = get_ccb(((WINFO_WOBJ *)(tcb->winfo))->clsid);
			tcb->pend_chgpri = TRUE;
			tcb->pend_newpri = newpri;
			RELEASE_LOCK(ccb->tsk_lock);

			/*
			 * 餿
			 *   ֥ȥå -> å
			 * νǥå
			 */
			if (ACQUIRE_LOCK(occb->obj_lock)) {
				t_unlock_cpu();
				goto retry;
			}
			T_ACQUIRE_NESTED_LOCK(ccb->tsk_lock, occb->obj_lock);
			/* ξ֤ѲƤʤå */
			if (!(tcb->pend_chgpri)) {
				/* ¾βսͥѹʤ줿 */
				T_RELEASE_NESTED_LOCK(ccb->tsk_lock, occb->obj_lock);
				T_RELEASE_LOCK(occb->obj_lock);
				ercd = E_OK;
				goto exit;
			}
			tcb->priority = tcb->pend_newpri;
			tcb->pend_chgpri = FALSE;
			wobj_change_priority(((WINFO_WOBJ *)(tcb->winfo))
							 ->wobjcb, tcb);
			RELEASE_LOCK(occb->obj_lock);
		}
		ercd = E_OK;
	}
	T_RELEASE_LOCK_AND_DISPATCH(ccb->tsk_lock, dspreq);

  exit:
	LOG_CHG_PRI_LEAVE(ercd);
	return(ercd);
}

#endif /* __chg_pri */

/**
 *  ͥ٤λ
 */
#ifdef __get_pri

SYSCALL ER
get_pri(ID tskid, PRI *p_tskpri)
{
	CCB	*ccb;
	TCB	*tcb;
	ER	ercd;

	LOG_GET_PRI_ENTER(tskid, p_tskpri);
	CHECK_TSKCTX_UNL();
	CHECK_CLSID_SELF(get_clsid(tskid)); 
	ccb = t_get_ccb_self(get_clsid(tskid));    
	tskid = remove_clsid(tskid);
	CHECK_TSKID_SELF(ccb, tskid);
	tcb = get_tcb_self(ccb, tskid);

  retry:
	T_ACQUIRE_LOCK(ccb->tsk_lock);
	if (TSTAT_DORMANT(tcb->tstat) || (tcb == runtsk && tcb->terflg)) {
		ercd = E_OBJ;
	}
	else {
		*p_tskpri = EXT_TSKPRI(tcb->priority);
		ercd = E_OK;
	}
	T_RELEASE_LOCK(ccb->tsk_lock);

  exit:
	LOG_GET_PRI_LEAVE(ercd, *p_tskpri);
	return(ercd);
}

#endif /* __get_pri */
