/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel  
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcb.h,v 1.2 2006/03/13 07:21:58 honda Exp $
 */

/** \file
 *  TCBϢ
 *   MPȼTCBϢ task.h ʬΥ
 *
 *  MPˤѹ 
 *   TCB˰ʲΥȥɲ
 *     clsid        : 饹ID
 *     pend_chgpri	: ͥѹα(0ꥻå)
 *     pend_tertsk	: ζλα 
 *     terflg       : exit_and_dispatch׵
 */ 

#ifndef _TCB_H_
#define _TCB_H_

typedef struct task_control_block TCB;
typedef struct task_initialization_block TINIB;

#include "queue.h"
#include "time_event.h"

/*
 *  ͥ٤ɽɽѴޥ
 */
#define INT_PRIORITY(x)		((UINT)((x) - TMIN_TPRI))
#define EXT_TSKPRI(x)		((PRI)(x) + TMIN_TPRI)

/*
 *  ֤ɽ
 *
 *  TCB Υ֤Ǥϡ¹Ծ֡RUNNINGˤȼ¹Բǽ֡READY
 *  ϶̤ʤԤ֤ϡ(TS_WAITING | TS_SUSPENDED) ɽ
 *  TS_WAIT_???? ϡԤ֤ȼ°֤ɽԤ֡Ԥ
 *  ֤ޤˤξˤΤꤵ롥
 */
#define	TS_DORMANT		0x00u	/* ٻ߾ */
#define	TS_RUNNABLE		0x01u	/* ¹ԤǤ */
#define	TS_WAITING		0x02u	/* Ԥ */
#define	TS_SUSPENDED	0x04u	/* Ԥ */

#define	TS_WAIT_SLEEP	0x08u	/* Ԥ */
#define	TS_WAIT_WOBJ	0x10u	/* Ʊ֥̿ȤФԤ */
#define	TS_WAIT_WOBJCB	0x20u	/* ʬԤ塼ˤĤʤäƤ */

/*
 *  Ƚ̥ޥ
 *
 *  TSTAT_DORMANT ϥٻ߾֤Ǥ뤫ɤTSTAT_RUNNABLE 
 *  ϥ¹ԤǤ֤Ǥ뤫ɤȽ̤롥TSTAT_WAITING 
 *  Ԥ֤Ԥ֤Τ줫Ǥ뤫ɤTSTAT_SUSPENDED 
 *  ϶Ԥ֤Ԥ֤Τ줫Ǥ뤫ɤȽ̤롥
 */
#define TSTAT_DORMANT(tstat)	((tstat) == TS_DORMANT)
#define TSTAT_RUNNABLE(tstat)	(((tstat) & TS_RUNNABLE) != 0)
#define TSTAT_WAITING(tstat)	(((tstat) & TS_WAITING) != 0)
#define TSTAT_SUSPENDED(tstat)	(((tstat) & TS_SUSPENDED) != 0)

/**
 *  Ԥ֥åWINFOˤ
 *
 *  Ԥ֤δ֤ϡTCB Ӥؤ WINFO 򼡤Τ
 *  ꤷʤФʤʤ
 *
 *  (a) TCB Υ֤Ԥ֤ˤ롥κݤˡԤ֤ȼ°
 *  ֡TS_WAIT_????ˤꤹ롥
 *
 *  (b) ॢȤƻ뤹뤿ˡ।٥ȥ֥åϿ롥
 *  Ͽ륿।٥ȥ֥åϡԤ륵ӥؿ
 *  ΥѿȤƳݤؤΥݥ󥿤 WINFO  tmevtb 
 *  롥ॢȤδƻ뤬ɬפʤʱʵԤξˤˤϡ
 *  tmevtb  NULL ˤ롥
 *
 *  Ʊ֥̿ȤФԤ֤ξˤϡɸ WINFO  
 *  wobjcbեɤɲä¤ΡWINFO_WOBJwait.h ˤ
 *  ֤ TS_WAIT_WOBJ ꤹ롥ޤʲ (c)(e) 
 *  Ԥɬפ롥Ʊ֥̿Ȥ˴طʤԤʵ
 *  ԤַвԤˤξˤϡ(c)(e) ɬפʤ
 *
 *  (c) TCB ԤоݤƱ֥̿ȤԤ塼ˤĤʤ
 *  塼ˤĤʤˡtask_queue ȤTCB Ʊ֥̿
 *  Ȥδ֥åζʬWOBJCBˤԤ塼ˤĤʤ
 *  ϡ֤ TS_WAIT_WOBJCB ꤹ롥
 *
 *  (d) ԤоݤƱ֥̿Ȥδ֥åؤΥݥ󥿤
 *  WINFO_WOBJ  wobjcb ˵롥
 *  FDMPͥ wobjcb ȤΤϡͥٽԤ塼ˤĤʤ
 *  륿ͥ٤ѹ줿ΤߤǤ뤬ǥХå
 *  Ф䤹褦ˡԤ塼ͥٽǤʤˤ wobjcb 
 *  롥
 *
 *  (e) ԤоݤƱ֥̿Ȥ˰¸Ƶ뤳Ȥɬפ
 *  󤬤ˤϡWINFO_WOBJ ɬפʾΤΥեɤɲ
 *  ¤ΤWINFO_WOBJ Ѥ롥
 *
 *  Ԥ֤ݤˤϡԤͤ WINFO 
 *  wercd ꤹ롥wercd ȤΤԤʹߤǤΤФơ
 *  tmevtb ԤϻȤʤᡤΤ˶Ρunion
 *  ȤäƤ롥
 */
typedef union waiting_information {
	ER	wercd;		/* ԤΥ顼 */
	TMEVTB	*tmevtb;	/* ԤѤΥ।٥ȥ֥å */
} WINFO;

/**
 *  ֥å
 *
 *  ˴ؤͤѤʤROM֤ʬʥ
 *  ֥åˤȡͤѲ뤿RAM֤ʤФʤʤ
 *  ʬʥ֥åTCBˤʬΥTCBб륿
 *  ֥åؤݥ󥿤롥֥åб
 *  TCBؤݥ󥿤ˡRAMδ˾ޤ
 *  ¹ԸΨʤ뤿˺ѤƤʤ¾Υ֥ȤˤĤ
 *  ƤƱͤ˰
 *  ֥åˤϡDEF_TEX 륿㳰롼
 *  ˴ؤޤࡥ
 */
struct task_initialization_block {
	ATR	    tskatr;		/* ° */
	VP_INT	exinf;		/* γĥ */
	FP	    task;		/* εư */
	UINT	ipriority;	/* εưͥ١ɽ */
	SIZE	stksz;		/* åΰΥʴݤ᤿͡ */
	VP	    stk;		/* åΰƬ */

	ATR	texatr;		/* 㳰롼° */
	FP	texrtn;		/* 㳰롼εư */
};

/*
 *  TCB ΥեɤΥӥå
 *
 *  TCB Υեɤ֤ϡǽ礭ƶȻפ뤿ᡤ
 *  åȰ¸˥եɤΥӥåѹ뤳ȤƤ롥
 */
#ifndef TBIT_TCB_TSTAT
#define	TBIT_TCB_TSTAT		6	/* tstat եɤΥӥå */
#endif /* TBIT_TCB_TSTAT */

#ifndef TBIT_TCB_PRIORITY
#define	TBIT_TCB_PRIORITY	4	/* priority եɤΥӥå */
#endif /* TBIT_TCB_PRIORITY */

/**
 *  ֥åTCB
 *
 *  FDMPǤϡεư׵ᥭ塼󥰿κ͡TMAX_ACTCNTˤȵ
 *  ư׵ᥭ塼󥰿κ͡TMAX_WUPCNTˤ 1 ˸ꤵƤ뤿
 *  ᡤ塼󥰤Ƥ뤫ɤοͤɽ뤳ȤǤ롥
 *  ޤԤ׵ͥȿκ͡TMAX_SUSCNTˤ 1 ˸ꤵ
 *  ΤǡԤ׵ͥȿsuscntˤɬפʤ
 */
struct task_control_block {
	QUEUE	task_queue;	/* 塼 */
	const TINIB *tinib;	/* ֥åؤΥݥ */

	UINT	tstat : TBIT_TCB_TSTAT;		/* ֡ɽ*/
	UINT	priority : TBIT_TCB_PRIORITY;	/* ߤͥ١ɽ*/
	unsigned int	actcnt : 1;		/* ư׵ᥭ塼 */
	unsigned int	wupcnt : 1;		/* ׵ᥭ塼 */
	unsigned int	enatex : 1;		/* 㳰ľ */
	
	TEXPTN	texptn;			/* α㳰װ */
	WINFO	*winfo;			/* Ԥ֥åؤΥݥ */
	CTXB	tskctxb;		/* ƥȥ֥å */
	
	ID		clsid;			/* 饹ID */
	BOOL	pend_tertsk;	/* ζλα */
	BOOL	pend_chgpri;	/* ͥѹα */
	BOOL    pend_relwai;    /* Ԥα */
	BOOL	terflg;		 	/* exit_and_dispatch׵ */
	UINT    pend_newpri;    /* ͥѹαοͥ١ɽ*/
};

#endif /*_TCB_H_*/
