/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: time_event.c,v 1.4 2007/05/28 01:44:28 honda Exp $
 */

/** \file
 *	।٥ȴ⥸塼
 *
 *  MPˤѹ
 *   - ƴؿΰccbɲ
 */

#include "fdmp_kernel.h"
#include "check.h"
#include "class.h"
#include "time_event.h"


/*
 *  ।٥ȥҡޥ
 */
#define	PARENT(index)	((index) >> 1)		/* ƥΡɤ */
#define	LCHILD(index)	((index) << 1)		/* λҥΡɤ */
#define	TMEVT_NODE(ccb, index)	((ccb->p_tmevt_heap)[(index) - 1])

/*
 *  ٥ȯӥޥ
 *
 *  ٥ȯϡcurrent_time ͤӤ롥ʤ
 *  current_time Ǿ͡ʺǤᤤˡcurrent_time - 1 
 *  ʺǤ󤤻ˤȤߤʤӤ롥
 *  ץåʳΥ٥ȯϡоݥץå current_time
 *  Ѥɬפ뤿ᡤccbͳǥ롥
 *   
 */
#define	EVTTIM_LT(t1, t2, ccb) (((t1) - *(ccb->p_current_time)) < ((t2) - *(ccb->p_current_time)))
#define	EVTTIM_LE(t1, t2, ccb) (((t1) - *(ccb->p_current_time)) <= ((t2) - *(ccb->p_current_time)))

#ifdef __tmeini

/**
 *  ƥΥեå
 */
SYSTIM	systim_offset;

/**
 *  ߤΥƥñ: ߥá
 *
 *  ̩ˤϡΥƥåΥƥ
 */
SYSTIM	current_time;

/**
 *  ΥƥåΥƥñ: 1ߥá
 */
SYSTIM	next_time;

/*
 *  ƥѻѿñ: 1/TIM_DENOߥá
 */
#if TIC_DENO != 1
UINT	next_subtime;
#endif /* TIC_DENO != 1 */

/**
 *  ।٥ȥҡפκǸλΰΥǥå
 */
UINT	last_index;

/**
 *  ޥ⥸塼ν
 */

void
tmevt_initialize()
{
	systim_offset = 0;
	current_time = 0;
#if TIC_DENO == 1
	next_time = current_time + TIC_NUME;
#else /* TIC_DENO == 1 */
	next_subtime += TIC_NUME;
	next_time = current_time + next_subtime / TIC_DENO;
	next_subtime %= TIC_DENO;
#endif /* TIC_DENO == 1 */
	last_index = 0;

	my_local_exccb->p_tmevt_heap = &tmevt_heap[0];
	my_local_exccb->p_last_index = &last_index;
    my_local_exccb->p_current_time = &current_time;
    my_local_exccb->p_next_time = &next_time;
#if TIC_DENO != 1    
    my_local_exccb->p_next_subtime = &next_subtime;
#endif /* TIC_DENO != 1 */    
}

#endif /* __tmeini */

/**
 *  ।٥Ȥ֤õ
 *
 *   time ȯ륿।٥ȤΡɤ뤿ˡ
 *  ҡפξ˸äƶΡɤư롥ưζΡɤΰ֤ 
 *  index ϤȡưζΡɤΰ֡ʤʤ֡ˤ֤
 */
#ifdef __tmeup

UINT
tmevt_up(CCB *ccb, UINT index, EVTTIM time)
{
	UINT	parent;

	while (index > 1) {
		/*
		 *  ƥΡɤΥ٥ȯᤤʤޤƱ
		 *  ʤСindex ֤ʤΤǥ롼פȴ롥
		 */
		parent = PARENT(index);
		if (EVTTIM_LE(TMEVT_NODE(ccb, parent).time, time, ccb)) {
			break;
		}

		/*
		 *  ƥΡɤ index ΰ֤˰ư롥
		 */
		TMEVT_NODE(ccb, index) = TMEVT_NODE(ccb, parent);
		TMEVT_NODE(ccb, index).tmevtb->index = index;

		/*
		 *  index ƥΡɤΰ֤˹
		 */
		index = parent;
	}
	return(index);
}

#endif /* __tmeup */

/**
 *  ।٥Ȥ֤򲼸õ
 *
 *   time ȯ륿।٥ȤΡɤ뤿ˡ
 *  ҡפβ˸äƶΡɤư롥ưζΡɤΰ֤ 
 *  index ϤȡưζΡɤΰ֡ʤʤ֡ˤ֤
 */
#ifdef __tmedown

UINT
tmevt_down(CCB *ccb, UINT index, EVTTIM time)
{
	UINT	child;

	while ((child = LCHILD(index)) <= *ccb->p_last_index) {
		/*
		 *  λҥΡɤΥ٥ȯӤᤤ
		 *  ҥΡɤΰ֤ child ꤹ롥ʲλҥΡ
		 *  ϡФ줿λҥΡɤΤȡ
		 */
		if (child + 1 <= *ccb->p_last_index
			&& EVTTIM_LT(TMEVT_NODE(ccb, child + 1).time,
				  TMEVT_NODE(ccb, child).time, ccb)) {
			child = child + 1;
		}

		/*
		 *  ҥΡɤΥ٥ȯ٤ʤޤƱ
		 *  ʤСindex ֤ʤΤǥ롼פȴ롥
		 */
		if (EVTTIM_LE(time, TMEVT_NODE(ccb, child).time, ccb)) {
			break;
		}

		/*
		 *  ҥΡɤ index ΰ֤˰ư롥
		 */
		TMEVT_NODE(ccb, index) = TMEVT_NODE(ccb, child);
		TMEVT_NODE(ccb, index).tmevtb->index = index;

		/*
		 *  index ҥΡɤΰ֤˹
		 */
		index = child;
	}
	return(index);
}

#endif /* __tmedown */

/**
 * ।٥ȥҡפؤϿ
 *
 *  ।٥ȥ֥å tmevtb time ǻꤷ֤в˥
 *  ٥Ȥȯ褦ˡ।٥ȥҡפϿ롥
 */
#ifdef __tmeins

void
tmevtb_insert(CCB *ccb, TMEVTB *tmevtb, EVTTIM time)
{
	UINT	index;

	/*
	 *  last_index 򥤥󥯥Ȥ֤õ
	 */
	index = tmevt_up((CCB*)ccb, ++(*ccb->p_last_index), time);

	/*
	 *  ।٥Ȥ index ΰ֤롥
	 */
	TMEVT_NODE(ccb, index).time = time;
	TMEVT_NODE(ccb, index).tmevtb = tmevtb;
	tmevtb->index = index;
}

#endif /* __tmeins */

/**
 *  ।٥ȥҡפκ
 */
#ifdef __tmedel

void
tmevtb_delete(CCB *ccb, TMEVTB *tmevtb)
{
	UINT	index = tmevtb->index;
	UINT	parent;
	EVTTIM	event_time = TMEVT_NODE(ccb, *ccb->p_last_index).time;

	/*
	 *  ˤ꥿।٥ȥҡפˤʤϲ⤷ʤ
	 */
	if (--*ccb->p_last_index == 0) {
		return;
	}

	/*
	 *  Ρɤΰ֤˺ǸΥΡɡlast_index + 1 ΰ
	 *  ΥΡɡˤŬڤʰ֤ذư롥ºݤˤϡ
	 *  ǸΥΡɤºݤΤǤϤʤΡɤΰ
	 *  ֤ΡɤˤʤΤǡǸΥΡɤ٤֤ظ
	 *  ƶΡɤư롥
	 *  ǸΥΡɤΥ٥ȯ郎ΡɤοƥΡ
	 *  Υ٥ȯξˤϡ˸ä֤
	 *  õǤʤˤϡ˸äõ
	 */
	if (index > 1 && EVTTIM_LT(event_time,
				TMEVT_NODE(ccb, parent = PARENT(index)).time, ccb)) {
		/*
		 *  ƥΡɤ index ΰ֤˰ư롥
		 */
		TMEVT_NODE(ccb, index) = TMEVT_NODE(ccb, parent);
		TMEVT_NODE(ccb, index).tmevtb->index = index;

		/*
		 *  ΡɤοƥΡɤ˸ä֤
		 *  õ
		 */
		index = tmevt_up(ccb, parent, event_time);
	}
	else {
		/*
		 *  Ρɤ鲼˸ä֤õ
		 */
		index = tmevt_down(ccb, index, event_time);
	}

	/*
	 *  ǸΥΡɤ index ΰ֤롥
	 */
	TMEVT_NODE(ccb, index) = TMEVT_NODE(ccb, *ccb->p_last_index + 1);
	TMEVT_NODE(ccb, index).tmevtb->index = index;
}

#endif /* __tmedel */

/**
 *  ।٥ȥҡפƬΥΡɤκ
 */
Inline void
tmevtb_delete_top()
{
	UINT	index;
	EVTTIM	event_time = TMEVT_NODE(my_local_ccb, last_index).time;

	/*
	 *  ˤ꥿।٥ȥҡפˤʤϲ⤷ʤ
	 */
	if (--last_index == 0) {
		return;
	}

	/*
	 *  롼ȥΡɤ˺ǸΥΡɡlast_index + 1 ΰ֤ΥΡɡ
	 *  Ŭڤʰ֤ذư롥ºݤˤϡǸΥΡ
	 *  ɤºݤΤǤϤʤ롼ȥΡɤΡɤˤʤ
	 *  ΤǡǸΥΡɤ٤֤ظƶΡɤư
	 *  롥
	 */
	index = tmevt_down(my_local_ccb, 1, event_time);

	/*
	 *  ǸΥΡɤ index ΰ֤롥
	 */ 
	TMEVT_NODE(my_local_ccb, index) = TMEVT_NODE(my_local_ccb, last_index + 1);
	TMEVT_NODE(my_local_ccb, index).tmevtb->index = index;
}

/**
 *  ƥåζ
 *
 *  TIC_NUME < TIC_DENO λϡȤ鷺˻ιǤ뤬
 *  ɤɤߤ䤹ˤ뤿 #if ¿Ѥ򤱤Ƥ롥
 *
 */
#ifdef __isig_tim

SYSCALL ER
isig_tim()
{
	TMEVTB	*tmevtb;
	ER	ercd;
	
	LOG_ISIG_TIM_ENTER();
	CHECK_INTCTX_UNL();

  retry:	
	I_ACQUIRE_LOCK(my_local_ccb->tsk_lock);
	/*
	 *  next_time ꥤ٥ȯᤤʤޤƱ˥।
	 *  ٥Ȥ򡤥।٥ȥҡפХåؿ
	 *  ƤӽФ
	 */
	while (last_index > 0
		   && EVTTIM_LE(TMEVT_NODE(my_local_ccb, 1).time, next_time, my_local_ccb)) {
		tmevtb = TMEVT_NODE(my_local_ccb, 1).tmevtb;
		tmevtb_delete_top();
		(*(tmevtb->callback))(tmevtb->arg);
		
		/*
		 *  I_RELEASE_LOCK()ǳߤĤ뤿ᡤͥ
         *  ι⤤ߤդ롥
		 *  I_ACQUIRE_LOCK()Ǥϡretryǽ뤬ʤ
		 */
		I_RELEASE_LOCK(my_local_ccb->tsk_lock);
		I_ACQUIRE_LOCK(my_local_ccb->tsk_lock);
	}
	/*
	 *  current_time 򹹿롥
	 */
	current_time = next_time;

	/*
	 *  next_timenext_subtime 򹹿롥
	 */
#if TIC_DENO == 1
	next_time = current_time + TIC_NUME;
#else /* TIC_DENO == 1 */
	next_subtime += TIC_NUME;
	next_time = current_time + next_subtime / TIC_DENO;
	next_subtime %= TIC_DENO;
#endif /* TIC_DENO == 1 */
	I_RELEASE_LOCK(my_local_ccb->tsk_lock);
	ercd = E_OK;
	
  exit:
	LOG_ISIG_TIM_LEAVE(ercd);
	return(ercd);
}

#endif /* __isig_tim */
