/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: wait.c,v 1.4 2006/09/15 13:48:38 honda Exp $
 */

/** \file
 *	Ԥִ⥸塼
 */

#include "fdmp_kernel.h"
#include "wait.h"

/**
 *  Ԥ֤ؤΰܹԡʥॢȻ
 *
 *  оݤ˸ƤӽФ 
 */
#ifdef __waimake

void
make_wait_tmout(WINFO *winfo, TMEVTB *tmevtb, TMO tmout)
{
	make_non_runnable(runccb, runtsk);
	runtsk->winfo = winfo;
	if (tmout > 0) {
		winfo->tmevtb = tmevtb;
		tmevtb_enqueue(runccb, tmevtb, (RELTIM) tmout,
					   (CBACK) wait_tmout, (VP) runtsk);
	}
	else {
		assert(tmout == TMO_FEVR);
		winfo->tmevtb = NULL;
	}
}

#endif /* __waimake */

/**
 *  ԤΤΥ֤ι
 *
 *  tcb ǻꤵ륿Ԥ褦֤򹹿롥
 *  륿¹ԤǤ֤ˤʤϡǥ塼ˤĤʤ
 *  ޤǥѥåɬפʾˤ TRUE ֤
 *
 *  Ԥ֤ϡɬδؿƤӽФᡤǥåȥå
 *  ΤΥڥǥ󥰥ե饰ΥåޤȤƹԤ 
 */

Inline BOOL
make_non_wait(CCB *ccb, TCB *tcb)
{
	assert(TSTAT_WAITING(tcb->tstat));
	
	/* λαå */
	if (tcb->pend_tertsk) {
		/*
		 * TCBơterflgTRUEˤ롥
		 * pend_tertskmake_dormant()ǥꥢ 
		 */ 
		make_dormant(tcb);	   
		tcb->terflg = TRUE;
		if (tcb->actcnt) {
			tcb->actcnt = FALSE;
			if (make_active(ccb, tcb)) {
				return(TRUE);
			}
		}
		return(FALSE);
	}
	
	/* ͥѹե饰å */
	if (tcb->pend_chgpri) {
		tcb->priority = tcb->pend_newpri;
		/*  ͥѹե饰Υꥢ  */
		tcb->pend_chgpri = FALSE;
	}

	/* Ԥαꥢ */
	tcb->pend_relwai = FALSE;
	
	if (!(TSTAT_SUSPENDED(tcb->tstat))) {
		/*
		 *  Ԥ֤¹ԤǤ֤ؤ
		 */
		return(make_runnable(ccb, tcb));
	}
	else {
		/*
		 *  Ԥ֤鶯Ԥ֤ؤ
		 */
		tcb->tstat = TS_SUSPENDED;
		LOG_TSKSTAT(tcb);
		return(FALSE);
	}
}


/**
 *  Ԥ
 */
#ifdef __waicmp

BOOL
wait_complete(CCB *ccb, TCB *tcb)
{
	if (tcb->winfo->tmevtb != NULL) {
		tmevtb_dequeue(ccb, tcb->winfo->tmevtb);
	}
	tcb->winfo->wercd = E_OK;
	return(make_non_wait(ccb, tcb));
}

#endif /* __waicmp */

/**
 *  ॢȤȼԤ(Хå롼)
 *
 * 
 *  ҡפˤϼץåΥ³ʤ
 *  ܴؿ make_wait_tmout() ˤ꥿ҡפϿ쥿ॢ
 *  ˥ХåؿȤƸƤӽФ롥ΤᡤCPUå֤Ǹ
 *  ӽФ롥
 *  å -> ֥ȥåνǥå뤿ᡤǥå
 *  å롼롥ॢȽоݥƱץ
 *  åưƤΤǡоݥϤδ֤ư¾Υ֥
 *  Ԥˤʤ뤳ȤϤʤ
 *
 *
 */
#ifdef __waitmo

void
wait_tmout(TCB *tcb)
{
	CCB		*occb;
	
	assert(get_ccb(tcb->clsid) == my_local_ccb);

	if ((tcb->tstat & TS_WAIT_WOBJ) != 0) {
		/* ֥Ԥξ */
		occb = get_ccb(((WINFO_WOBJ *)tcb->winfo)->clsid);
		tcb->pend_relwai = TRUE;
		I_RELEASE_LOCK(my_local_ccb->tsk_lock);

		/*
		 *  餿
		 *	֥ȥå -> å
		 *  νǥå 
		 */
	  retry:
		I_ACQUIRE_LOCK(occb->obj_lock);
		I_ACQUIRE_NESTED_LOCK(my_local_ccb->tsk_lock, occb->obj_lock);
		
		/* ξ֤ѲƤʤå */
		if (!(tcb->pend_relwai)) {
			/* ¾βսԤʤ줿 */
			RELEASE_LOCK(occb->obj_lock);
			return;
		}
		tcb->pend_relwai = FALSE;
		queue_delete(&(tcb->task_queue));
		RELEASE_LOCK(occb->obj_lock);		
	}
	tcb->winfo->wercd = E_TMOUT;
	if (make_non_wait(my_local_ccb, tcb)) {
		reqflg = TRUE;
	}		
}

#endif /* __waitmo */

/**
 *  dly_tskΥॢȥХå롼
 */
#ifdef __waitmook

void
wait_tmout_ok(TCB *tcb)
{
	assert(get_ccb(tcb->clsid) == my_local_ccb);

	tcb->winfo->wercd = E_OK;
	if (make_non_wait(my_local_ccb, tcb)) {
		reqflg = TRUE;
	}
}

#endif /* __waitmook */

/**
 *  Ԥ֤ζ
 */
#ifdef __waican

void
wait_cancel(CCB *ccb, TCB *tcb)
{
	if (tcb->winfo->tmevtb != NULL) {
		tmevtb_dequeue((VP) ccb, tcb->winfo->tmevtb);
	}
	if ((tcb->tstat & TS_WAIT_WOBJ) != 0) {
		queue_delete(&(tcb->task_queue));
	}
}

#endif /* __waican */

/** 
 *  Ԥ֤ζ(for rel_wai(), irel_wai())
 */
#ifdef __wairel

BOOL
wait_release(CCB *ccb, TCB *tcb)
{
	wait_cancel(ccb, tcb);
	tcb->winfo->wercd = E_RLWAI;
	return(make_non_wait(ccb, tcb));
}

#endif /* __wairel */

/**
 *  ͥٽԤ塼ؤ
 */
Inline void
queue_insert_tpri(TCB *tcb, QUEUE *queue)
{
	QUEUE	*entry;
	UINT	priority = tcb->priority;

	for (entry = queue->next; entry != queue; entry = entry->next) {
		if (priority < ((TCB *) entry)->priority) {
			break;
		}
	}
	queue_insert_prev(entry, &(tcb->task_queue));
}


/**
 *  ¹ΥƱ֥̿ȤԤ塼ؤ
 */
Inline void
wobj_queue_insert(WOBJCB *wobjcb)
{
	if ((wobjcb->wobjinib->wobjatr & TA_TPRI) != 0) {
		queue_insert_tpri(runtsk, &(wobjcb->wait_queue));
	}
	else {
		queue_insert_prev(&(wobjcb->wait_queue),
					&(runtsk->task_queue));
	}
}


/**
 *  Ʊ֥̿ȤФԤ֤ؤΰܹ
 *  ccbԤоݤΥ֥ȤCCB 
 */
#ifdef __wobjwai

void
wobj_make_wait(ID clsid, WOBJCB *wobjcb, WINFO_WOBJ *winfo)
{
	runtsk->tstat = (TS_WAITING | TS_WAIT_WOBJ | TS_WAIT_WOBJCB);
	make_wait(&(winfo->winfo));
	wobj_queue_insert(wobjcb);
	winfo->clsid = clsid;
	winfo->wobjcb = wobjcb;
	LOG_TSKSTAT(runtsk);
}

#endif /* __wobjwai */

#ifdef __wobjwaitmo

void
wobj_make_wait_tmout(ID clsid, WOBJCB *wobjcb, WINFO_WOBJ *winfo,
					TMEVTB *tmevtb, TMO tmout)
{
	runtsk->tstat = (TS_WAITING | TS_WAIT_WOBJ | TS_WAIT_WOBJCB);
	make_wait_tmout(&(winfo->winfo), tmevtb, tmout);
	wobj_queue_insert(wobjcb);
	winfo->clsid = clsid;	
	winfo->wobjcb = wobjcb;
	LOG_TSKSTAT(runtsk);
}

#endif /* __wobjwaitmo */

/**
 *  ͥѹν
 */
#ifdef __wobjpri

void
wobj_change_priority(WOBJCB *wobjcb, TCB *tcb)
{
	if ((wobjcb->wobjinib->wobjatr & TA_TPRI) != 0) {
		queue_delete(&(tcb->task_queue));
		queue_insert_tpri(tcb, &(wobjcb->wait_queue));
	}
}

#endif /* __wobjpri */
